//map list in directory
class ListEntry
{
	public: 
		ListEntry *next;
		ListEntry *prev;

		char	*name;
		char	*key;
};

class NameEntry : public ListEntry
{
	public:
		
		NameEntry(char *szName, char *szKey)
		{
			name = new char[strlen(szName)+1];
			sprintf(name, "%s", szName);

			key = new char[strlen(szKey)+1];
			sprintf(key, "%s", szKey);

			next = NULL;
			prev = NULL;
		};

		~NameEntry()
		{
			delete name;
			delete key;
		};
};

class List
{
	public:
		List();
		~List();

		void next(){current = current->next;};
		void prev(){current = current->prev;};
		const char *current_name(){return current->name;};
		const char *current_key(){return current->key;};

		ListEntry * GetIndex(int index);
		int GetCount() {return count;}
		void SetCurrent(int index);
		int GetCurrentIndex();
		void BubbleSort();

		void random();

	protected:
		ListEntry *head;
		ListEntry *current;
		int count;
};

class MapList : public List
{
	public:
		MapList();
		~MapList();
		char * GetMapKey(char * name, int offset);

		void add(char * name);
		bool find(char * name);
		bool startswith(char letter);
		void printlist();
};

class SkinList : public List
{
	public:
		SkinList();
		~SkinList();
};

class AnnouncerList : public List
{
	public:
		AnnouncerList();
		~AnnouncerList();
};

/*
class MusicPlayList : public List
{
	public:
		MusicPlayList();
		~MusicPlayList();
};
*/

class MusicEntry : public ListEntry
{
	public:
		MusicEntry(char *szFile);
		~MusicEntry();

		char * GetMusic(int musicID);
		char * GetRandomMusic(int backgroundID);

		int		numsongsforbackground[MAXBACKGROUNDID];
		int		*songsforbackground[MAXBACKGROUNDID];
		int		nummusicfiles;
		char    **songfilenames;
};

class MusicList : public List
{
	public:
		MusicList();
		~MusicList();
		
		char * GetMusic(int musicID);
		void SetRandomMusic(int backgroundID);
		char * GetCurrentMusic();

		char * CurrentMusic;
};

