#ifndef _GAMEMODES_H
#define _GAMEMODES_H

//#define GAMEMODE_LAST 17


/*
  the game mode thingy is still not perfect, because when writing
  a new gamemode you are kind of concurring with the simpel deathmatch mode.

  alrady now what will be changed to eliminate that problem, but i
  don't want to do it now.

  i'll probably change that when adding multkill etc score awards...
  ..hmm.... bring me to another idea... the game mode has to keep track of the scores...
  ... hmm... maybe that causes too much problems... maybe not... hmmm... better think
  about that ;)
*/

enum GameModeType{game_mode_freeplay, game_mode_fraglimit, game_mode_timelimit, game_mode_coinlimit, game_mode_mariowar, game_mode_chicken, game_mode_tag, game_mode_fireball, game_mode_thwomp, game_mode_egglimit, game_mode_domination, game_mode_bobomb, game_mode_owned, game_mode_jail, game_mode_goomba, game_mode_race, game_mode_hammer, GAMEMODE_LAST};

//gamemode base class ( = endless play)
class CGameMode
{
	public:
        virtual ~CGameMode() {;};
		virtual void init(){chicken = NULL; winningteam = -1; gameover = false; gamemode = game_mode_freeplay; playedwarningsound = false;};		//called once when the game is started
		virtual void think(){;};	//called once a frame
		virtual void draw(){;};
		//called when a player stomps another player, after the p2p logic has run
		//returns true if the other was deleted
		virtual bool playerkilledplayer(CPlayer &inflictor, CPlayer &other)
		{
			//Penalize killing your team mates
			if(inflictor.teamID == other.teamID)
			{
				inflictor.score->score -= 2;
				if(inflictor.score->score < 0)
					inflictor.score->score = 0;
			}

			return false;
		};
		virtual bool playerkilledself(CPlayer &player){return false;};
		virtual void player1up(CPlayer &player){player.score->score++;};

		virtual char *getMenuString(char *buffer64){return "Free Play";};
		virtual void toggleoptions(){;};

		void transferbobombifneeded(CPlayer &inflictor, CPlayer &other);
		void displayplayertext();
		void playwarningsound();

		int winningteam;
		bool gameover;

		CPlayer *chicken;
		CPlayer *tagged;

		GameModeType getgamemode(){return gamemode;}
		GameModeType gamemode;

		bool playedwarningsound;
		int goal;

#ifdef _DEBUG
		virtual void setdebuggoal() {};
#endif
		
};



//Fraglimit
class CGM_DM_Fraglimit : public CGameMode
{
	public:
        virtual ~CGM_DM_Fraglimit() {;};
		CGM_DM_Fraglimit()
		{
			goal = 20;
			winningteam = -1;
			gameover = false;
			gamemode = game_mode_fraglimit;
		};
		virtual void init();
		virtual void think();
		bool playerkilledplayer(CPlayer &inflictor, CPlayer &other);
		bool playerkilledself(CPlayer &player);
		void player1up(CPlayer &player);
		virtual char *getMenuString(char *buffer64);
		virtual void toggleoptions();

#ifdef _DEBUG
		void setdebuggoal() {goal = 5;}
#endif
		
};


//Timelimit
class CGM_DM_Timelimit : public CGameMode
{
	public:
        virtual ~CGM_DM_Timelimit() {;};
		CGM_DM_Timelimit()
		{
			goal = 60;
			winningteam = -1;
			gameover = false;
			gamemode = game_mode_timelimit;
		};
		void init();
		void think();
		void draw();
		bool playerkilledplayer(CPlayer &inflictor, CPlayer &other);
		bool playerkilledself(CPlayer &player);
		void player1up(CPlayer &player);
		char *getMenuString(char *buffer64);
		void toggleoptions();

#ifdef _DEBUG
		void setdebuggoal() {goal = 30;}
#endif

	protected:
		int timeleft;
		int framesleft_persecond;
};


//mariowar classic
class CGM_MarioWar : public CGameMode
{
	public:
        virtual ~CGM_MarioWar() {;};
		CGM_MarioWar()
		{
			goal = 10;
			winningteam = -1;
			gameover = false;
			gamemode = game_mode_mariowar;
		};

		void init();
		virtual void think();
		bool playerkilledplayer(CPlayer &inflictor, CPlayer &other);
		bool playerkilledself(CPlayer &player);
		void player1up(CPlayer &player);
		virtual char *getMenuString(char *buffer64);
		void toggleoptions();

#ifdef _DEBUG
		void setdebuggoal() {goal = 5;}
#endif

};


//capture the chicken
class CGM_CaptureTheChicken : public CGameMode
{
		public:
        virtual ~CGM_CaptureTheChicken() {;};
		CGM_CaptureTheChicken();
		void init();
		void think();
		void draw();
		bool playerkilledplayer(CPlayer &inflictor, CPlayer &other);
		bool playerkilledself(CPlayer &player);
		void player1up(CPlayer &player);
		char *getMenuString(char *buffer64);
		void toggleoptions();

#ifdef _DEBUG
		void setdebuggoal() {goal = 100;}
#endif

};

class CGM_Tag : public CGameMode
{
		public:
        virtual ~CGM_Tag() {;};
		CGM_Tag();
		void init();
		void think();
		bool playerkilledplayer(CPlayer &inflictor, CPlayer &other);
		bool playerkilledself(CPlayer &player);
		void player1up(CPlayer &player);
		char *getMenuString(char *buffer64);
		void toggleoptions();

#ifdef _DEBUG
		void setdebuggoal() {goal = 100;}
#endif

};

class CGM_Coins : public CGameMode
{
		public:
        virtual ~CGM_Coins() {;};
		CGM_Coins()
		{
			goal = 20;
			winningteam = -1;
			gameover = false;
		};

		virtual void init();
		virtual void think();
		bool playerkilledplayer(CPlayer &inflictor, CPlayer &other);
		bool playerkilledself(CPlayer &player);
		void player1up(CPlayer &player);
		virtual char *getMenuString(char *buffer64);
		void toggleoptions();

#ifdef _DEBUG
		void setdebuggoal() {goal = 5;}
#endif

};

class CGM_Eggs : public CGameMode
{
		public:
        virtual ~CGM_Eggs() {;};
		CGM_Eggs()
		{
			goal = 20;
			winningteam = -1;
			gameover = false;
		};

		void init();
		void think();
		bool playerkilledplayer(CPlayer &inflictor, CPlayer &other);
		bool playerkilledself(CPlayer &player);
		void player1up(CPlayer &player);
		char *getMenuString(char *buffer64);
		void toggleoptions();

#ifdef _DEBUG
		void setdebuggoal() {goal = 5;}
#endif

};

//Just like frag limit, but firepower cards appear randomly
class CGM_Fireball : public CGM_DM_Fraglimit
{
	public:
        virtual ~CGM_Fireball() {;};
		CGM_Fireball();
		void init();
		void think();
		char *getMenuString(char *buffer64);

	private:
		int timer;
};

//Just like frag limit, but firepower cards appear randomly
class CGM_Hammer : public CGM_DM_Fraglimit
{
	public:
        virtual ~CGM_Hammer() {;};
		CGM_Hammer();
		void init();
		void think();
		char *getMenuString(char *buffer64);

	private:
		int timer;
};

class CGM_Thwomp : public CGM_MarioWar
{
	public:
        virtual ~CGM_Thwomp() {;};
		CGM_Thwomp();
		void init();
		void think();
		char *getMenuString(char *buffer64);

	protected:
		int timer;
		int ratetimer;
		int rate;
};

//Just like frag limit, but players can tranform into bob-omb
class CGM_Bobomb : public CGM_DM_Fraglimit
{
	public:
        virtual ~CGM_Bobomb() {;};
		CGM_Bobomb();
		void think();
		char *getMenuString(char *buffer64);

};

//Domination (capture the area blocks)
class CGM_Domination : public CGameMode
{
	public:
        virtual ~CGM_Domination() {;};
		CGM_Domination();
		void init();
		void think();
		bool playerkilledplayer(CPlayer &inflictor, CPlayer &other);
		bool playerkilledself(CPlayer &player);
		void player1up(CPlayer &player);
		char *getMenuString(char *buffer64);
		void toggleoptions();

#ifdef _DEBUG
		void setdebuggoal() {goal = 100;}
#endif

};

//Domination (capture the area blocks)
class CGM_Race : public CGameMode
{
	public:
        virtual ~CGM_Race() {;};
		CGM_Race();
		void init();
		void think();
		bool playerkilledplayer(CPlayer &inflictor, CPlayer &other);
		bool playerkilledself(CPlayer &player);
		void player1up(CPlayer &player);
		char *getMenuString(char *buffer64);
		void toggleoptions();
		int getNextGoal(int teamID) {return nextGoal[teamID];}
		void setNextGoal(int teamID);

#ifdef _DEBUG
		void setdebuggoal() {goal = 5;}
#endif

	protected:
		int nextGoal[4];
};

//Similar to frag limit, but players get bonus frags for the number of players they have "owned"
class CGM_Owned : public CGameMode
{
	public:
        virtual ~CGM_Owned() {;};
		CGM_Owned();
		void init();
		void think();
		bool playerkilledplayer(CPlayer &inflictor, CPlayer &other);
		bool playerkilledself(CPlayer &player);
		void player1up(CPlayer &player);
		char *getMenuString(char *buffer64);
		void toggleoptions();

#ifdef _DEBUG
		void setdebuggoal() {goal = 100;}
#endif

};

//Similar to frag limit but:
//When a player is killed by another player, they get a "jail" marker
//Jailed players move slowly
//Jailed players can be freed by teammates
//If all players on a team are jailed, bonus kill goes to other team
//Similar to frag limit, but players get bonus frags for the number of players they have "owned"
class CGM_Jail : public CGM_DM_Fraglimit
{
	public:
        virtual ~CGM_Jail() {;};
		CGM_Jail();
		bool playerkilledplayer(CPlayer &inflictor, CPlayer &other);
		void player1up(CPlayer &player);
		char *getMenuString(char *buffer64);
};

//Similar to coin mode but you have to smash the most goombas
class CGM_Goomba : public CGM_Coins
{
	public:
        virtual ~CGM_Goomba() {;};
		CGM_Goomba() : CGM_Coins() {};
		void init();
		void think();
		char *getMenuString(char *buffer64);

	private:
		int spawntimer;
};

#endif

