
#ifndef _GLOBAL_H
#define _GLOBAL_H

//----------------------------------------------------------------
// this file contains stuff that's needed by every part of smw
//----------------------------------------------------------------

#define TITLESTRING "Super Mario War"
#define VERSIONNUMBER "1.6"


#include <stdlib.h>	//srand/rand (maybe replace with an own version)
#include <string.h>


#include "gfx.h"

struct STextAward
{
	char			*name;
	gfxFont			*font;
	
	STextAward(char *nname, gfxFont *nfont) {name = nname; font = nfont;}
};

//------------- global definitions -------------


//----------------------------------------------------------------
// DON'T CHANGE THE ORDER xxx_R xxx_L xxx_R xxx_L !!!
//----------------------------------------------------------------
// because this is used to determine the direction the player was facing in the last frame
// if the last sprite was facing right (spr & 0x1) is 0
// because the last bit of every PGFX_[action]_R is 0
// the last bit of PGFX_[action]_L is 1
// IF YOU CHANGE THE ORDER OF THE PGFX_L/R STUFF THIS WON'T WORK!

// see CPlayer::draw() on how this is used

#define PGFX_STANDING_R	0
#define PGFX_STANDING_L	1
#define PGFX_RUNNING_R	2
#define PGFX_RUNNING_L	3
#define PGFX_JUMPING_R	4
#define PGFX_JUMPING_L	5
#define PGFX_STOPPING_R	6
#define PGFX_STOPPING_L	7
#define PGFX_DEADFLYING	8
#define PGFX_DEAD		9
//--------------------------
#define PGFX_LAST		10

#define PANNOUNCER_SOUND_LAST	12
#define PAWARD_LAST		9

#define PH				25		//Player height
#define PW				22		//Player width
#define HALFPH			12
#define HALFPW			11
#define PHOFFSET		4
#define PWOFFSET		5

#define VELMOVING		4.0f		//velocity (speed) for moving left, right
#define VELSLOWMOVING	2.2f		//velocity when slow down powerup is in effect
#define	VELMOVING_CHICKEN 2.9f		//speed of the chicken in the gamemode capturethechicken
#define VELMOVINGFRICTION 0.2f
#define VELMOVINGADD	0.5f
#define VELTURBOMOVING	5.5f
#define VELJUMP			9.0f		//velocity for jumping
#define VELSLOWJUMP		7.0f		//velocity for jumping when slow down powerup is in effect
#define VELTURBOJUMP	10.2f		//velocity for turbo jumping
#define VELPUSHBACK		5.0f
#define VELMAXBREAKBLOCK 3.0f
#define VELNOTEBLOCKBOUNCE 3.0f
#define VELNOTEBLOCKREPEL 5.0f
#define VELBLOCKBOUNCE  3.0f
#define VELBLOCKREPEL   3.0f
#define VELPOWERUPBOUNCE 8.1f
#define FIREBALLBOUNCE  5.0f
#define HAMMERTHROW     8.5f
#define VELAIRFRICTION  0.06f
#define VELSTOPJUMP     5.0f
#define BOUNCESTRENGTH  0.5f
#define TAGGEDBOOST    1.0f

#define	GRAVITATION		0.40f		//gravitation - 1 pixel per frame (too fast, will be changed somewhen (playerx,y -> float, grav: 0.xx))

#define MAXVELY			20

#define CRUNCHVELOCITY	2
#define CRUNCHAMOUNT	16


#define MAPWIDTH		20			//width of the map
#define MAPHEIGHT		15			//height of the map
#define MAPLAYERS		4			//number of layers the map has
#define TILESIZE		32			//size of the tiles, should be dynamically read
#define INTERACTBLOCKSETSIZE  6     //size of interaction block set
#define	MAXWARPS		32

#define MAXSPAWNAREAS   128
#define MAXDRAWAREAS   128

#define TILESETSIZE		300			//15*20 Tiles by 32 pixel in a 640*480 bmp
#define TILESETHEIGHT   15
#define TILESETWIDTH	20

#define MAXBACKGROUNDID	19

#define MAXEYECANDY		192
#define MAXINTERACTIONOBJECTS 128
#define CORPSESTAY		200

#define MENUSPACING     36

#define WAITTIME		16		//delay between frames (default:16)
#define MAXAWARDS       10
#define MINAWARDSNEEDED 3

#define MAXTOURNAMENTGAMES 10

#define ifsoundonplay(x) (game_values.sound ? x.play() : -1)
#define ifsoundonandreadyplay(x) (x.isready() && game_values.sound ? x.play() : -1)
#define ifsoundonplayloop(x,y) (game_values.sound ? x.playloop(y) : -1)
#define ifsoundonstop(x) (game_values.sound ? x.stop() : void(NULL))
#define ifsoundonpause(x) (game_values.sound ? x.pause() : void(NULL))
#define ifmusiconplay(x) (game_values.music ? x.play() : -1)

#define ABS(x) (x>0?x:-x)

#define TWO_PI 6.28318f
#define PI 3.14159f
#define THREE_HALF_PI 4.71238f
#define THREE_QUARTER_PI 2.35619f
#define HALF_PI 1.57079f
#define QUARTER_PI 0.78539f

//------------- data structures / selfmade include files -------------
#include "MapList.h"
#include "map.h"
#include "player.h"
#include "interactionobject.h"
#include "eyecandy.h"
#include "gamemodes.h"



//------------- global variables / etc -------------
//i know that using so much global variables is ugly, this will change somewhen

//gfx stuff
extern Uint8			*keystates;
extern SDL_Surface		*screen;		//for gfx
extern SDL_Surface		*blitdest;		//for gfx
extern int				x_shake;		//for shaking screen
extern int				y_shake;


extern CMap				map;
extern CPlayer			*list_players[4];
extern int				list_players_cnt;
extern bool				showscoreboard;
extern SScore			score[4];
extern int				respawn[4];
extern int				projectiles[4];
extern int				score_cnt;
extern int				controlkeys[4][6];
extern CInteractionObjectContainer interactionobjectsfront;
extern CInteractionObjectContainer interactionobjectsplayer;
extern CInteractionObjectContainer interactionobjectcollisionitems;
extern CInteractionObjectContainer interactionobjectblocks;
extern CEyecandyContainer eyecandyfront;
extern CEyecandyContainer eyecandyback;

#include "sfx.h"

extern STextAward		awards[PAWARD_LAST];
extern sfxSound			announcer[PANNOUNCER_SOUND_LAST];
extern sfxSound	        mip;
extern sfxSound	        deathsound;
extern sfxSound	        jump;
//extern sfxSound	        excellent;

extern int iInvincibleMusicChannel;
extern int iSlowdownMusicChannel;
extern int iHurryUpMusicChannel;
extern int iTournamentEndMusicChannel;
extern bool fResumeMusic;

extern sfxSound			invinciblemusic;
extern sfxSound			extraguysound;
extern sfxSound			sprout;
extern sfxSound			collectpowerup;
extern sfxSound			storepowerup;
extern sfxSound			breakblock;
extern sfxSound			bump;
extern sfxSound			coin;
extern sfxSound			fireball;
extern sfxSound			springjump;
extern sfxSound			timewarning;
extern sfxSound			hit;
extern sfxSound			chicken;
extern sfxSound			transform;
extern sfxSound			yoshi;
extern sfxSound			pause;
extern sfxSound			bobombsound;
extern sfxSound			areatag;
extern sfxSound			cannon;
extern sfxSound			burnup;
extern sfxSound			sfx_pipe;
extern sfxSound			thunder;
extern sfxSound			slowdownmusic;
extern sfxSound			storedpowerupsound;
extern sfxSound			kicksound;
extern sfxSound			racesound;
extern sfxSound			bulletbillsound;

extern sfxMusic			backgroundmusic[5];

extern gfxSprite		spr_noteblock;
extern gfxSprite		spr_breakableblock;
extern gfxSprite		spr_powerupblock;
extern gfxSprite		spr_donutblock;
extern gfxSprite		spr_flipblock;
extern gfxSprite		spr_bounceblock;

extern gfxSprite		spr_starpowerup;
extern gfxSprite		spr_1uppowerup;
extern gfxSprite		spr_firepowerup;
extern gfxSprite		spr_hammerpowerup;
extern gfxSprite		spr_poisonpowerup;
extern gfxSprite		spr_clockpowerup;
extern gfxSprite		spr_bobombpowerup;
extern gfxSprite		spr_powpowerup;
extern gfxSprite		spr_bulletbillpowerup;

extern gfxSprite		spr_shade[3];
extern gfxSprite		spr_spawneggs;
extern gfxSprite		spr_crown;
extern gfxSprite		spr_warplock;

extern gfxSprite		spr_egg;
extern gfxSprite		spr_yoshi;
extern gfxSprite		spr_coin;
extern gfxSprite		spr_thwomp;
extern gfxSprite		spr_areas;
extern gfxSprite		spr_jail;
extern gfxSprite		spr_goomba;
extern gfxSprite		spr_goombadead;
extern gfxSprite		spr_goombadeadflying;
extern gfxSprite		spr_bulletbill;
extern gfxSprite		spr_bulletbilldeadflyingleft;
extern gfxSprite		spr_bulletbilldeadflyingright;
extern gfxSprite		spr_chicken;
extern gfxSprite		spr_racegoal;
extern gfxSprite		spr_racegoalnumbers;

extern gfxSprite		spr_bobombcard;
extern gfxSprite		spr_fireflowercard;
extern gfxSprite		spr_hammercard;

extern gfxSprite		spr_fireball;
extern gfxSprite		spr_hammer;

extern gfxSprite		spr_fireballexplosion;
extern gfxSprite		spr_frictionsmoke;
extern gfxSprite		spr_explosion;
extern gfxSprite		spr_burnup;
extern gfxSprite		spr_spawnsmoke[4];
extern gfxSprite		spr_spawndoor[4];
extern gfxSprite		spr_bonus[4];
extern gfxSprite		spr_award;
extern gfxSprite		spr_awardsolid;
extern gfxSprite		spr_awardsouls;
extern gfxSprite		spr_awardsoulspawn;
extern gfxSprite		spr_awardkillsinrow[4];
extern gfxSprite		spr_owned[4];
extern gfxSprite		spr_keys[5];

extern gfxSprite		spr_storedpowerupsmall;
extern gfxSprite		spr_storedpoweruplarge;
extern gfxSprite		spr_powerupselector;

extern gfxSprite		spr_scoreboard;
extern gfxSprite		spr_abovearrows;

#ifndef _SMW_EDITOR
extern gfxFont          font[3];
#endif

//stupid, i know
extern gfxSprite		** spr_player[4];	//all player sprites (see global.h)
extern gfxSprite		** spr_chocobo[4];
extern gfxSprite		** spr_bobomb[4];
extern gfxSprite		spr_clouds[2];
extern gfxSprite		spr_ghosts[3];
extern gfxSprite		spr_brokenBlock[4];
extern gfxSprite		spr_background;
extern gfxSprite		spr_backmap;
extern gfxSprite		spr_frontmap;
extern gfxSprite		menu_backdrop;

extern gfxSprite		menu_shade;
extern gfxSprite		menu_smw;
extern gfxSprite		menu_version;
extern gfxSprite		menu_mario;
extern gfxSprite		menu_cpu;
extern gfxSprite		menu_itembackground;
extern gfxSprite		menu_stoneborder;
extern gfxSprite		menu_slider_bar;
extern gfxSprite		menu_mode;
extern gfxSprite		game_mode;
extern gfxSprite		spr_dialog;
extern gfxSprite		spr_dialogbutton;
extern gfxSprite		spr_tournament_background;
extern gfxSprite		spr_tournament_powerup_splash;
extern gfxSprite		spr_player_select_background;

extern sfxSound mip;
extern sfxSound deathsound;
extern sfxSound jump;

extern MapList maplist;
extern SkinList skinlist;
extern AnnouncerList announcerlist;
//extern MusicPlayList musicplaylist;
extern MusicList musiclist;

extern CGameMode	*gamemodes[GAMEMODE_LAST];
extern int			currentgamemode;

extern float CapVelocity(float vel);

//----------------- game options all parts of the game need -----------
enum gs{GS_MENU, GS_GAME, GS_QUIT, GS_SCOREBOARD, GS_BONUS};
enum MenuID {menu_id_main = 0, menu_id_tournament = 1, menu_id_bonus = 2};

struct ps
{
	int selectoranimation;
	int selectoranimationcounter;
	float selectionspeed;
	float selectionangle;
	int selectedpowerup;
};

struct gv
{
	//int			players;
	int			playercontrol[4];
	bool		showfps;
	bool		frameadvance;
	
	bool		sound;
	bool		music;

	int			soundvolume;
	int			musicvolume;

	bool		NUMmousecontrol;
	bool		fullscreen;
	gs			gamestate;
    float		screenResizeX;
	float		screenResizeY;
	float		screenResizeW;
	float		screenResizeH;
	CGameMode	*gamemode;

	int			spawnstyle;
	int			awardstyle;

	bool		spawninvincibility;

	bool		pausegame;
	bool		exitinggame;
	bool		exityes;
	
	int			tournamentgames;
	bool		tournament;
	int			tournamentwinner;
	bool		powerupselectdone;
	ps			powerupselector; 

	int			slowdownon;
	int			slowdowncounter;

	int			storedpowerups[4];
	int			gamepowerups[4];

	int			teamids[4][3];
	int			teamcounts[4];
	int			skinids[4];
	int			colorids[4];

	bool		screencrunch;
	int			screenshaketimer;
	CPlayer *	screenshakeplayer;

	int			bulletbilltimer;

	bool		friendlyfire;
	bool		toplayer;
	int			scoreboardstyle;
	bool		teamcolors;

	int			loadedannouncer;
	int			loadedmusic;

	int			teamdeadcounter;

	int			respawn;

	int			cputurn;
};

extern gv game_values;

struct ts
{
	int			wins;
	int			type[MAXTOURNAMENTGAMES];
};

extern ts tournament_scores[4];

#endif

