/*----------------------------------------------------------+
| Super Mario War Leveleditor								|
|															|
| based on the jnrdev #1/#2 level editor					|
|															|
| ...a big bunch of crappy code ;)							|
| ...with some improvements									|
|															|
|															|
| this sourcecode is released under the GPL.				|
|															|
| start:		18.12.2003									|
| last changes:	20.02.2004									|
| save/load added 03.7.2004 by Armen - thanks!				|
| blocks/maplist/2-layers/extended tile set added 15.07.2005|
|                                                  by Two52 |
|															|
|				 2004 Florian Hufsky <fhufsky@phorus.at>	|
+----------------------------------------------------------*/

#define _SMW_EDITOR
#include "global.h"
#include <string.h>
#include <ctype.h>

#ifdef _WIN32
    #ifndef _XBOX
        #include <windows.h>
    #endif
#endif

#define MAPTITLESTRING "SMW 1.6 Leveleditor"

#define EDITOR_EDIT 0
#define EDITOR_TILES 1
#define EDITOR_QUIT 2
#define SAVE_AS 3
#define FIND 4
#define CLEAR_MAP 5
#define EDITOR_BLOCKS 6
#define NEW_MAP 7
#define SAVE 8
#define EDITOR_WARP 9
#define EDITOR_EYECANDY 10
#define DISPLAY_HELP 11

class MapTile
{
	public:
		int			tile[MAPLAYERS];
		int			block;
		Warp		warp;
		bool		nospawn;
};

SDL_Surface		*screen;
SDL_Surface		*blitdest;
SDL_Event		event;

gfxSprite		spr_background;
gfxSprite		spr_frontmap;
gfxSprite		spr_tiletypes[6];
gfxSprite		spr_backgroundlevel;
gfxFont			font;
gfxFont			fontbig;
gfxSprite		spr_selectedtile;
gfxSprite		spr_nospawntile;
gfxSprite		spr_dialog;
gfxSprite		menu_shade;

TileType		set_type = tile_solid;
int				set_tile = 0;
int				set_block = 0;

int				set_direction = 0;
int				set_connection = 0;

int				edit_mode = 1;
int				selected_layer = 0;

int				move_mode = 0;
int				move_start_x = 0;
int				move_start_y = 0;
int				move_offset_x = 0;
int				move_offset_y = 0;
bool			move_nodrag = false;

int				move_drag_start_x = 0;
int				move_drag_start_y = 0;
int				move_drag_offset_x = 0;
int				move_drag_offset_y = 0;

CMap			map;
int				state;
bool			selectedtiles[MAPWIDTH][MAPHEIGHT];
bool			moveselectedtiles[MAPWIDTH][MAPHEIGHT];
MapTile			copiedtiles[MAPWIDTH][MAPHEIGHT];
int				copiedlayer;

//externals the map needs but aren't used in the level editor
gfxSprite		spr_warplock;
gfxSprite		spr_noteblock;
gfxSprite		spr_breakableblock;
gfxSprite		spr_powerupblock;
gfxSprite		spr_donutblock;
gfxSprite		spr_flipblock;
gfxSprite		spr_bounceblock;

int	x_shake = 0;
int	y_shake = 0;

char *convertPath(char *source)
{
	return source;
}

//////////////////////////////////////////



SDL_Surface * s_flipblock;
SDL_Surface * s_donutblock;
SDL_Surface * s_noteblock;
SDL_Surface * s_breakableblock;
SDL_Surface * s_powerupblock;
SDL_Surface * s_bounceblock;
SDL_Surface * s_warp;
SDL_Surface * s_eyecandy;
SDL_Surface * s_eyecandyindicator;

int save_as();
int find();
int clearMap();
bool dialog(char * title, char * instructions, char * input, int inputsize);
int display_help();

#ifdef _DEBUG
	void convertAll();
#endif

void drawmap();

MapList maplist;
void loadcurrentmap();
int savecurrentmap();
int findcurrentstring();
int newmap();

int editor_edit();
int editor_warp();
int editor_eyecandy();
int	editor_tiles();
int editor_blocks();

void resetselectedtiles();
void copymoveselection();
void pastemoveselection(int movex, int movey);
bool copyselectedtiles();
void clearselectedmaptiles();
void pasteselectedtiles(int movex, int movey);
void getcenterselection(int * x, int * y);

bool viewblocks = true;
bool view_only_layer = false;
bool viewwarps = true;
bool ignoreclick = false;

char findstring[64] = "";

//main main main
int main(int argc, char *argv[])
{
	bool done;

	printf("-------------------------------------------------------------------------------\n");
	printf(" %s\n", MAPTITLESTRING);
	printf("-------------------------------------------------------------------------------\n");
	printf("\n---------------- startup ----------------\n");

	gfx_init(640,480, false);
	blitdest = screen;

	SDL_WM_SetCaption(MAPTITLESTRING, "leveleditor.ico");

	printf("\n---------------- loading graphics ----------------\n");

	spr_tiletypes[0].init("gfx/leveleditor/leveleditor_solid.bmp");
	spr_tiletypes[1].init("gfx/leveleditor/leveleditor_solid_on_top.bmp");
	spr_tiletypes[2].init("gfx/leveleditor/leveleditor_ice.bmp");
	spr_tiletypes[3].init("gfx/leveleditor/leveleditor_deadly.bmp");
	spr_tiletypes[4].init("gfx/leveleditor/leveleditor_death_on_top.bmp");
	spr_tiletypes[5].init("gfx/leveleditor/leveleditor_death_on_bottom.bmp");

	spr_backgroundlevel.init("gfx/leveleditor/leveleditor_background_levels.bmp", 255, 0, 255);
	
	s_bounceblock = SDL_LoadBMP("gfx/blocks/bounceblock.bmp");
	s_flipblock = SDL_LoadBMP("gfx/blocks/flipblock.bmp");
	s_donutblock = SDL_LoadBMP("gfx/blocks/donutblock.bmp");
	s_noteblock = SDL_LoadBMP("gfx/blocks/noteblock.bmp");
	s_breakableblock = SDL_LoadBMP("gfx/blocks/breakableblock.bmp");
	s_powerupblock = SDL_LoadBMP("gfx/blocks/powerupblock.bmp");
	s_warp = SDL_LoadBMP("gfx/leveleditor/leveleditor_warp.bmp");
	s_eyecandy = SDL_LoadBMP("gfx/leveleditor/leveleditor_eyecandy.bmp");
	s_eyecandyindicator = SDL_LoadBMP("gfx/leveleditor/leveleditor_eyecandyindicator.bmp");

	spr_selectedtile.init("gfx/leveleditor/leveleditor_selectedtile.bmp", 0, 0, 0, 128);
	spr_nospawntile.init("gfx/leveleditor/leveleditor_nospawntile.bmp", 0, 0, 0, 128);
	spr_dialog.init("gfx/menu/dialog.bmp", 255, 0, 255, 255);
	menu_shade.init("gfx/menu/menu_shade.bmp", 255, 0, 255, 128);

	if( SDL_SetColorKey(s_bounceblock, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(s_bounceblock->format, 255, 0, 255)) < 0)
	{
		printf("\n ERROR: Couldn't set ColorKey + RLE: %s\n", SDL_GetError());
	}

	if( SDL_SetColorKey(s_flipblock, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(s_flipblock->format, 255, 0, 255)) < 0)
	{
		printf("\n ERROR: Couldn't set ColorKey + RLE: %s\n", SDL_GetError());
	}
	
	if( SDL_SetColorKey(s_donutblock, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(s_donutblock->format, 255, 0, 255)) < 0)
	{
		printf("\n ERROR: Couldn't set ColorKey + RLE: %s\n", SDL_GetError());
	}

	if( SDL_SetColorKey(s_noteblock, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(s_noteblock->format, 255, 0, 255)) < 0)
	{
		printf("\n ERROR: Couldn't set ColorKey + RLE: %s\n", SDL_GetError());
	}

	if( SDL_SetColorKey(s_breakableblock, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(s_breakableblock->format, 255, 0, 255)) < 0)
	{
		printf("\n ERROR: Couldn't set ColorKey + RLE: %s\n", SDL_GetError());
	}

	if( SDL_SetColorKey(s_powerupblock, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(s_powerupblock->format, 255, 0, 255)) < 0)
	{
		printf("\n ERROR: Couldn't set ColorKey + RLE: %s\n", SDL_GetError());
	}
	
	if( SDL_SetColorKey(s_warp, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(s_powerupblock->format, 255, 0, 255)) < 0)
	{
		printf("\n ERROR: Couldn't set ColorKey + RLE: %s\n", SDL_GetError());
	}

	if( SDL_SetColorKey(s_eyecandy, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(s_powerupblock->format, 255, 0, 255)) < 0)
	{
		printf("\n ERROR: Couldn't set ColorKey + RLE: %s\n", SDL_GetError());
	}

	if( SDL_SetColorKey(s_eyecandyindicator, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(s_powerupblock->format, 255, 0, 255)) < 0)
	{
		printf("\n ERROR: Couldn't set ColorKey + RLE: %s\n", SDL_GetError());
	}

	font.init("gfx/fonts/font0.bmp");
	fontbig.init("gfx/fonts/font2.bmp");

	printf("\n---------------- load map ----------------\n");

	map.loadTileSet("maps/tileset.tls", "gfx/tileset.bmp");
	
	loadcurrentmap();
	
	printf("\n---------------- ready, steady, go! ----------------\n");

	resetselectedtiles();

	printf("entering level editor loop...\n");
	done = false;
	while(!done)
	{
		switch(state)
		{
			case EDITOR_EDIT:
				move_nodrag = false;
				state = editor_edit();
			break;

			case EDITOR_TILES:
				state = editor_tiles();
			break;

			case EDITOR_BLOCKS:
				state = editor_blocks();
			break;

			case EDITOR_WARP:
				state = editor_warp();
			break;

			case EDITOR_EYECANDY:
				state = editor_eyecandy();
			break;

			case EDITOR_QUIT:
				done = true;
			break;

			case DISPLAY_HELP:
				state = display_help();
			break;

			case SAVE_AS:
				state = save_as();
			break;

			case FIND:
				state = find();
			break;

			case CLEAR_MAP:
				state = clearMap();
			break;

			case NEW_MAP:
				state = newmap();
			break;

			case SAVE:
				state = savecurrentmap();
			break;

			default:
				printf(" PANIC: WEIRD GAMESTATE: %d\n", state);
			break;
		}
	}



	printf("\n---------------- save map ----------------\n");

	map.saveMap("maps/ZZleveleditor.map");
	map.saveTileSet("maps/tileset.tls");


	printf("\n---------------- shutdown ----------------\n");
	return 0;
}



int editor_edit()
{
	bool done = false;

	while (!done)
	{
		int framestart = SDL_GetTicks();

		//handle messages
		while(SDL_PollEvent(&event))
		{
			Uint8 * keystate = SDL_GetKeyState(NULL);

			switch(event.type)
			{
				case SDL_QUIT:
					done = true;
				break;

				case SDL_KEYDOWN:
					if(event.key.keysym.sym == SDLK_ESCAPE)
						done = true;

					if(event.key.keysym.sym == SDLK_t)
						return EDITOR_TILES;

					if(event.key.keysym.sym == SDLK_i)
						return EDITOR_BLOCKS;

					//if 'B' is pressed, rotate backgrounds
					if(event.key.keysym.sym == SDLK_b)
					{
						if(++map.backgroundID >= MAXBACKGROUNDID)
							map.backgroundID = 0;

						char filename[128];
						sprintf(filename, "gfx/backgrounds/bg%d.bmp", map.backgroundID);
						spr_background.init(filename);
					}
					
					if(event.key.keysym.sym == SDLK_s )
					{
						if(keystate[SDLK_LSHIFT] || keystate[SDLK_RSHIFT])
							return SAVE_AS;

						return SAVE;
					}

					if(event.key.keysym.sym == SDLK_f )
					{
						if(keystate[SDLK_LSHIFT] || keystate[SDLK_RSHIFT] || findstring[0] == '\0')
							return FIND;

						findcurrentstring();
					}

					if(event.key.keysym.sym == SDLK_DELETE && (keystate[SDLK_LCTRL] || keystate[SDLK_RCTRL]))
					{
						return CLEAR_MAP;
					}

					if(event.key.keysym.sym == SDLK_DELETE || event.key.keysym.sym == SDLK_BACKSPACE)
					{
						clearselectedmaptiles();
						resetselectedtiles();
					}

					if(event.key.keysym.sym == SDLK_n)
						return NEW_MAP;

					if(event.key.keysym.sym == SDLK_v)
						viewblocks = !viewblocks;
					
					if(event.key.keysym.sym == SDLK_e)
						return EDITOR_EYECANDY;
					
					if(event.key.keysym.sym == SDLK_w)
						return EDITOR_WARP;

					if(event.key.keysym.sym == SDLK_h || event.key.keysym.sym == SDLK_F1)
						return DISPLAY_HELP;

					if(event.key.keysym.sym == SDLK_PAGEUP)
					{
						maplist.prev();
						loadcurrentmap();
					}

					if(event.key.keysym.sym == SDLK_PAGEDOWN)
					{
						maplist.next();
						loadcurrentmap();
					}

					if(event.key.keysym.sym == SDLK_y)
					{
						if(++selected_layer >= MAPLAYERS)
							selected_layer = 0;
					}

					if(event.key.keysym.sym == SDLK_u)
					{
						view_only_layer = !view_only_layer;
					}

#ifdef _DEBUG
					if(event.key.keysym.sym == SDLK_p)
						convertAll();
#endif

					if(event.key.keysym.sym == SDLK_o)
						map.optimize();

					if(event.key.keysym.sym == SDLK_m)
						edit_mode = 3;

					if(event.key.keysym.sym == SDLK_x)
						edit_mode = 4;

					if(event.key.keysym.sym == SDLK_LCTRL)
						move_nodrag = true;

					if(event.key.keysym.sym == SDLK_c)
					{
						if(edit_mode == 3)
						{
							if(copyselectedtiles())
							{
								move_mode = 3;
								getcenterselection(&move_start_x, &move_start_y);
							}
						}
					}


				break;

				case SDL_KEYUP:
					if(event.key.keysym.sym == SDLK_LCTRL)
						move_nodrag = false;
					break;

				case SDL_MOUSEBUTTONDOWN:
					if(event.button.button == SDL_BUTTON_LEFT && !ignoreclick)
					{
						if(edit_mode == 0)
							map.interactionobjectdata[event.button.x / TILESIZE][event.button.y / TILESIZE] = set_block;
						else if(edit_mode == 1)
							map.mapdata[event.button.x / TILESIZE][event.button.y / TILESIZE][selected_layer] = set_tile;
						else if(edit_mode == 2)
						{
							map.warpdata[event.button.x / TILESIZE][event.button.y / TILESIZE].direction = set_direction;
							map.warpdata[event.button.x / TILESIZE][event.button.y / TILESIZE].connection = set_connection;
						}
						else if(edit_mode == 3)
						{
							if(move_mode == 3)
							{
								move_mode = 0;

								pasteselectedtiles(move_offset_x, move_offset_y);

								copymoveselection();
								resetselectedtiles();
								pastemoveselection(move_offset_x, move_offset_y);

								move_offset_x = 0;
								move_offset_y = 0;
							}
							else
							{
								if(selectedtiles[event.button.x / TILESIZE][event.button.y / TILESIZE])
								{	
									if(copyselectedtiles())
									{
										move_mode = 1;
										clearselectedmaptiles();
									}
								}
								else
								{
									if(!keystate[SDLK_LSHIFT] && !keystate[SDLK_RSHIFT] && !keystate[SDLK_LCTRL])
										resetselectedtiles();

									if(move_nodrag)
									{
										selectedtiles[event.button.x / TILESIZE][event.button.y / TILESIZE] = true;
									}
									else
									{
										move_mode = 2;
										move_drag_start_x = event.button.x / TILESIZE;
										move_drag_start_y = event.button.y / TILESIZE;
									}
								}

								move_start_x = event.button.x / TILESIZE;
								move_start_y = event.button.y / TILESIZE;
							}
						}
						else if(edit_mode == 4)
						{
							map.nospawn[event.button.x / TILESIZE][event.button.y / TILESIZE] = true;
						}
					}
					else if(event.button.button == SDL_BUTTON_RIGHT)
					{
						if(edit_mode == 0)
							map.interactionobjectdata[event.button.x / TILESIZE][event.button.y / TILESIZE] = INTERACTBLOCKSETSIZE;
						else if(edit_mode == 1)
                            map.mapdata[event.button.x / TILESIZE][event.button.y / TILESIZE][selected_layer] = TILESETSIZE;
						else if(edit_mode == 2)
						{
							map.warpdata[event.button.x / TILESIZE][event.button.y / TILESIZE].direction = -1;
							map.warpdata[event.button.x / TILESIZE][event.button.y / TILESIZE].connection = -1;
						}
						else if(edit_mode == 3)
						{
							if(move_mode == 3)
							{
								move_mode = 0;
								resetselectedtiles();
								move_offset_x = 0;
								move_offset_y = 0;
							}
							else
							{
								if(selectedtiles[event.button.x / TILESIZE][event.button.y / TILESIZE])
								{
									selectedtiles[event.button.x / TILESIZE][event.button.y / TILESIZE] = false;
								}
								else
								{
									resetselectedtiles();
								}
							}
						}
						else if(edit_mode == 4)
						{
							map.nospawn[event.button.x / TILESIZE][event.button.y / TILESIZE] = false;
						}
					}
				break;

				case SDL_MOUSEMOTION:
					if(event.motion.state == SDL_BUTTON(SDL_BUTTON_LEFT) && !ignoreclick)
					{
						if(edit_mode == 0)
							map.interactionobjectdata[event.button.x / TILESIZE][event.button.y / TILESIZE] = set_block;
						else if(edit_mode == 1)
							map.mapdata[event.button.x / TILESIZE][event.button.y / TILESIZE][selected_layer] = set_tile;
						else if(edit_mode == 2)
						{
							map.warpdata[event.button.x / TILESIZE][event.button.y / TILESIZE].direction = set_direction;
							map.warpdata[event.button.x / TILESIZE][event.button.y / TILESIZE].connection = set_connection;
						}
						else if(edit_mode == 3)
						{
							if(move_mode == 0)
							{
								selectedtiles[event.button.x / TILESIZE][event.button.y / TILESIZE] = true;
							}
						}
						else if(edit_mode == 4)
						{
							map.nospawn[event.button.x / TILESIZE][event.button.y / TILESIZE] = true;
						}
					}
					else if(event.motion.state == SDL_BUTTON(SDL_BUTTON_RIGHT))
					{
						if(edit_mode == 0)
							map.interactionobjectdata[event.button.x / TILESIZE][event.button.y / TILESIZE] = INTERACTBLOCKSETSIZE;
						else if(edit_mode == 1)
                            map.mapdata[event.button.x / TILESIZE][event.button.y / TILESIZE][selected_layer] = TILESETSIZE;
						else if(edit_mode == 2)
						{
							map.warpdata[event.button.x / TILESIZE][event.button.y / TILESIZE].direction = -1;
							map.warpdata[event.button.x / TILESIZE][event.button.y / TILESIZE].connection = -1;
						}
						else if(edit_mode == 3)
						{
							if(move_mode == 0)
								selectedtiles[event.button.x / TILESIZE][event.button.y / TILESIZE] = false;
						}
						else if(edit_mode == 4)
						{
							map.nospawn[event.button.x / TILESIZE][event.button.y / TILESIZE] = false;
						}
					}
				break;
				
				case SDL_MOUSEBUTTONUP:
					if(event.button.button == SDL_BUTTON_LEFT)
					{
						ignoreclick = false;

						if(move_mode == 1)
						{
							pasteselectedtiles(move_offset_x, move_offset_y);

							copymoveselection();
							resetselectedtiles();
							pastemoveselection(move_offset_x, move_offset_y);

							move_offset_x = 0;
							move_offset_y = 0;
						}
						else if(move_mode == 2)
						{
							int currentx = event.button.x / TILESIZE;
							int currenty = event.button.y / TILESIZE;

							int left = move_drag_start_x < currentx ? move_drag_start_x : currentx;
							int top = move_drag_start_y < currenty ? move_drag_start_y : currenty;
							int right = move_drag_start_x < currentx ? currentx : move_drag_start_x;
							int bottom = move_drag_start_y < currenty ? currenty : move_drag_start_y;

							for(int k = top; k <= bottom; k++)
							{
								for(int j = left; j <= right; j++)
								{
									selectedtiles[j][k] = true;
								}
							}
						}

						move_mode = 0;
					}
				break;

				default:
				break;
			}
		}

		if(move_mode == 1 || move_mode == 3)
		{
			int mousex, mousey;
			SDL_GetMouseState(&mousex, &mousey);
			move_offset_x = (mousex / TILESIZE) - move_start_x;
			move_offset_y = (mousey / TILESIZE) - move_start_y;
		}

		if(move_mode == 2)
		{
			int mousex, mousey;
			SDL_GetMouseState(&mousex, &mousey);
			move_drag_offset_x = (mousex / TILESIZE);
			move_drag_offset_y = (mousey / TILESIZE);
		}

		drawmap();

		if(edit_mode == 0)
		{
			font.draw(0,0, "Block Mode");
		}
		else if(edit_mode == 1)
		{
			char modestring[128] = "Tile Mode - ";
			
			if(selected_layer == 0)
				strcat(modestring, "Bottom Background");
			else if(selected_layer == 1)
				strcat(modestring, "Top Background");
			else if(selected_layer == 2)
				strcat(modestring, "Bottom Foreground");
			else if(selected_layer == 3)
				strcat(modestring, "Top Foreground");

			if(view_only_layer)
				strcat(modestring, " Only");

			font.draw(0,0, modestring);

			if(view_only_layer)
				spr_backgroundlevel.draw(2, 18 + (3 - selected_layer) * 18, selected_layer * 16, (3 - selected_layer) * 18, 16, 16);
			else
				spr_backgroundlevel.draw(2, 18, selected_layer * 16, 0, 16, 70);
		}
		else if(edit_mode == 2)
		{
			font.draw(0,0, "Warp Mode");
		}

		if(edit_mode == 3)
		{
			for(int k = 0; k < MAPHEIGHT; k++)
			{
				for(int j = 0; j < MAPWIDTH; j++)
				{
					if(selectedtiles[j][k])
						spr_selectedtile.draw((j + move_offset_x) * TILESIZE, (k + move_offset_y) * TILESIZE);
				}
			}

			//Draw dragging selection
			if(move_mode == 2)
			{
				int left = move_drag_start_x < move_drag_offset_x ? move_drag_start_x : move_drag_offset_x;
				int top = move_drag_start_y < move_drag_offset_y ? move_drag_start_y : move_drag_offset_y;
				int right = move_drag_start_x < move_drag_offset_x ? move_drag_offset_x : move_drag_start_x;
				int bottom = move_drag_start_y < move_drag_offset_y ? move_drag_offset_y : move_drag_start_y;

				for(int k = top; k <= bottom; k++)
				{
					for(int j = left; j <= right; j++)
					{
						if(!selectedtiles[j][k])
							spr_selectedtile.draw(j * TILESIZE, k * TILESIZE);
					}
				}
			}

			font.draw(0,0, "Move Mode");

			if(view_only_layer)
				spr_backgroundlevel.draw(2, 18 + (3 - selected_layer) * 18, selected_layer * 16, (3 - selected_layer) * 18, 16, 16);
			else
				spr_backgroundlevel.draw(2, 18, selected_layer * 16, 0, 16, 70);
		}
		else if(edit_mode == 4)
		{
			for(int k = 0; k < MAPHEIGHT; k++)
			{
				for(int j = 0; j < MAPWIDTH; j++)
				{
					if(map.nospawn[j][k])
						spr_nospawntile.draw((j + move_offset_x) * TILESIZE, (k + move_offset_y) * TILESIZE);
				}
			}

			font.draw(0,0, "No Spawn Mode");
		}

		font.drawRightJustified(640, 0, maplist.current_name());
		
		SDL_Flip(screen);

		int delay = WAITTIME - (SDL_GetTicks() - framestart);
		if(delay < 0)
			delay = 0;
		else if(delay > WAITTIME)
			delay = WAITTIME;
		
		SDL_Delay(delay);
	}

	return EDITOR_QUIT;
}

void drawmap()
{
	spr_background.draw(0,0);

	if((view_only_layer && selected_layer == 0) || !view_only_layer)
		drawlayer(0);

	if((view_only_layer && copiedlayer == 0) || !view_only_layer)
		drawcopiedlayer(0);
	
	if((view_only_layer && selected_layer == 1) || !view_only_layer)
		drawlayer(1);

	if((view_only_layer && copiedlayer == 1) || !view_only_layer)
		drawcopiedlayer(1);

	if(viewblocks && !view_only_layer)
	{
		for(int j = 0; j < MAPHEIGHT; j++)
		{
			for(int i = 0; i < MAPWIDTH; i++)
			{
				int displayblock = INTERACTBLOCKSETSIZE;
				if((move_mode == 1 || move_mode == 3) && i - move_offset_x >= 0 && i - move_offset_x < MAPWIDTH &&
					j - move_offset_y >= 0 && j - move_offset_y < MAPHEIGHT && 
					selectedtiles[i - move_offset_x][j - move_offset_y])
				{
					displayblock = copiedtiles[i - move_offset_x][j - move_offset_y].block;
				}
				else
				{
					displayblock = map.interactionobjectdata[i][j];
				}

				if(displayblock != INTERACTBLOCKSETSIZE)
				{
					SDL_Rect rSrc = {0, 0, 32, 32};
					SDL_Rect rDst = {i * TILESIZE, j * TILESIZE, 32, 32};

					if(displayblock == 0)
						SDL_BlitSurface(s_breakableblock, &rSrc, screen, &rDst);
					else if(displayblock == 1)
						SDL_BlitSurface(s_powerupblock, &rSrc, screen, &rDst);
					else if(displayblock == 2)
						SDL_BlitSurface(s_donutblock, &rSrc, screen, &rDst);
					else if(displayblock == 3)
						SDL_BlitSurface(s_flipblock, &rSrc, screen, &rDst);
					else if(displayblock == 4)
						SDL_BlitSurface(s_bounceblock, &rSrc, screen, &rDst);
					else if(displayblock == 5)
						SDL_BlitSurface(s_noteblock, &rSrc, screen, &rDst);
					
				}
			}
		}
	}
	
	if((view_only_layer && selected_layer == 2) || !view_only_layer)
		drawlayer(2);

	if((view_only_layer && copiedlayer == 2) || !view_only_layer)
		drawcopiedlayer(2);
	
	if((view_only_layer && selected_layer == 3) || !view_only_layer)
		drawlayer(3);

	if((view_only_layer && copiedlayer == 3) || !view_only_layer)
		drawcopiedlayer(3);

	if(viewwarps && !view_only_layer)
	{
		for(int j = 0; j < MAPHEIGHT; j++)
		{
			for(int i = 0; i < MAPWIDTH; i++)
			{
				Warp * warp = NULL;
				if((move_mode == 1 || move_mode == 3) && i - move_offset_x >= 0 && i - move_offset_x < MAPWIDTH &&
					j - move_offset_y >= 0 && j - move_offset_y < MAPHEIGHT && 
					selectedtiles[i - move_offset_x][j - move_offset_y])
				{
					warp = &copiedtiles[i - move_offset_x][j - move_offset_y].warp;
				}
				else
				{
					warp = &map.warpdata[i][j];
				}
				
				if(warp->connection != -1)
				{
					SDL_Rect rSrc = {warp->connection * 32, warp->direction * 32, 32, 32};
					SDL_Rect rDst = {i * TILESIZE, j * TILESIZE, 32, 32};

					SDL_BlitSurface(s_warp, &rSrc, screen, &rDst);
				}
			}
		}
	}

	/*
	for(int k = 0; k < map.numwarpexits; k++)
	{
		SDL_Rect rSrc = {map.warpexits[k].connection * 32, map.warpexits[k].direction * 32, 32, 32};
		SDL_Rect rDst = {map.warpexits[k].x, map.warpexits[k].y, 32, 32};

		SDL_BlitSurface(s_warp, &rSrc, screen, &rDst);
	}
	*/
}

void drawlayer(int layer)
{
	int i, j, ts;
	SDL_Rect bltrect, tilebltrect;
	
	tilebltrect.w = TILESIZE;
	tilebltrect.h = TILESIZE;
	bltrect.w = TILESIZE;
	bltrect.h = TILESIZE;
	
	//draw left to right full vertical
	bltrect.x = 0;
	for(i = 0; i < MAPWIDTH; i++)
	{
		bltrect.y = -TILESIZE;	//this is okay, see

		for(j = 0; j < MAPHEIGHT; j++)
		{
			bltrect.y += TILESIZE;	// here

			if((move_mode == 1 || move_mode == 3) && i - move_offset_x >= 0 && i - move_offset_x < MAPWIDTH &&
				j - move_offset_y >= 0 && j - move_offset_y < MAPHEIGHT && 
				selectedtiles[i - move_offset_x][j - move_offset_y])
			{
				ts = TILESETSIZE;
			}
			else
			{
				ts = map.mapdata[i][j][layer];
			}

			if(ts == TILESETSIZE)
				continue;

			tilebltrect.x = (ts%TILESETWIDTH)*TILESIZE;
			tilebltrect.y = (ts/TILESETWIDTH)*TILESIZE;
		
			SDL_BlitSurface(map.tilesetsurface, &tilebltrect, screen, &bltrect);
		}

		bltrect.x += TILESIZE;
	}
}

void drawcopiedlayer(int layer)
{
	int i, j, ts;
	SDL_Rect bltrect, tilebltrect;
	
	tilebltrect.w = TILESIZE;
	tilebltrect.h = TILESIZE;
	bltrect.w = TILESIZE;
	bltrect.h = TILESIZE;
	
	//draw left to right full vertical
	bltrect.x = 0;
	for(i = 0; i < MAPWIDTH; i++)
	{
		bltrect.y = -TILESIZE;	//this is okay, see

		for(j = 0; j < MAPHEIGHT; j++)
		{
			bltrect.y += TILESIZE;	// here

			if((move_mode == 1 || move_mode == 3) && i - move_offset_x >= 0 && i - move_offset_x < MAPWIDTH &&
				j - move_offset_y >= 0 && j - move_offset_y < MAPHEIGHT && 
				selectedtiles[i - move_offset_x][j - move_offset_y])
			{
				ts = copiedtiles[i - move_offset_x][j - move_offset_y].tile[layer];
			}
			else
			{
				ts = TILESETSIZE;
			}
			
			if(ts == TILESETSIZE)
				continue;

			tilebltrect.x = (ts%TILESETWIDTH)*TILESIZE;
			tilebltrect.y = (ts/TILESETWIDTH)*TILESIZE;
		
			SDL_BlitSurface(map.tilesetsurface, &tilebltrect, screen, &bltrect);
		}

		bltrect.x += TILESIZE;
	}
}

int editor_warp()
{
	bool done = false;
	
	SDL_Rect r;
	r.x = 0;
	r.y = 0;
	r.w = 640;
	r.h = 480;

	while (!done)
	{
		int framestart = SDL_GetTicks();

		//handle messages
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					done = true;
				break;

				case SDL_KEYDOWN:
					edit_mode = 2;  //change to edit mode using warps
					return EDITOR_EDIT;
				break;

				case SDL_MOUSEBUTTONDOWN:
					if(event.button.button == SDL_BUTTON_LEFT)
					{
						if(event.button.x / TILESIZE < 10 && event.button.y / TILESIZE < 4)
						{
							set_direction = event.button.y / TILESIZE;
							set_connection = event.button.x / TILESIZE;
						}

						edit_mode = 2;  //change to edit mode using warps
						
						//The user must release the mouse button before trying to add a tile
						ignoreclick = true;
						
						return EDITOR_EDIT;
					}
				break;

				default:
				break;
			}
		}

		
		drawmap();
		menu_shade.draw(0, 0);

		SDL_BlitSurface(s_warp, NULL, screen, &r);
		font.drawRightJustified(640, 0, maplist.current_name());

		SDL_Flip(screen);

		int delay = WAITTIME - (SDL_GetTicks() - framestart);
		if(delay < 0)
			delay = 0;
		else if(delay > WAITTIME)
			delay = WAITTIME;
		
		SDL_Delay(delay);
	}

	return EDITOR_QUIT;
}

int editor_eyecandy()
{
	bool done = false;
	
	SDL_Rect r;
	r.x = 244;
	r.y = 118;
	r.w = 192;
	r.h = 244;

	SDL_Rect ri;
	ri.x = r.x + 20;
	ri.y = r.y + 50 + map.eyecandyID * 55;
	ri.w = 152;
	ri.h = 24;

	while (!done)
	{
		int framestart = SDL_GetTicks();

		//handle messages
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					done = true;
				break;

				case SDL_KEYDOWN:
						return EDITOR_EDIT;
				break;

				case SDL_MOUSEBUTTONDOWN:
					if(event.button.button == SDL_BUTTON_LEFT)
					{
						for(int k = 0; k < 3; k++)
						{
							if(event.button.x >= r.x && event.button.x < r.x + r.w &&
								event.button.y >= r.y + 30 + k * 60 && event.button.y < r.y + 30 + (k + 1) * 60)
							{
								map.eyecandyID = k;
								ri.y = r.y + 50 + map.eyecandyID * 55;
								
								//The user must release the mouse button before trying to add a tile
								ignoreclick = true;
								return EDITOR_EDIT;
							}
						}
					}
				break;

				default:
				break;
			}
		}

		
		drawmap();
		menu_shade.draw(0, 0);

		SDL_BlitSurface(s_eyecandy, NULL, screen, &r);
		SDL_BlitSurface(s_eyecandyindicator, NULL, screen, &ri);

		font.draw(0,480-font.getHeight(), "eyecandy mode: [e]: edit mode, [LMB] choose eyecandy");
		font.drawRightJustified(640, 0, maplist.current_name());

		SDL_Flip(screen);

		int delay = WAITTIME - (SDL_GetTicks() - framestart);
		if(delay < 0)
			delay = 0;
		else if(delay > WAITTIME)
			delay = WAITTIME;
		
		SDL_Delay(delay);
	}

	return EDITOR_QUIT;
}

int editor_tiles()
{
	int i, j, t;
	bool done = false;
	
	SDL_Rect r;
	r.x = 0;
	r.y = 0;
	r.w = 640;
	r.h = 480;
		

	while (!done)
	{
		int framestart = SDL_GetTicks();

		//handle messages
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					done = true;
				break;

				case SDL_KEYDOWN:
					edit_mode = 1;  //change to edit mode using tiles
					return EDITOR_EDIT;
				break;

				case SDL_MOUSEBUTTONDOWN:
					if(event.button.button == SDL_BUTTON_LEFT)
					{
						set_tile = (event.button.x / TILESIZE) + (event.button.y / TILESIZE)*TILESETWIDTH;
						if(set_tile >= TILESETSIZE)
							set_tile = 0;

						edit_mode = 1;  //change to edit mode using tiles
						
						//The user must release the mouse button before trying to add a tile
						ignoreclick = true;
						
						return EDITOR_EDIT;
					}
					else if(event.button.button == SDL_BUTTON_RIGHT)
					{
						t = (event.button.x / TILESIZE) + (event.button.y / TILESIZE)*TILESETWIDTH;
						if(t >= TILESETSIZE)
							t = 0; 
						set_type = map.tileset[t];

						if(set_type == tile_nonsolid)
							set_type = tile_solid;
						else if(set_type == tile_solid)
							set_type = tile_solid_on_top;
						else if(set_type == tile_solid_on_top)
							set_type = tile_ice;
						else if(set_type == tile_ice)
							set_type = tile_death;
						else if(set_type == tile_death)
							set_type = tile_death_on_top;
						else if(set_type == tile_death_on_top)
							set_type = tile_death_on_bottom;
						else if(set_type == tile_death_on_bottom)
							set_type = tile_nonsolid;

						map.tileset[t] = set_type;	
					}
				break;

				case SDL_MOUSEMOTION:
					if(event.motion.state == SDL_BUTTON(SDL_BUTTON_RIGHT))
					{
						t = (event.button.x / TILESIZE) + (event.button.y / TILESIZE)*TILESETWIDTH;
						if(t >= TILESETSIZE)
							t = 0; 
						map.tileset[t] = set_type;
						
					}
				break;
				

				default:
				break;
			}
		}

		
		drawmap();
		menu_shade.draw(0, 0);

		SDL_BlitSurface(map.tilesetsurface, NULL, screen, &r);
		font.drawRightJustified(640, 0, maplist.current_name());

		for(i=0;i<TILESETWIDTH;i++)
		{
			for(j=0;j<TILESETHEIGHT;j++)
			{
				t = map.tileset[i + j*TILESETWIDTH];
				if(t != tile_nonsolid)
					spr_tiletypes[t-1].draw(i*TILESIZE, j*TILESIZE);
			}
		}
		
		
		SDL_Flip(screen);

		int delay = WAITTIME - (SDL_GetTicks() - framestart);
		if(delay < 0)
			delay = 0;
		else if(delay > WAITTIME)
			delay = WAITTIME;
		
		SDL_Delay(delay);
	}

	return EDITOR_QUIT;
}

int editor_blocks()
{
	bool done = false;
	
	while (!done)
	{
		int framestart = SDL_GetTicks();

		//handle messages
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					done = true;
				break;

				case SDL_KEYDOWN:
					edit_mode = 0;
					return EDITOR_EDIT;
				break;

				case SDL_MOUSEBUTTONDOWN:
					if(event.button.button == SDL_BUTTON_LEFT)
					{
						set_block = (event.button.x / TILESIZE) + (event.button.y / TILESIZE)*TILESETWIDTH;
						if(set_block >= INTERACTBLOCKSETSIZE)
							set_block = 0;
						
						edit_mode = 0;

						//The user must release the mouse button before trying to add a tile
						ignoreclick = true;
						return EDITOR_EDIT;
					}
				break;

				default:
				break;
			}
		}

		drawmap();
		menu_shade.draw(0, 0);
		
		SDL_Rect rSrc = {0, 0, 32, 32};
		SDL_Rect r;
		r.x = 0;
		r.y = 0;
		r.w = 32;
		r.h = 32;
		SDL_BlitSurface(s_breakableblock, &rSrc, screen, &r);

		r.x = 32;
		r.y = 0;
		r.w = 32;
		r.h = 32;
		SDL_BlitSurface(s_powerupblock, &rSrc, screen, &r);

		r.x = 64;
		r.y = 0;
		r.w = 32;
		r.h = 32;
		SDL_BlitSurface(s_donutblock, &rSrc, screen, &r);

		r.x = 96;
		r.y = 0;
		r.w = 32;
		r.h = 32;
		SDL_BlitSurface(s_flipblock, &rSrc, screen, &r);

		r.x = 128;
		r.y = 0;
		r.w = 32;
		r.h = 32;
		SDL_BlitSurface(s_bounceblock, &rSrc, screen, &r);

		r.x = 160;
		r.y = 0;
		r.w = 32;
		r.h = 32;
		SDL_BlitSurface(s_noteblock, &rSrc, screen, &r);

		font.drawRightJustified(640, 0, maplist.current_name());
				
		SDL_Flip(screen);

		int delay = WAITTIME - (SDL_GetTicks() - framestart);
		if(delay < 0)
			delay = 0;
		else if(delay > WAITTIME)
			delay = WAITTIME;
		
		SDL_Delay(delay);
	}

	return EDITOR_QUIT;
}

int display_help()
{
	//unsigned int currentChar = 0;

	drawmap();
	menu_shade.draw(0, 0);
	fontbig.drawCentered(50, "Help");
	
	int offsety = 100;
	int offsetx = 50;
	font.draw(offsetx, offsety, "Modes:");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[t] - Tile Mode");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[i] - Block Mode");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[w] - Warp Mode");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[m] - Move Mode");
	offsety += font.getHeight() + 20;

	font.draw(offsetx, offsety, "Layers:");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[v] - Hide Blocks");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[y] - Select Active Tile Layer");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[u] - Hide Inactive Tile Layers");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[o] - Optimize Layers");
	offsety += font.getHeight() + 20;

	font.draw(offsetx, offsety, "File:");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[n] - New Map");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[s] - Save Map");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[shift] + [s] - Save As");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[f] - Find Map");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[pageup] - Go To Previous Map");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[pagedown] - Go To Next Map");

	offsetx = 320;
	offsety = 100;

	font.draw(offsetx, offsety, "Tile, Warp and Block Modes:");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[Right Mouse Button] - Place Item");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[Left Mouse Button] - Remove Item");
	offsety += font.getHeight() + 20;

	font.draw(offsetx, offsety, "Move Mode:");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[Right Mouse Button] - Select Area");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[Left Mouse Button] - Unselect Area");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "Select And Drag - Move Selections");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "Hold [shift] - Multiple Selections");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "Hold [ctrl] - Freehand Selections");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[delete] - Delete Selection");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[c] - Copy Selection");
	offsety += font.getHeight() + 20;

	font.draw(offsetx, offsety, "Miscellaneous:");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[b] - Change Background");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[e] - Change Floating Eyecandy");
	offsety += font.getHeight() + 2;
	font.draw(offsetx, offsety, "[ctrl] + [delete] - Clear All");
	offsety += font.getHeight() + 2;


	SDL_Flip(screen);

    while (true)
	{
		int framestart = SDL_GetTicks();

		//handle messages
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					return 0;
				break;

				case SDL_KEYDOWN:
					return 0;
				break;

				default:
				break;
			}
		}
		
		int delay = WAITTIME - (SDL_GetTicks() - framestart);
		if(delay < 0)
			delay = 0;
		else if(delay > WAITTIME)
			delay = WAITTIME;
		
		SDL_Delay(delay);
	}

	return 0;
}

int save_as()
{	
	char fileName[64] = "";
	char mapLocation[64] = "maps/";

	if(dialog("Save As", "Enter name:", fileName, 64))
	{
		map.saveMap(strcat(strcat(mapLocation, fileName),".map"));
		maplist.add(strcat(fileName, ".map"));
	}

	return 0;
}

bool dialog(char * title, char * instructions, char * input, int inputsize)
{	
	unsigned int currentChar = 0;

	drawmap();
	menu_shade.draw(0, 0);
	spr_dialog.draw(224, 176);
	fontbig.drawCentered(200, title);
	font.draw(240, 235, instructions);
	font.drawRightJustified(640, 0, maplist.current_name());
	SDL_Flip(screen);

    while (true)
	{
		int framestart = SDL_GetTicks();

		//handle messages
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
				case SDL_QUIT:
					return false;
				break;

				case SDL_KEYDOWN:

					if(event.key.keysym.sym == SDLK_KP_ENTER || event.key.keysym.sym == SDLK_RETURN)
					{
						return true;
					}
					else if(event.key.keysym.sym == SDLK_ESCAPE)
					{
						return false;
					}
					else if(event.key.keysym.sym == SDLK_BACKSPACE)
					{
						if(currentChar > 0)
						{
							input[currentChar-1] = '\0';
							
							drawmap();
							menu_shade.draw(0, 0);
							spr_dialog.draw(224, 176);
							fontbig.drawCentered(200, title);
							font.draw(240, 235, instructions);
							font.draw(240, 255, input);
							font.drawRightJustified(640, 0, maplist.current_name());
							SDL_Flip(screen);
							
							currentChar--;
						}
					}
					else
					{
						
						/* I realise the if statement below is long and can be substituted with 
						the function isalnum(event.key.keysym.sym) but I did it this way because
						isalnum acts funny (ie wrong) when the number pad is pressed. */
						if((isdigit(event.key.keysym.sym) || event.key.keysym.sym == 45 || event.key.keysym.sym == 32 || (event.key.keysym.sym >= 95 && event.key.keysym.sym <= 122)) && currentChar < (unsigned)inputsize - 1)
						{
							//insert charachter into fileName and onScreenText and increment current char
							Uint8 key = event.key.keysym.sym;

							Uint8 * keystate = SDL_GetKeyState(NULL);
							if ((keystate[SDLK_LSHIFT] || keystate[SDLK_RSHIFT]) && event.key.keysym.sym == 45)
								key = 95;

							input[currentChar] = key;
							currentChar++;
							input[currentChar] = '\0';

							drawmap();
							menu_shade.draw(0, 0);
							spr_dialog.draw(224, 176);
							fontbig.drawCentered(200, title);
							font.draw(240, 235, instructions);
							font.draw(240, 255, input);
							font.drawRightJustified(640, 0, maplist.current_name());
							SDL_Flip(screen);
						}
					}	
				break;

				default:
				break;
			}
		}
		
		int delay = WAITTIME - (SDL_GetTicks() - framestart);
		if(delay < 0)
			delay = 0;
		else if(delay > WAITTIME)
			delay = WAITTIME;
		
		SDL_Delay(delay);
	}

	return false;
}

int find()
{
	char fileName[64] = "";
	//char mapLocation[64] = "maps/";

	if(dialog("Find Map", "Enter name:", fileName, 64))
	{
		strcpy(findstring, fileName);

		if(maplist.find(findstring))
		{
			loadcurrentmap();
		}
	}

	return 0;
}

int clearMap()
{ 

	map.clearMap();		
	printf("Map Cleared\n");
	return 0;
}

#ifdef _DEBUG
void convertAll()
{
	for(int k = 0; k < maplist.GetCount(); k++)
	{
		//map.convertMap();
		map.saveMap(maplist.current_name());
		maplist.next();
		map.loadMap(maplist.current_name());
	}
}
#endif


void loadcurrentmap()
{
	map.loadMap(maplist.current_name());

	char filename[128];
	sprintf(filename, "gfx/backgrounds/bg%d.bmp", map.backgroundID);
	spr_background.init(filename);
}

int savecurrentmap()
{
	map.saveMap(maplist.current_name());
	return 0;
}

int findcurrentstring()
{
	if(findstring[0] != '\0')
	{
		if(maplist.find(findstring))
		{
			loadcurrentmap();
		}
	}

	return 0;
}

int newmap()
{
	char fileName[64] = "";
	char mapLocation[64] = "maps/";

	if(dialog("New Map", "Enter name:", fileName, 64))
	{
		map.clearMap();
		map.saveMap(strcat(strcat(mapLocation, fileName),".map"));
		maplist.add(strcat(fileName, ".map"));
	}

	return 0;
}

void resetselectedtiles()
{
	for(int k = 0; k < MAPHEIGHT; k++)
	{
		for(int j = 0; j < MAPWIDTH; j++)
		{
			selectedtiles[j][k] = false;
		}
	}
}

void copymoveselection()
{
	for(int k = 0; k < MAPHEIGHT; k++)
	{
		for(int j = 0; j < MAPWIDTH; j++)
		{
			moveselectedtiles[j][k] = selectedtiles[j][k];
		}
	}
	
	copiedlayer = selected_layer;
}

void pastemoveselection(int movex, int movey)
{
	for(int k = 0; k < MAPHEIGHT; k++)
	{
		for(int j = 0; j < MAPWIDTH; j++)
		{
			if(moveselectedtiles[j][k])
			{
				if(j + movex >= 0 && j + movex < MAPWIDTH && 
					k + movey >= 0 && k + movey < MAPHEIGHT)
				{
					selectedtiles[j + movex][k + movey] = moveselectedtiles[j][k];
				}
			}
		}
	}
}

bool copyselectedtiles()
{
	//Copy the selected tiles and remove tiles from map
	bool ret = false;
	for(int k = 0; k < MAPHEIGHT; k++)
	{
		for(int j = 0; j < MAPWIDTH; j++)
		{
			if(selectedtiles[j][k])
			{
				ret = true;
				copiedtiles[j][k].tile[0] = map.mapdata[j][k][0];
				copiedtiles[j][k].tile[1] = map.mapdata[j][k][1];
				copiedtiles[j][k].tile[2] = map.mapdata[j][k][2];
				copiedtiles[j][k].tile[3] = map.mapdata[j][k][3];

				copiedtiles[j][k].block = map.interactionobjectdata[j][k];

				copiedtiles[j][k].warp.connection = map.warpdata[j][k].connection;
				copiedtiles[j][k].warp.direction = map.warpdata[j][k].direction;
				copiedtiles[j][k].warp.id = map.warpdata[j][k].id;
				
				copiedtiles[j][k].nospawn = map.nospawn[j][k];
			}
		}
	}

	copiedlayer = selected_layer;

	return ret;
}

void clearselectedmaptiles()
{
	for(int k = 0; k < MAPHEIGHT; k++)
	{
		for(int j = 0; j < MAPWIDTH; j++)
		{
			if(selectedtiles[j][k])
			{
				if(view_only_layer)
				{
					map.mapdata[j][k][selected_layer] = TILESETSIZE;
				}
				else
				{
					map.mapdata[j][k][0] = TILESETSIZE;
					map.mapdata[j][k][1] = TILESETSIZE;
					map.mapdata[j][k][2] = TILESETSIZE;
					map.mapdata[j][k][3] = TILESETSIZE;
					
					map.interactionobjectdata[j][k] = INTERACTBLOCKSETSIZE;

					map.warpdata[j][k].connection = -1;
					map.warpdata[j][k].direction = -1;
					map.warpdata[j][k].id = -1;

					map.nospawn[j][k] = false;
				}
			}
		}
	}
}

void pasteselectedtiles(int movex, int movey)
{
	//Paste the tiles into their new location
	//Removing tiles that hang over the edges of the map
	for(int k = 0; k < MAPHEIGHT; k++)
	{
		for(int j = 0; j < MAPWIDTH; j++)
		{
			if(selectedtiles[j][k])
			{
				if(j + movex >= 0 && j + movex < MAPWIDTH && 
					k + movey >= 0 && k + movey < MAPHEIGHT)
				{
					if(view_only_layer)
					{
						map.mapdata[j + movex][k + movey][selected_layer] = copiedtiles[j][k].tile[copiedlayer];
					}
					else
					{
						map.mapdata[j + movex][k + movey][0] = copiedtiles[j][k].tile[0];
						map.mapdata[j + movex][k + movey][1] = copiedtiles[j][k].tile[1];
						map.mapdata[j + movex][k + movey][2] = copiedtiles[j][k].tile[2];
						map.mapdata[j + movex][k + movey][3] = copiedtiles[j][k].tile[3];

						map.interactionobjectdata[j + movex][k + movey] = copiedtiles[j][k].block;

						map.warpdata[j + movex][k + movey].connection = copiedtiles[j][k].warp.connection;
						map.warpdata[j + movex][k + movey].direction = copiedtiles[j][k].warp.direction;
						map.warpdata[j + movex][k + movey].id = copiedtiles[j][k].warp.id;

						map.nospawn[j + movex][k + movey] = copiedtiles[j][k].nospawn;
					}
				}
			}
		}
	}
}

void getcenterselection(int * x, int * y)
{
	int left = -1;
	int top = -1;
	int right = -1;
	int bottom = -1;

	for(int k = 0; k < MAPHEIGHT; k++)
	{
		for(int j = 0; j < MAPWIDTH; j++)
		{
			if(selectedtiles[j][k])
			{
				if(left == -1)
					left = j;

				if(top == -1)
					top = k;

				right = j;
				bottom = k;
			}
		}
	}

	if(right == -1)
	{
		*x = 0;
		*y = 0;
		return;
	}

	*x = ((right - left) >> 1) + left;
	*y = ((bottom - top) >> 1) + top;
}
