/*----------------------------------------------------------+
| super mario war											|
|															|
| a mario war clone written using the tile based collision	|
| detection technique explained in jnrdev #1				|
|															|
| you can read the tutorial on http://jnrdev.72dpiarmy.net	|
|															|
|															|
| this sourcecode is released under the GPL.				|
|															|
|															|
| the code is a bit messy and contains a few things i'm not	|
| really happy with. (menu, ...)							|
| but it works and the game is fun playing :)				|
|															|
|															|
| maybe put all the game relevant stuff in a CGame class	|
| when adding a menu.										|
|															|
|															|
| start:		24.01.2003									|
| last changes:	24.10.2005									|
|															|
|									 2004  Florian Hufsky  |
|								  florian.hufsky@gmail.com	|
|								  http://smw.72dpiarmy.com	|
+----------------------------------------------------------*/

#ifdef _XBOX
	#include <xtl.h>
#endif

#include "global.h"				//all the global stuff
#include <time.h>

//now it's really time for an "engine" (aka resource manager)
#ifdef _WIN32
	#ifndef _XBOX
		#pragma comment(lib, "SDL.lib")
		#pragma comment(lib, "SDLmain.lib")
		#pragma comment(lib, "SDL_mixer.lib")

		#define WIN32_LEAN_AND_MEAN
		#include "windows.h"
	#endif
#endif


//------ system stuff ------
Uint8			*keystates;
SDL_Surface		*screen;		//for gfx (maybe the gfx system should be improved -> resource manager)
SDL_Surface		*blitdest;		//the destination surface for all drawing (can be swapped from screen to another surface)

int				x_shake = 0;
int				y_shake = 0;

//------ sprites (maybe this should be done in a resource manger) ------
gfxSprite		** spr_player[4];	//all player sprites (see global.h)
gfxSprite		** spr_chocobo[4];
gfxSprite		** spr_bobomb[4];
gfxSprite		spr_clouds[2];
gfxSprite		spr_ghosts[3];
gfxSprite		spr_background;
gfxSprite		spr_backmap;
gfxSprite		spr_frontmap;
gfxSprite		menu_backdrop;

gfxFont			font[3];

gfxSprite		menu_shade;
gfxSprite		menu_smw;
gfxSprite		menu_version;
gfxSprite		menu_mario;
gfxSprite		menu_cpu;
gfxSprite		menu_itembackground;
gfxSprite		menu_stoneborder;
gfxSprite		menu_slider_bar;
gfxSprite		menu_mode;
gfxSprite		game_mode;
gfxSprite		spr_dialog;
gfxSprite		spr_dialogbutton;
gfxSprite		spr_tournament_background;
gfxSprite		spr_tournament_powerup_splash;
gfxSprite		spr_player_select_background;

gfxSprite		spr_noteblock;
gfxSprite		spr_breakableblock;
gfxSprite		spr_powerupblock;
gfxSprite		spr_donutblock;
gfxSprite		spr_flipblock;
gfxSprite		spr_bounceblock;

gfxSprite		spr_starpowerup;
gfxSprite		spr_1uppowerup;
gfxSprite		spr_firepowerup;
gfxSprite		spr_hammerpowerup;
gfxSprite		spr_poisonpowerup;
gfxSprite		spr_clockpowerup;
gfxSprite		spr_bobombpowerup;
gfxSprite		spr_powpowerup;
gfxSprite		spr_bulletbillpowerup;

gfxSprite		spr_shade[3];
gfxSprite		spr_spawneggs;
gfxSprite		spr_crown;
gfxSprite		spr_warplock;

gfxSprite		spr_coin;
gfxSprite		spr_egg;
gfxSprite		spr_yoshi;
gfxSprite		spr_thwomp;
gfxSprite		spr_areas;
gfxSprite		spr_jail;
gfxSprite		spr_goomba;
gfxSprite		spr_goombadead;
gfxSprite		spr_goombadeadflying;
gfxSprite		spr_bulletbill;
gfxSprite		spr_bulletbilldeadflyingleft;
gfxSprite		spr_bulletbilldeadflyingright;
gfxSprite		spr_chicken;
gfxSprite		spr_racegoal;
gfxSprite		spr_racegoalnumbers;

gfxSprite		spr_bobombcard;
gfxSprite		spr_fireflowercard;
gfxSprite		spr_hammercard;

gfxSprite		spr_fireball;
gfxSprite		spr_hammer;

gfxSprite		spr_fireballexplosion;
gfxSprite		spr_frictionsmoke;
gfxSprite		spr_explosion;
gfxSprite		spr_burnup;
gfxSprite		spr_spawnsmoke[4];
gfxSprite		spr_spawndoor[4];
gfxSprite		spr_brokenBlock[4];
gfxSprite		spr_bonus[4];
gfxSprite		spr_award;
gfxSprite		spr_awardsolid;
gfxSprite		spr_awardsouls;
gfxSprite		spr_awardsoulspawn;
gfxSprite		spr_awardkillsinrow[4];
gfxSprite		spr_owned[4];

gfxSprite		spr_storedpowerupsmall;
gfxSprite		spr_storedpoweruplarge;
gfxSprite		spr_powerupselector;

gfxSprite		spr_scoreboard;
gfxSprite		spr_abovearrows;

//key graphics for help
gfxSprite		spr_keys[5];

//------ game relevant stuff ------
CPlayer			*list_players[4];
int				list_players_cnt = 0;
bool			showscoreboard;
float			scorepercentmove;
SScore			score[4] = {{	/*0*/ 0, 0, 0, 0, 0, 0, 0, 0, 0}, 
							{	/*1*/ 0, 0, 0, 0, 0, 1, 0, 0, 0}, 
							{	/*2*/ 0, 0, 0, 0, 0, 2, 0, 0, 0}, 
							{	/*3*/ 0, 0, 0, 0, 0, 3, 0, 0, 0}};
int				score_cnt;
int				scoreoffsets[3] = {2, 36, 70};
int				scorepowerupoffsets[3][3] = {{37, 0, 0},
											{71, 89, 0},
											{105, 123, 141}};
int				respawn[4] = {0, 0, 0, 0};

int				projectiles[4];
int				controlkeys[4][6] = { {SDLK_LEFT, SDLK_RIGHT, SDLK_UP, SDLK_DOWN, SDLK_RCTRL, SDLK_RSHIFT},
									  {SDLK_a, SDLK_d, SDLK_w, SDLK_s, SDLK_e, SDLK_q},
									  {SDLK_g, SDLK_j, SDLK_y, SDLK_h, SDLK_u, SDLK_t},
									  {SDLK_l, SDLK_QUOTE, SDLK_p, SDLK_SEMICOLON, SDLK_LEFTBRACKET, SDLK_o}};

CMap			map;

CEyecandyContainer eyecandyback;
CEyecandyContainer eyecandyfront;

CInteractionObjectContainer interactionobjectblocks;
CInteractionObjectContainer interactionobjectcollisionitems;
CInteractionObjectContainer interactionobjectsfront;
CInteractionObjectContainer interactionobjectsplayer;

// lastgamewinner is assigned to the player that won the last game.  This allows for adding 
// eyecandy to that player for bragging rights
int				lastgamewinner = -1;
bool			loadmessages = true;

STextAward awards[PAWARD_LAST] = {
								STextAward("Double Kill", &font[0]),
								STextAward("Triple Kill", &font[0]),
								STextAward("Killing Spree",  &font[1]),
								STextAward("Killing Spree x 2",  &font[1]),
								STextAward("Killing Spree x 3", &font[1]),
								STextAward("Dominating", &font[2]),
								STextAward("Dominating x 2",  &font[2]),
								STextAward("Dominating x 3",  &font[2]),
								STextAward("Unstoppable!", &font[2])
							};

sfxSound announcer[PANNOUNCER_SOUND_LAST];

sfxSound mip;
sfxSound deathsound;
sfxSound jump;

int iInvincibleMusicChannel = -1;
int iSlowdownMusicChannel = -1;
int iHurryUpMusicChannel = -1;
bool fResumeMusic = true;

sfxSound invinciblemusic;
sfxSound extraguysound;
sfxSound sprout;
sfxSound collectpowerup;
sfxSound storepowerup;
sfxSound breakblock;
sfxSound bump;
sfxSound coin;
sfxSound fireball;
sfxSound springjump;
sfxSound timewarning;
sfxSound hit;
sfxSound chicken;
sfxSound transform;
sfxSound yoshi;
sfxSound pause;
sfxSound bobombsound;
sfxSound areatag;
sfxSound cannon;
sfxSound burnup;
sfxSound sfx_pipe;
sfxSound thunder;
sfxSound slowdownmusic;
sfxSound storedpowerupsound;
sfxSound kicksound;
sfxSound racesound;
sfxSound bulletbillsound;

sfxMusic backgroundmusic[5];

CGameMode	*gamemodes[GAMEMODE_LAST];
int			currentgamemode = 0;


extern void setupscoreboard();
extern bool loadmenuskin(int playerID, int skinID, int colorID);

MapList maplist;
SkinList skinlist;
AnnouncerList announcerlist;
//MusicPlayList musicplaylist;
MusicList musiclist;

char *convertPath(char *source) 
{
#ifndef _XBOX
	return source;
#else
	static char convertedString[512];
	strcpy(convertedString, "D:\\");
	strcat(convertedString, source);
	for(unsigned int i=0; i<strlen(convertedString); i++) 
	{
		if(convertedString[i] == '/')
			convertedString[i] = '\\';
	}
	return convertedString;
#endif
}

float CapVelocity(float vel)
{
	if(vel < -MAXVELY)
		return (float)-MAXVELY;
	
	if(vel > MAXVELY)
		return (float)MAXVELY;
	
	return vel;
}


//handles a collision between a powerup and an object
void collisionhandler_o2o(IO_MovingObject &o1, CInteractionObject &o2)
{
	o2.collide(&o1);
}

void stopinvincibilityfordeadplayer(int playerID)
{
	//check to make sure the invincible music is playing for this player
	if(!list_players[playerID]->invincible)
		return;

	bool stopMusic = true;
	for(int k = 0; k < list_players_cnt; k++)
	{
		if(k == playerID)
			continue;

		if(list_players[k]->invincible && list_players[k]->invincibletimer < list_players[playerID]->invincibletimer)
		{
			stopMusic = false;
			break;
		}
	}

	if(stopMusic)
	{
		ifsoundonstop(invinciblemusic);
	
		if(game_values.music)
			backgroundmusic[0].play(false, false);
	}
}

void cleandeadplayers()
{
	for(int i = 0; i < list_players_cnt; i++)
	{
		if(list_players[i]->isdead())
		{
			if(list_players[i]->invincible)
			{
				stopinvincibilityfordeadplayer(i);
			}

			if(respawn[list_players[i]->globalID] <= 0)
				list_players[i]->spawnGameOverMario();

			if(game_values.gamemode->tagged == list_players[i])
				game_values.gamemode->tagged = NULL;

			if(game_values.gamemode->chicken == list_players[i])
				game_values.gamemode->chicken = NULL;

			delete list_players[i];
			
			for(int j = i; j < list_players_cnt - 1; j++)
			{
				list_players[j] = list_players[j + 1];
				list_players[j]->localID = j;
			}

			list_players_cnt--;
			list_players[list_players_cnt] = NULL;
		}
	}

	int lastteam = -1;
	if(!game_values.gamemode->gameover && countaliveteams(&lastteam) <= 1)
	{
		game_values.gamemode->gameover = true;
		game_values.gamemode->winningteam = lastteam;
		setupscoreboard();
	}
}

//Must only be called after organizeteams() is called
int lookupteamid(int id)
{
	for(int i = 0; i < score_cnt; i++)
	{
		for(int j = 0; j < game_values.teamcounts[i]; j++)
		{
			if(game_values.teamids[i][j] == id)
			{
				return i;
			}
		}
	}

	return -1;
}

int countaliveteams(int * lastteam)
{
	int findlastteam = 0;

	bool teamalive[4] = {false, false, false, false};
	for(int k = 0; k < list_players_cnt; k++)
	{
		if(!list_players[k]->isdead())
			teamalive[list_players[k]->teamID] = true;
	}

	int numteams = 0;
	for(int k = 0; k < 4; k++)
	{
		if(teamalive[k])
		{
			findlastteam = k;
			numteams++;
		}
	}

	if(lastteam != NULL)
	{
		if(numteams == 1)
			*lastteam = findlastteam;
		else
			*lastteam = -1;
	}

	return numteams;
}

//Returns the number of teams that are formed
int organizeteams()
{
	int numteams = 0;
	for(int i = 0; i < 4; i++)
	{
		if(game_values.teamcounts[i] == 0)
		{
			for(int j = i + 1; j < 4; j++)
			{
				if(game_values.teamcounts[j] > 0)
				{
					game_values.teamcounts[i] = game_values.teamcounts[j];

					for(int k = 0; k < 3; k++)
						game_values.teamids[i][k] = game_values.teamids[j][k];

					game_values.teamcounts[j] = 0;

					numteams++;

					break;
				}
			}
		}
		else
		{
			numteams++;
		}
	}

	return numteams;
}

void DECLSPEC soundfinished(int channel)
{
	if(iInvincibleMusicChannel == channel)
	{
		iInvincibleMusicChannel = -1;
		
		if(iHurryUpMusicChannel < 0)
		{
			if(game_values.music && !game_values.gamemode->gameover)
				backgroundmusic[0].play(false, false);
		}
	}

	if(iHurryUpMusicChannel == channel)
	{
		iHurryUpMusicChannel = -1;

		if(iInvincibleMusicChannel < 0)
		{
			if(game_values.music && !game_values.gamemode->gameover)
				backgroundmusic[0].play(false, false);
		}
	}

	if(iSlowdownMusicChannel == channel)
		iSlowdownMusicChannel = -1;

	channel = -1;
}

void DECLSPEC musicfinished()
{
	if(fResumeMusic && game_values.music)
	{
		backgroundmusic[3].play(false, false);
	}
}

void rungame();
void runmenu(MenuID id);
void cleanup();
bool load_and_splashscreen();
void loadInteractionMapObjects();
void updatescoreboard();

gv game_values;

ts tournament_scores[4];


//ugly devcpp hack
// michael, you figure out when you need this preprocessor directive to fire,
// and then you make it fire then. you don't make it fire for every single god
// damn system except for WINDOWS you idiot
#ifdef MICHAEL_IS_AN_IDIOT
#  ifndef _WIN32
#    undef main
#  endif
#endif

#ifdef _XBOX
	//Joystick-Init
	SDL_Joystick **joysticks = NULL;
	int joystickcount = 0;
#endif

bool autotest = false;

// ------ MAIN ------
int main(int argc, char *argv[])
{
	bool loadok;
	
	printf("-------------------------------------------------------------------------------\n");
	printf(" %s %s\n", TITLESTRING, VERSIONNUMBER);
	printf("-------------------------------------------------------------------------------\n");
	printf("\n---------------- startup ----------------\n");

	gfx_init(640, 480, false);		//initialize the graphics (SDL)
	blitdest = screen;

	sfx_init();                     //init the sound system

#ifdef _XBOX
	//Joystick-Init
	SDL_InitSubSystem(SDL_INIT_JOYSTICK);
	joystickcount = SDL_NumJoysticks();
	joysticks = new SDL_Joystick*[joystickcount];

	for(int i = 0; i < joystickcount; i++)
		joysticks[i] = SDL_JoystickOpen(i);

	SDL_JoystickEventState(SDL_ENABLE);
#endif

	keystates = SDL_GetKeyState(0);	//get key array

	//currently this only sets the title, not the icon.
	//setting the icon isn't implemented in sdl ->  i'll ask on the mailing list
	char title[128];
	sprintf(title, "%s %s", TITLESTRING, VERSIONNUMBER);
	SDL_WM_SetCaption(title, "smw.ico");
	SDL_ShowCursor(SDL_DISABLE);



	printf("\n---------------- loading ----------------\n");
	
	//set standard game values
	game_values.playercontrol[0]	= 1;
	game_values.playercontrol[1]	= 1;
	game_values.showfps				= false;
	game_values.frameadvance		= false;
	game_values.sound				= true;
	game_values.music				= true;
	game_values.gamestate			= GS_MENU;
	game_values.NUMmousecontrol		= true;
	game_values.fullscreen			= false;
	//game_values.fullscreen		= true;
	game_values.screenResizeX		= 20.0f;
	game_values.screenResizeY		= 20.0f;
	game_values.screenResizeW		= -40.0f;
	game_values.screenResizeH		= -40.0f;
	game_values.pausegame			= false;
	game_values.exitinggame			= false;
	game_values.exityes				= false;
	game_values.awardstyle			= award_style_fireworks;
	game_values.spawnstyle			= 2;
	game_values.tournamentgames		= 1;
	game_values.tournamentwinner	= -1;
	game_values.powerupselectdone	= false;
	game_values.slowdownon			= -1;
	game_values.slowdowncounter		= 0;
	game_values.friendlyfire		= false;
	game_values.screencrunch		= true;
	game_values.screenshaketimer	= 0;
	game_values.screenshakeplayer   = NULL;
	game_values.toplayer			= true;
	game_values.loadedannouncer		= -1;
	game_values.loadedmusic			= -1;
	game_values.scoreboardstyle     = 0;
	game_values.teamcolors          = true;
	game_values.cputurn				= -1;
	game_values.spawninvincibility  = true;
	game_values.musicvolume			= 128;
	game_values.soundvolume			= 128;
	game_values.respawn				= 3;

	announcerlist.SetCurrent(0);

	for(int k = 0; k < 4; k++)
	{
		game_values.storedpowerups[k] = -1;
		game_values.gamepowerups[k] = -1;
		game_values.teamids[k][0] = k;
		game_values.teamcounts[k] = 1;
		game_values.skinids[k] = 0;
		game_values.colorids[k] = k;

		projectiles[k] = 0;
		respawn[k] = 0;
	}
	
	//set game modes
	gamemodes[0] = new CGM_MarioWar;
	gamemodes[1] = new CGM_DM_Fraglimit;
	gamemodes[2] = new CGM_DM_Timelimit;
	gamemodes[3] = new CGM_Jail;
	gamemodes[4] = new CGM_Coins;
	gamemodes[5] = new CGM_Goomba;
	gamemodes[6] = new CGM_Eggs;
	gamemodes[7] = new CGM_CaptureTheChicken;
	gamemodes[8] = new CGM_Tag;
	gamemodes[9] = new CGM_Domination;
	gamemodes[10] = new CGM_Race;
	gamemodes[11] = new CGM_Owned;
	gamemodes[12] = new CGM_Fireball;
	gamemodes[13] = new CGM_Hammer;
	gamemodes[14] = new CGM_Bobomb;
	gamemodes[15] = new CGM_Thwomp;
	gamemodes[16] = new CGameMode;

	currentgamemode = 0;
	game_values.gamemode = gamemodes[currentgamemode];


	//Read saved settings from disk
	FILE *fp;

#ifdef _XBOX
	fp = fopen("D:\\options.bin", "rb");
#else
	fp = fopen("options.bin", "rb");
#endif

	if(fp != NULL)
	{

#ifdef _XBOX
		fread(&game_values.screenResizeX, sizeof(int), 1, fp);
		fread(&game_values.screenResizeY, sizeof(int), 1, fp);
		fread(&game_values.screenResizeW, sizeof(int), 1, fp);
		fread(&game_values.screenResizeH, sizeof(int), 1, fp);

		SDL_XBOX_SetScreenPosition(game_values.screenResizeX, game_values.screenResizeY);
		SDL_XBOX_SetScreenStretch(game_values.screenResizeW, game_values.screenResizeH);
#endif
		unsigned char abyte[15];
		fread(abyte, 15, 1, fp);
        game_values.spawnstyle = (int) abyte[0];
        game_values.awardstyle = (int) abyte[1];
		game_values.friendlyfire = ((int)abyte[3] > 0 ? true : false);
		game_values.screencrunch = ((int)abyte[4] > 0 ? true : false);
		game_values.toplayer = ((int)abyte[5] > 0 ? true : false);
		game_values.scoreboardstyle = (int)abyte[6];
		game_values.teamcolors = ((int)abyte[7] > 0 ? true : false);
		game_values.sound = ((int)abyte[8] > 0 ? true : false);
		game_values.music = ((int)abyte[9] > 0 ? true : false);
		game_values.spawninvincibility = ((int)abyte[10] > 0 ? true : false);
		game_values.musicvolume = (int)abyte[11];
		game_values.soundvolume = (int)abyte[12];
		game_values.respawn = (int)abyte[13];

#ifndef _XBOX
		fread(&game_values.fullscreen, sizeof(bool), 1, fp);
		if(game_values.fullscreen)
		{
			gfx_setresolution(640, 480, true);
			blitdest = screen;
		}
#endif
		
		for(int k = 0; k < GAMEMODE_LAST; k++)
			fread(&(gamemodes[k]->goal), sizeof(int), 1, fp);

		fclose(fp);

		announcerlist.SetCurrent((int) abyte[2]);
		musiclist.SetCurrent((int) abyte[14]);

		sfx_setmusicvolume(game_values.musicvolume);
		sfx_setsoundvolume(game_values.soundvolume);
	}

	srand((unsigned int)time(NULL));	//now we've got a random seed - we can't know how much time the player spends in the splash screen

	loadok = load_and_splashscreen();

	if(!loadok)
	{
		printf("\n---------------- EXIT DURING LOADING ----------------\n\n");
        sfx_close();
		gfx_close();
		return 0;
	}


	printf("\n---------------- ready, steady, go! ----------------\n");

	runmenu(menu_id_main);

	while(game_values.gamestate != GS_QUIT)
	{
		switch(game_values.gamestate)
		{
			case GS_GAME:
				rungame();
			break;

			case GS_MENU:
				runmenu(menu_id_main);
			break;

			case GS_SCOREBOARD:
				runmenu(menu_id_tournament);
			break;

			case GS_BONUS:
				runmenu(menu_id_bonus);
			break;

            case GS_QUIT: // added because of warning on not handling all of enum
            break;
		}
	}
	
	

	printf("\n---------------- shutdown ----------------\n");
	for(int i = 0; i < GAMEMODE_LAST; i++)
		delete gamemodes[i];

#ifdef _XBOX
	for(i = 0; i < joystickcount; i++)
		SDL_JoystickClose(joysticks[i]);

	delete[] joysticks;
#endif
	
    sfx_close();
	gfx_close();

	//Delete player skins
	for(int k = 0; k < 4; k++)
	{
		for(int j = 0; j < PGFX_LAST; j++)
		{
			delete spr_player[k][j];
			delete spr_chocobo[k][j];
			delete spr_bobomb[k][j];
		}

		delete [] spr_player[k];
		delete [] spr_chocobo[k];
		delete [] spr_bobomb[k];
	}

	return 0;
}


/*
#ifdef _XBOX

void reconnectjoysticks()
{
	for(int i = 0; i < joystickcount; i++)
		SDL_JoystickClose(joysticks[i]);

	delete[] joysticks;

	SDL_QuitSubSystem(SDL_INIT_JOYSTICK);
	SDL_InitSubSystem(SDL_INIT_JOYSTICK);

	joystickcount = SDL_NumJoysticks();
	joysticks = new SDL_Joystick*[joystickcount];

	for(i = 0; i < joystickcount; i++)
		joysticks[i] = SDL_JoystickOpen(i);

	SDL_JoystickEventState(SDL_ENABLE);
}

#endif
*/





//-----------------------------------------------------------------------------
// THE GAME LOOP
//-----------------------------------------------------------------------------

bool coldec_player2player(CPlayer &o1, CPlayer &o2);
bool coldec_player2obj(CPlayer &o1, CInteractionObject &o2);
bool coldec_obj2obj(CInteractionObject &o1, CInteractionObject &o2);

void rungame()
{
	unsigned int	framestart, ticks;
	SDL_Event		event;
	int				i,j;
	float			realfps = 0, flipfps=0;
	Uint8			mouse;
	int				mousex;
	int				mousey;

#ifdef _DEBUG
	static exitgametimer = 0;
	exitgametimer = 0;
#endif
	
	y_shake = 0;
	x_shake = 0;

	//Moves teams to the first arrays in the list
	score_cnt = organizeteams();

	//TODO: the controls should be modifiable!

	for(int k = 0; k < 4; k++)
	{
		projectiles[k] = 0;
		respawn[k] = 0;

		if(game_values.playercontrol[k] > 0)
		{
			int teamid = lookupteamid(k);
			list_players[list_players_cnt] = new CPlayer(k, list_players_cnt, teamid, game_values.colorids[k], controlkeys[k], spr_player[k], &(score[teamid]), &(respawn[k]), game_values.playercontrol[k] == 2);
			list_players_cnt++;
		}

		game_values.gamepowerups[k] = game_values.storedpowerups[k];
	}

	game_values.gamemode->init();
	game_values.pausegame = false;
	game_values.exitinggame = false;
	game_values.exityes = false;
	game_values.teamdeadcounter = 0;
	game_values.screenshaketimer = 0;
	game_values.bulletbilltimer = 0;
	game_values.slowdownon = -1;
	game_values.slowdowncounter	= 0;

	showscoreboard = false;
	scorepercentmove = 0.0f;

	int totalspace = 0;
	for(i = 0; i < score_cnt; i++)
	{
		totalspace += 56 + game_values.teamcounts[i] * 34;
	}
	totalspace += 20 * (score_cnt - 1);

	for(i = 0; i < score_cnt; i++)
	{
		if(game_values.scoreboardstyle == 0 || game_values.scoreboardstyle == 1)
		{
			score[i].x = ((640 - totalspace) >> 1);

			for(int k = 0; k < i; k++)
				score[i].x += 76 + game_values.teamcounts[k] * 34;

			score[i].y = 5 + (game_values.scoreboardstyle == 1 ? 429 : 0);
		}
		else
		{
			score[i].x = 5 + (574 - (34 * game_values.teamcounts[i])) * (i % 2);
			score[i].y = 5 + 429 * (i > 1 ? 1 : 0);
		}

		score[i].fromx = score[i].x;
		score[i].fromy = score[i].y;
		score[i].place = i;
	}

	if(map.eyecandyID == 1)
	{
		for(i = 0; i < 4; i++)
		{
			int c = rand()%2;	//cloud type (0... small cloud, 1... big cloud)
			float velx;			//speed of cloud, small clouds are slower than big ones
			if(c == 0)
				velx = (int)(rand()%51-25)/10.0f;	//big clouds: -3 - +3 pixel/frame
			else
				velx = (int)(rand()%41-20)/10.0f;	//small clouds: -2 - +2 pixel/frame
			
			velx = velx < 0.5f && velx > -0.5f ? 1 : velx;	//no static clouds please

			//add cloud to eyecandy array
			eyecandyfront.add(new EC_Cloud(&spr_clouds[c], (float)(rand()%640), (float)(rand()%100), velx));
		}
	}
	else if(map.eyecandyID == 2)
	{
		for(i = 0; i < 12; i++)
		{
			int c = rand()%3;	//ghost type
			float velx = (int)(rand()%51-25)/10.0f;	//big clouds: -3 - +3 pixel/frame
			
			velx = velx < 0.5f && velx > -0.5f ? (rand() % 1 ? 1.0f : -1.0f) : velx;	//no static clouds please

			//add cloud to eyecandy array
			eyecandyfront.add(new EC_Ghost(&spr_ghosts[c], (float)(rand()%640), (float)(rand()%100), velx, 8, 2));
		}
	}
	
	bool quitGame = false;
	while (true)
	{
		framestart = SDL_GetTicks();

/*
#ifdef _XBOX
		if(joystickcount != SDL_NumJoysticks())
			reconnectjoysticks();
#endif
*/
#ifdef _DEBUG

		static int endgametimer = rand() % 200;
		if(autotest)
		{
			/*
			for(int k = 0; k < list_players_cnt; k++)
			{
				if(list_players[k]->isready())
				{
					//Detect player is in center of tile only
					int x = (list_players[k]->ix + HALFPW) / TILESIZE;
					
					if(list_players[k]->ix + HALFPW < 0)
						x = (list_players[k]->ix + HALFPW + 640) / TILESIZE;

					int y = (list_players[k]->iy + HALFPH) / TILESIZE;

					TileType tile = tile_nonsolid;
					IO_Block * block = NULL;
					int blocktype = INTERACTBLOCKSETSIZE;

					if(list_players[k]->iy + HALFPH >= 0 && list_players[k]->iy + HALFPH < 480)
					{
						tile = map.map(x, y);
						block = map.block(x, y);
						blocktype = map.blockat(x, y);
					}

					if( (tile != tile_nonsolid && tile != tile_solid_on_top) || 
						(block && blocktype != 3))
					{
						game_values.pausegame = true;
						game_values.frameadvance = true;
						autotest = false;
					}

					//Detect if any corner of player is in a tile
					int actualvalues[2][2];
					actualvalues[0][0] = list_players[k]->ix;

					if(list_players[k]->ix < 0)
						actualvalues[0][0] = list_players[k]->ix + 640;

					actualvalues[0][1] = list_players[k]->ix + PW;

					if(list_players[k]->ix + PW < 0)
						actualvalues[0][1] = list_players[k]->ix + PW + 640;

					actualvalues[1][0] = list_players[k]->iy;
					actualvalues[1][1] = list_players[k]->iy + PH;

					int corners[2][2];
					corners[0][0] = list_players[k]->ix / TILESIZE; 

					if(list_players[k]->ix < 0)
						corners[0][0] = (list_players[k]->ix + 640) / TILESIZE;

					corners[0][1] = (list_players[k]->ix + PW) / TILESIZE; 

					if(list_players[k]->ix + PW < 0)
						corners[0][1] = (list_players[k]->ix + PW + 640) / TILESIZE;

					corners[1][0] = list_players[k]->iy / TILESIZE;
					corners[1][1] = (list_players[k]->iy + PH) / TILESIZE;

					for(int i = 0; i < 2; i++)
					{
						for(int j = 0; j < 2; j++)
						{
							TileType tile = tile_nonsolid;
							IO_Block * block = NULL;
							int blocktype = INTERACTBLOCKSETSIZE;

							if(actualvalues[0][j] >= 0 && actualvalues[0][j] < 20 && actualvalues[1][i] >= 0 && actualvalues[1][i] < 15)
							{
								tile = map.map(corners[0][j], corners[1][i]);
								block = map.block(corners[0][j], corners[1][i]);
								blocktype = map.blockat(corners[0][j], corners[1][i]);
							}

							if( (tile != tile_nonsolid && tile != tile_solid_on_top) || 
								(block && blocktype != 3))
							{
								game_values.pausegame = true;
								game_values.frameadvance = true;
								autotest = false;
							}
						}
					}
				}
			}
			*/

			/*
			//Kill off players to test spawning
			static int chooseplayer = 0;
			static int killtimer = 0;
			if(++killtimer > 20)
			{
				killtimer = 0;

				if(++chooseplayer > 3)
					chooseplayer = 0;

				if( !game_values.gamemode->playerkilledself(*(list_players[chooseplayer])) )
				{
					list_players[chooseplayer]->deathAwards();
					list_players[chooseplayer]->jumpDeath();
				}
			}*/
			
			//Automatically run menus
			if(showscoreboard)
			{
				if(--endgametimer < 0)
				{
					endgametimer = rand() % 200;

					if(game_values.tournament)
					{
						cleanup();
						updatescoreboard();
						game_values.gamestate = GS_SCOREBOARD;
						return;
					}
					else
					{
						quitGame = true;
					}
				}
			}
			else
			{
				if(++exitgametimer >= 8000)
				{
					if(game_values.tournament)
					{
						cleanup();
						game_values.gamestate = GS_SCOREBOARD;
						game_values.exitinggame = false;
						game_values.exityes = false;
						return;
					}
					else
					{
						quitGame = true;
					}
				}
			}
		}
		
#endif

		if(quitGame) 
		{
			quitGame = false;
			game_values.exitinggame = false;
			game_values.exityes = false;

			cleanup();
			game_values.gamestate = GS_MENU;

			for(int k = 0; k < 4; k++)
			{
				game_values.colorids[k] = k;
				loadmenuskin(k, game_values.skinids[k], game_values.colorids[k]);
			}
			
			return;
		}
		//handle messages
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
#ifndef _XBOX
				case SDL_QUIT:
					cleanup();
					game_values.gamestate = GS_QUIT;
					return;
				break;
#endif
				case SDL_KEYDOWN:
#ifndef _XBOX
					if(event.key.keysym.sym == SDLK_F4 && (keystates[SDLK_LALT] || keystates[SDLK_RALT]))
					{
						cleanup();
						game_values.gamestate = GS_QUIT;
						return;
					}
#endif
					if(event.key.keysym.sym == SDLK_ESCAPE)
					{
						if(showscoreboard)
						{
							if(game_values.tournament)
							{
								cleanup();
								updatescoreboard();
								game_values.gamestate = GS_SCOREBOARD;
								return;
							}
							else
							{
								quitGame = true;
							}
						}
						else
						{
							if(!game_values.pausegame && !game_values.exitinggame)
							{
								menu_shade.draw(0, 0);
								game_values.exitinggame = true;
								ifsoundonpause(invinciblemusic);
								ifsoundonpause(slowdownmusic);
							}
						}
					}
					else if(event.key.keysym.sym == SDLK_F1)
					{
						game_values.showfps = !game_values.showfps;
					}
#ifdef _DEBUG
					else if(event.key.keysym.sym == SDLK_F2)
					{
						game_values.frameadvance = !game_values.frameadvance;
					}
					else if(event.key.keysym.sym == SDLK_F12)
					{
						for(int k = 0; k < list_players_cnt; k++)
						{
							if( !game_values.gamemode->playerkilledself(*(list_players[k])) )
							{
								list_players[k]->deathAwards();
								list_players[k]->jumpDeath();
							}
						}
					}
					else if(event.key.keysym.sym == SDLK_1)
					{
						interactionobjectcollisionitems.add(new PU_StarPowerup(&spr_starpowerup, list_players[0]->ix + 32, list_players[0]->iy, 3, true, 2, 30, 30, 1, 1));
					}
					else if(event.key.keysym.sym == SDLK_2)
					{
						interactionobjectcollisionitems.add(new PU_1upPowerup(&spr_1uppowerup, list_players[0]->ix + 32, list_players[0]->iy, 1, true, 1000000, 30, 30, 1, 1));
					}
					else if(event.key.keysym.sym == SDLK_3)
					{
						interactionobjectcollisionitems.add(new PU_FirePowerup(&spr_firepowerup, list_players[0]->ix + 32, list_players[0]->iy, 1, true, 1000000, 30, 30, 1, 1));
					}
					else if(event.key.keysym.sym == SDLK_4)
					{
						interactionobjectcollisionitems.add(new PU_HammerPowerup(&spr_hammerpowerup, list_players[0]->ix + 32, list_players[0]->iy, 1, true, 1000000, 30, 30, 1, 1));
					}
					else if(event.key.keysym.sym == SDLK_5)
					{
						interactionobjectcollisionitems.add(new PU_PoisonPowerup(&spr_poisonpowerup, list_players[0]->ix + 32, list_players[0]->iy, 1, true, 1000000, 30, 30, 1, 1));
					}
					else if(event.key.keysym.sym == SDLK_6)
					{
						interactionobjectcollisionitems.add(new PU_ClockPowerup(&spr_clockpowerup, list_players[0]->ix + 32, list_players[0]->iy - 1, 1, true, 1000000, 30, 30, 1, 1));
					}
					else if(event.key.keysym.sym == SDLK_7)
					{
						interactionobjectcollisionitems.add(new PU_BobombPowerup(&spr_bobombpowerup, list_players[0]->ix + 32, list_players[0]->iy - 1, 1, true, 1000000, 30, 30, 1, 1));
					}
					else if(event.key.keysym.sym == SDLK_8)
					{
						interactionobjectcollisionitems.add(new PU_PowPowerup(&spr_powpowerup, list_players[0]->ix + 32, list_players[0]->iy - 1, 1, true, 1000000, 30, 30, 1, 1));
					}
					else if(event.key.keysym.sym == SDLK_9)
					{
						interactionobjectcollisionitems.add(new PU_BulletBillPowerup(&spr_bulletbillpowerup, list_players[0]->ix + 32, list_players[0]->iy - 1, 1, true, 1000000, 30, 30, 1, 1));
					}
					else if(event.key.keysym.sym == SDLK_INSERT)
					{
						autotest = !autotest;
					}
#endif
					else if(event.key.keysym.sym == SDLK_RETURN)
					{
						if(keystates[SDLK_LALT] || keystates[SDLK_RALT])
						{
#ifndef _XBOX
							game_values.fullscreen = !game_values.fullscreen;
							gfx_setresolution(640, 480, game_values.fullscreen);
							blitdest = screen;
#endif
						}
						else
						{
							if(!showscoreboard && !game_values.exitinggame)
							{
								game_values.pausegame = !game_values.pausegame;

								if(game_values.pausegame)
									menu_shade.draw(0, 0);

								ifsoundonpause(invinciblemusic);
								ifsoundonpause(slowdownmusic);
								ifsoundonplay(pause);
							}

							if(game_values.exitinggame)
							{
								if(game_values.exityes)
								{
									if(game_values.tournament)
									{
										cleanup();
										game_values.gamestate = GS_SCOREBOARD;
										game_values.exitinggame = false;
										game_values.exityes = false;
										return;
									}
									else
									{
										quitGame = true;
									}
								}
								else
								{
									game_values.exitinggame = false;
									ifsoundonpause(invinciblemusic);
									ifsoundonpause(slowdownmusic);
								}
							}
						}
					}
					
					if(game_values.exitinggame)
					{
						if(event.key.keysym.sym == SDLK_LEFT)
							game_values.exityes = true;
						else if(event.key.keysym.sym == SDLK_RIGHT)
							game_values.exityes = false;
					}
					
				break;

#ifdef _XBOX
				case SDL_JOYHATMOTION:
				{
					if(event.jhat.which >= 0 && event.jhat.which <= 3)
					{
						if (event.jhat.value & SDL_HAT_LEFT)
							keystates[controlkeys[event.jhat.which][0]] = 1;
						else
							keystates[controlkeys[event.jhat.which][0]] = 0;

						if (event.jhat.value & SDL_HAT_RIGHT)
							keystates[controlkeys[event.jhat.which][1]] = 1;
						else
							keystates[controlkeys[event.jhat.which][1]] = 0;

						if (event.jhat.value & SDL_HAT_DOWN)
							keystates[controlkeys[event.jhat.which][3]] = 1;
						else
							keystates[controlkeys[event.jhat.which][3]] = 0;
					}

					if(game_values.exitinggame)
					{
						if(event.jhat.value & SDL_HAT_LEFT)
							game_values.exityes = true;
						else if(event.jhat.value & SDL_HAT_RIGHT)
							game_values.exityes = false;
					}

					break;
				}
				case SDL_JOYBUTTONDOWN:
				{
					if(event.jbutton.button == 9 && !game_values.pausegame)
					{
						if(showscoreboard)
						{
							if(game_values.tournament)
							{
								cleanup();
								updatescoreboard();
								game_values.gamestate = GS_SCOREBOARD;
								return;
							}
							else
							{
								quitGame = true;
							}
						}
						else
						{
							if(!game_values.pausegame && !game_values.exitinggame)
							{
								menu_shade.draw(0, 0);
								game_values.exitinggame = true;
								ifsoundonpause(invinciblemusic);
								ifsoundonpause(slowdownmusic);
							}
						}
					}
					
					if(event.jbutton.button == 8 && !showscoreboard && !game_values.exitinggame)
					{
						game_values.pausegame = !game_values.pausegame;

						if(game_values.pausegame)
							menu_shade.draw(0, 0);

						ifsoundonpause(invinciblemusic);
						ifsoundonpause(slowdownmusic);
						ifsoundonplay(pause);
					}
#ifdef _DEBUG
					if(event.jbutton.button == 4)
					{
						autotest = !autotest;
					}
#endif
					
					if(event.jbutton.button == 0) 
					{
						if(game_values.exitinggame)
						{
							if(game_values.exityes)
							{
								if(game_values.tournament)
								{
									cleanup();
									game_values.gamestate = GS_SCOREBOARD;
									game_values.exitinggame = false;
									game_values.exityes = false;
									return;
								}
								else
								{
									quitGame = true;
								}
							}
							else
							{
								game_values.exitinggame = false;
								ifsoundonpause(invinciblemusic);
								ifsoundonpause(slowdownmusic);
							}
						}
						else
						{
							if(event.jhat.which >= 0 && event.jhat.which <= 3)
							{
								keystates[controlkeys[event.jhat.which][2]] = 1;
							}
						}
					}

					if(event.jbutton.button == 1 || event.jbutton.button == 2) 
					{
						if(event.jhat.which >= 0 && event.jhat.which <= 3)
						{
							keystates[controlkeys[event.jhat.which][4]] = 1;
						}
					}

					if(event.jbutton.button == 3)
					{
						if(event.jhat.which >= 0 && event.jhat.which <= 3)
						{
							keystates[controlkeys[event.jhat.which][5]] = 1;
						}
					}

					break;
				}
				case SDL_JOYBUTTONUP:
				{
					if(event.jbutton.button == 0)
					{
						if(event.jhat.which >= 0 && event.jhat.which <= 3)
						{
							keystates[controlkeys[event.jhat.which][2]] = 0;
						}
					}

					if(event.jbutton.button == 1 || event.jbutton.button == 2)
					{
						if(event.jhat.which >= 0 && event.jhat.which <= 3)
						{
							keystates[controlkeys[event.jhat.which][4]] = 0;
						}
					}

					if(event.jbutton.button == 3)
					{
						if(event.jhat.which >= 0 && event.jhat.which <= 3)
						{
							keystates[controlkeys[event.jhat.which][5]] = 0;
						}
					}

					break;
				}
#endif

				default:
				break;
			}
		}

		if(game_values.NUMmousecontrol)
		{
			mouse = SDL_GetMouseState(&mousex, &mousey);
			if(mouse & SDL_BUTTON(1) && mouse & SDL_BUTTON(3))
				keystates[SDLK_KP5] = 1;
			else
			{
				keystates[SDLK_KP5] = 0;
				if(mouse & SDL_BUTTON(1))
					keystates[SDLK_KP1] = 1;
				else
					keystates[SDLK_KP1] = 0;
				if(mouse & SDL_BUTTON(3))
					keystates[SDLK_KP3] = 1;
				else
					keystates[SDLK_KP3] = 0;
			}
		}

		if(!game_values.pausegame && !game_values.exitinggame)
		{
			//Shake screen
			if(game_values.screenshaketimer > 0)
			{
				game_values.screenshaketimer--;

				static bool shakeleft = false;
				if(shakeleft)
				{
					x_shake -= 2;
					if(x_shake <= -2)
					{
						shakeleft = false;
					}
				}
				else
				{
					x_shake += 2;
					if(x_shake >= 2)
					{
						shakeleft = true;
					}
				}

				//Kill things touching the ground
				if(game_values.screenshakeplayer)
				{
					int k;
					for(k = 0; k < list_players_cnt; k++)
					{
						if(k == game_values.screenshakeplayer->localID)
							continue;

						if(!game_values.friendlyfire && game_values.screenshakeplayer->teamID == list_players[k]->teamID)
							continue;

						if(!list_players[k]->inair && !list_players[k]->invincible && !list_players[k]->spawninvincible && list_players[k]->isready())
						{
							stopinvincibilityfordeadplayer(k);
							killplayer(*(game_values.screenshakeplayer), *list_players[k], death_style_jump, kill_style_flag);
						}
					}

					for(k = 0; k < interactionobjectcollisionitems.list_end; k++)
					{
						if(interactionobjectcollisionitems.list[k]->getObjectType() == object_moving)
						{
							IO_MovingObject * object = (IO_MovingObject *)interactionobjectcollisionitems.list[k];
							
							if(object->getMovingObjectType() == movingobject_goomba && !object->inair)
							{
								interactionobjectcollisionitems.list[k]->dead = true;

								if(!game_values.gamemode->gameover)
									game_values.screenshakeplayer->score->score++;

								ifsoundonplay(kicksound);
								eyecandyfront.add(new EC_FallingObject(&spr_goombadeadflying, interactionobjectcollisionitems.list[k]->ix, interactionobjectcollisionitems.list[k]->iy, -VELJUMP / 2.0f));
							}
						}
					}
				}
			}

			if(game_values.bulletbilltimer > 0)
			{
				game_values.bulletbilltimer--;

				static int bulletbillspawntimer = 0;
				
				if(--bulletbillspawntimer <= 0)
				{
					bulletbillspawntimer = rand() % 20 + 25;
					float speed = ((float)(rand() % 21 + 20)) / 10.0f;
					interactionobjectsfront.add(new OMO_BulletBill(&spr_bulletbill, rand() % 448, (rand() % 2 ? speed : -speed)));
					ifsoundonplay(bulletbillsound);
				}
			}

			//------------- update objects -----------------------

			if(++game_values.cputurn > 3)
				game_values.cputurn = 0;

			//Player to player collisions
			for(i = 0; i < list_players_cnt; i++)
			{
				if(list_players[i]->isready() || list_players[i]->iswarping())
				{
					for(j = i + 1; j < list_players_cnt; j++)
					{
						if(list_players[j]->isready() || list_players[j]->iswarping())
						{
							if(coldec_player2player(*(list_players[i]), *(list_players[j])))
							{
								collisionhandler_p2p(*(list_players[i]), *(list_players[j]));
							}
						}
					}
				}
			}

			for(i = 0; i < list_players_cnt; i++)
				list_players[i]->move();	//move all objects before doing object-object collision detection in
											//->think(), so we test against the new position after object-map collision detection
			
			interactionobjectblocks.update();
			interactionobjectcollisionitems.update();
			interactionobjectsfront.update();
			interactionobjectsplayer.update();

			for(i = 0; i < list_players_cnt; i++)
			{
				//Collide with collision detected objects
				for(j = 0; j < interactionobjectcollisionitems.list_end; j++)
				{
					if(!list_players[i]->isready())
						break;

					if(!interactionobjectcollisionitems.list[j]->GetDead() && interactionobjectcollisionitems.list[j]->GetState() == 1)
					{
						if(coldec_player2obj(*(list_players[i]), *(interactionobjectcollisionitems.list[j])))
						{
							collisionhandler_p2o(*(list_players[i]), *(interactionobjectcollisionitems.list[j]));
						}
					}
				}

				//Collide with player objects
				for(j = 0; j < interactionobjectsplayer.list_end; j++)
				{
					if(!list_players[i]->isready())
						break;

					if(!interactionobjectsplayer.list[j]->GetDead())
					{
						if(coldec_player2obj(*(list_players[i]), *(interactionobjectsplayer.list[j])))
						{
							collisionhandler_p2o(*(list_players[i]), *(interactionobjectsplayer.list[j]));
						}
					}
				}

				//Collide with front objects
				for(j = 0; j < interactionobjectsfront.list_end; j++)
				{
					if(!list_players[i]->isready())
						break;

					if(!interactionobjectsfront.list[j]->GetDead())
					{
						if(coldec_player2obj(*(list_players[i]), *(interactionobjectsfront.list[j])))
						{
							collisionhandler_p2o(*(list_players[i]), *(interactionobjectsfront.list[j]));
						}
					}
				}
			}

			//moving object to moving object collisions
			for(i = 0; i < interactionobjectcollisionitems.list_end; i++)
			{
				if(!interactionobjectcollisionitems.list[i]->GetDead() && interactionobjectcollisionitems.list[i]->getObjectType() == object_moving && interactionobjectcollisionitems.list[i]->GetState() == 1)
				{
					IO_MovingObject * object = (IO_MovingObject*)interactionobjectcollisionitems.list[i];

					//collision items
					if(object->getMovingObjectType() == movingobject_fireball)
					{
						for(j = 0; j < interactionobjectcollisionitems.list_end; j++)
						{
							if(i == j)
								continue;

							if(!interactionobjectcollisionitems.list[j]->GetDead() && interactionobjectcollisionitems.list[j]->GetState() == 1)
							{
								if(coldec_obj2obj(*(interactionobjectcollisionitems.list[i]), *(interactionobjectcollisionitems.list[j])))
								{
									collisionhandler_o2o(*object, *(interactionobjectcollisionitems.list[j]));
								}
							}
						}
					}

					if(object->getMovingObjectType() == movingobject_goomba || object->getMovingObjectType() == movingobject_fireball)
					{
						for(j = 0; j < interactionobjectsfront.list_end; j++)
						{
							if(!interactionobjectsfront.list[j]->GetDead())
							{
								if(coldec_obj2obj(*(interactionobjectcollisionitems.list[i]), *(interactionobjectsfront.list[j])))
								{
									collisionhandler_o2o(*object, *(interactionobjectsfront.list[j]));
								}
							}
						}
					}
				}
			}

			//front objects to front and collision items (bullet bills to explosions and hammers to bullet bills and goombas)
			for(i = 0; i < interactionobjectsfront.list_end; i++)
			{
				if(!interactionobjectsfront.list[i]->GetDead() && interactionobjectsfront.list[i]->getObjectType() == object_moving)
				{
					IO_MovingObject * object = (IO_MovingObject*)interactionobjectsfront.list[i];
					
					if(object->getMovingObjectType() == movingobject_bulletbill || object->getMovingObjectType() == movingobject_hammer)
					{
						//bullet bills to explosions && hammers to bullet bills
						for(j = 0; j < interactionobjectsfront.list_end; j++)
						{
							if(i == j)
								continue;

							bool bulletbill = interactionobjectsfront.list[j]->getObjectType() == object_moving && ((IO_MovingObject*)interactionobjectsfront.list[j])->getMovingObjectType() == movingobject_bulletbill;

							if((interactionobjectsfront.list[j]->getObjectType() == object_explosion || bulletbill) && !interactionobjectsfront.list[j]->GetDead())
							{
								if(coldec_obj2obj(*(interactionobjectsfront.list[i]), *(interactionobjectsfront.list[j])))
								{
									collisionhandler_o2o(*object, *(interactionobjectsfront.list[j]));
								}
							}
						}

						//hammers to goombas
						for(j = 0; j < interactionobjectcollisionitems.list_end; j++)
						{
							bool goomba = interactionobjectcollisionitems.list[j]->getObjectType() == object_moving && ((IO_MovingObject*)interactionobjectcollisionitems.list[j])->getMovingObjectType() == movingobject_goomba;

							if(goomba && !interactionobjectcollisionitems.list[j]->GetDead())
							{
								if(coldec_obj2obj(*(interactionobjectsfront.list[i]), *(interactionobjectcollisionitems.list[j])))
								{
									collisionhandler_o2o(*object, *(interactionobjectcollisionitems.list[j]));
								}
							}
						}
					}
				}
			}

			eyecandyfront.cleandeadobjects();
			eyecandyback.cleandeadobjects();
			interactionobjectsfront.cleandeadobjects();
			interactionobjectsplayer.cleandeadobjects();
			interactionobjectcollisionitems.cleandeadobjects();
			interactionobjectblocks.cleandeadobjects();
			cleandeadplayers();

			eyecandyfront.update();
			eyecandyback.update();
			game_values.gamemode->think();

			if(game_values.slowdownon != -1)
			{
				if(++game_values.slowdowncounter > 580)
				{
					game_values.slowdownon = -1;
					game_values.slowdowncounter = 0;
				}
			}

			map.updateWarpLocks();

			if(y_shake > 0)
			{
				y_shake -= CRUNCHVELOCITY;

				if(y_shake < 0)
					y_shake = 0;
			}
		
			if(showscoreboard)
			{
				if(scorepercentmove < 1.0f)
				{
					scorepercentmove += 0.01f;
					
					if(scorepercentmove >= 1.0f)
						scorepercentmove = 1.0f;
				}
				else
				{
					scorepercentmove = 1.0f;
				}

				for(i = 0; i < score_cnt; i++)
				{
					score[i].x = (int)((float)(score[i].destx - score[i].fromx) * scorepercentmove) + score[i].fromx;
					score[i].y = (int)((float)(score[i].desty - score[i].fromy) * scorepercentmove) + score[i].fromy;
				}
			}

			//--------------- draw everything ----------------------

			if(y_shake > 0)
			{
				SDL_Rect rect = {0, 0, 640, y_shake};
				SDL_FillRect(screen, &rect, 0x0);		//fill empty area with black
			}

			spr_backmap.draw(0, 0);

			//draw back eyecandy behind players
			interactionobjectblocks.draw();
			eyecandyback.draw();
			interactionobjectcollisionitems.draw();

			for(i=0;i<list_players_cnt;i++)
				list_players[i]->draw();

			interactionobjectsplayer.draw();

#ifdef _XBOX
			map.drawfrontlayer();
#else
			if(game_values.toplayer)
				map.drawfrontlayer();
#endif
			map.drawWarpLocks();

			interactionobjectsfront.draw();
			eyecandyfront.draw();
			game_values.gamemode->draw();
		
			int winning = -1;
			int mostkills = 0;
			for(i = 0; i < score_cnt; i++)
			{
				if(score[i].score > mostkills)
				{
					mostkills = score[i].score;
					winning = i;
				}
				else if(score[i].score == mostkills)
				{
					winning = -1;
				}
			}
			
			//big endgame scoreboard (sorted)
			if(showscoreboard)
			{
				char gameovertext[128] = "";
				if(game_values.gamemode->winningteam > -1)
				{
					if(game_values.teamcounts[game_values.gamemode->winningteam] == 1)
						sprintf(gameovertext, "Player %d Wins!", game_values.teamids[game_values.gamemode->winningteam][0] + 1);
					else
						sprintf(gameovertext, "Team %d Wins!", game_values.gamemode->winningteam + 1);
				}
				else
				{
					sprintf(gameovertext, "Tie Game");
				}
					
				font[2].drawCentered(100, gameovertext);
			}

			//scoreboards
			for(i = 0; i < score_cnt; i++)
			{
				spr_shade[game_values.teamcounts[i] - 1].draw(score[i].x, score[i].y);

				for(int k = 0; k < game_values.teamcounts[i]; k++)
				{
					int globalID = game_values.teamids[i][k];
					if(respawn[globalID] > 0 && !game_values.gamemode->gameover)
					{
						spr_spawneggs.draw(score[i].x + scoreoffsets[k], score[i].y + 2, (respawn[globalID] - 1) * 32, game_values.colorids[globalID] * 32, 32, 32);
					}
					else
					{
						spr_player[game_values.teamids[i][k]][PGFX_STANDING_R]->draw(score[i].x + scoreoffsets[k], score[i].y + 2, 0, 0, 32, 32);
					
						//give crown to player(s) with most kills
						if(winning == i)
							spr_crown.draw(score[i].x + scoreoffsets[k] + 12, score[i].y - 3);
					}

					int storedpowerupid = game_values.gamepowerups[game_values.teamids[i][k]];

					if(storedpowerupid != -1)
						spr_storedpowerupsmall.draw(score[i].x + scorepowerupoffsets[game_values.teamcounts[i] - 1][k], score[i].y + 25, storedpowerupid * 16, 0, 16, 16);
				}
				
				font[2].drawf(score[i].x + 4 + 34 * game_values.teamcounts[i], score[i].y + 1, "%.3d", score[i].score);
			}

			for(i=0;i<list_players_cnt;i++)
				list_players[i]->drawarrows();
		}
		else
		{
			if(game_values.pausegame)
			{
				spr_dialog.draw(224, 176);
				font[2].drawCentered(240 - (font[2].getHeight() >> 1), "Pause");
			}

			if(game_values.exitinggame)
			{
				spr_dialog.draw(224, 176);
				font[2].drawCentered(220 - (font[2].getHeight() >> 1), "Exit Game");

				spr_dialogbutton.draw(235, 250, 0, (game_values.exityes ? 34 : 0), 80, 34);
				spr_dialogbutton.draw(325, 250, 0, (game_values.exityes ? 0 : 34), 80, 34);
			
				font[2].draw(275 - (font[2].getWidth("Yes") >> 1),  269 - (font[2].getHeight() >> 1), "Yes");
				font[2].draw(365 - (font[2].getWidth("No") >> 1),  269 - (font[2].getHeight() >> 1), "No");
			}
		}

		ticks = SDL_GetTicks() - framestart;
		if(ticks == 0)
			ticks = 1;

		if(game_values.showfps) 
			font[2].drawf(0, 480-font[2].getHeight(), "Actual:%.1f/%.1f, Flip:%.1f, Potential:%.1f", realfps, 1000.0f / (float)WAITTIME, flipfps, 1000.0f / (float)ticks);

#ifdef _DEBUG
	if(autotest)
		font[0].drawRightJustified(635, 5, "Auto");
#endif
 
		//double buffering -> flip buffers
		SDL_Flip(screen);

		flipfps = 1000.0f / (float)ticks;

		
		//Sleep for time just under what we need
		int delay = WAITTIME - SDL_GetTicks() + framestart - 2;

		if(delay > 0)
		{
			if(delay > WAITTIME)
				delay = WAITTIME;
			
			SDL_Delay(delay);
		}

		//Fine tune wait here
		while(SDL_GetTicks() - framestart < WAITTIME)
			SDL_Delay(0);   //keep framerate constant at 1000/WAITTIME fps

#ifdef _DEBUG
		if(game_values.frameadvance)
			while(SDL_GetTicks() - framestart < 1000);
#endif

		ticks = SDL_GetTicks() - framestart;
		if(ticks == 0)
			ticks = WAITTIME;

		realfps = 1000.0f / (float)ticks;

		/*
		static float avgFPS = 0.0f;
		static int outputtimer = 0;

		avgFPS += realfps;

		if(++outputtimer == 60)
		{
			FILE * out = fopen("fps.txt", "a+");

			fprintf(out, "%.2f\n", avgFPS / (float)outputtimer);

			fclose(out);

			avgFPS = 0.0f;
			outputtimer = 0;
		}
		*/
	}

	
	//we never get here

	return;
}

void cleanup()
{
	int i;
	//delete object list
	for(i = 0; i < list_players_cnt; i++)
	{
		delete list_players[i];
	}
	list_players_cnt = 0;

	eyecandyfront.clean();
	eyecandyback.clean();
	interactionobjectsfront.clean();
	interactionobjectsplayer.clean();
	interactionobjectcollisionitems.clean();
	interactionobjectblocks.clean();
	loadInteractionMapObjects();
	map.clearWarpLocks();

	//Stop all game sounds
	sfx_stopallsounds();
	invinciblemusic.resetpause();
	slowdownmusic.resetpause();
}

void updatescoreboard()
{
	int maxScore = -1;
	int maxTeam = -1;

	for(int i = 0; i < score_cnt; i++)
	{
		if(score[i].score > maxScore)
		{
			maxScore = score[i].score;
			maxTeam = i;
		}
		else if(score[i].score == maxScore)
		{
			maxTeam = -1;
		}
	}

	if(maxTeam > -1)
	{
		tournament_scores[maxTeam].type[tournament_scores[maxTeam].wins] = currentgamemode;

		if(++tournament_scores[maxTeam].wins >= game_values.tournamentgames)
		{
			game_values.tournamentwinner = maxTeam;
			
			if(game_values.music)
			{
				backgroundmusic[4].play(true, true);
			}
		}
	}
}

bool coldec_player2player(CPlayer &o1, CPlayer &o2)
{
	//Special cases to deal with players overlapping the right and left sides of the screen
	if(o1.ix + PW < 320 && o2.ix > 320)
	{
		if (o1.ix + 640 > o2.ix + PW || o1.ix + PW + 640 < o2.ix || o1.iy > o2.iy + PH || o1.iy + PH < o2.iy) 
			return false;
		else 
			return true;
	}
	else if(o2.ix + PW < 320 && o1.ix > 320)
	{
		if (o1.ix > o2.ix + PW + 640 || o1.ix + PW < o2.ix + 640 || o1.iy > o2.iy + PH || o1.iy + PH < o2.iy) 
			return false;
		else 
			return true;
	}
	else  //Normal case where no overlap
	{
		if (o1.ix > o2.ix+PW || o1.ix+PW < o2.ix || o1.iy > o2.iy+PH || o1.iy+PH < o2.iy) 
			return false;
		else 
			return true;
	}

	return false;
}

bool coldec_player2obj(CPlayer &o1, CInteractionObject &o2)
{
	//Special cases to deal with players overlapping the right and left sides of the screen
	if(o1.ix + PW < 320 && o2.ix > 320)
	{
		if (o1.ix + 640 > o2.ix + o2.collisionWidth || o1.ix + PW + 640 < o2.ix || o1.iy > o2.iy + o2.collisionHeight || o1.iy + PH < o2.iy) 
			return false;
		else 
			return true;
	}
	else if(o2.ix + o2.collisionWidth < 320 && o1.ix > 320)
	{
		if (o1.ix > o2.ix + o2.collisionWidth + 640 || o1.ix + PW < o2.ix + 640 || o1.iy > o2.iy + o2.collisionHeight || o1.iy + PH < o2.iy) 
			return false;
		else 
			return true;
	}
	else //Normal case where no overlap
	{
		if (o1.ix > o2.ix + o2.collisionWidth || o2.ix > o1.ix + PW || o1.iy > o2.iy + o2.collisionHeight || o2.iy > o1.iy + PH) 
			return false;
		else 
			return true;
	}

	return false;
}

/*
bool coldec_player2objCentered(CPlayer &o1, CInteractionObject &o2)
{
	int x1 = o1.ix + HALFPW; //Center X
	int y1 = o1.iy + HALFPH; //Center Y
	
	int l1 = o1.ix;		//left
	int r1 = l1 + PW;	//right
	int t1 = o1.iy;		//top
	int b1 = t1 + PH;	//bottom

	int l2 = o2.ix;
	int r2 = l2 + o2.collisionWidth;
	int t2 = o2.iy;
	int b2 = t2 + o2.collisionHeight;

	//Special cases to deal with players overlapping the right and left sides of the screen
	if(o1.ix + PW < 320 && o2.ix > 320)
	{
		if ((x1 + 640 > r2 || x1 + 640 < l2 || t1 > b2 || t2 > b1) && (y1 > b2 || y1 < t2 || l1 + 640 > r2 || l2 > r1 + 640))
			return false;
		else 
			return true;
	}
	else if(o2.ix + o2.collisionWidth < 320 && o1.ix > 320)
	{
		if ((x1 > r2 + 640 || x1 < l2 + 640 || t1 > b2 || t2 > b1) && (y1 > b2 || y1 < t2 || l1 > r2 + 640 || l2 + 640 > r1))
			return false;
		else 
			return true;
	}
	else //Normal case where no overlap
	{
		if ((x1 > r2 || x1 < l2 || t1 > b2 || t2 > b1) && (y1 > b2 || y1 < t2 || l1 > r2 || l2 > r1))
			return false;
		else 
			return true;
	}

	return false;
}
*/

bool coldec_obj2obj(CInteractionObject &o1, CInteractionObject &o2)
{
	//Special cases to deal with players overlapping the right and left sides of the screen
	int o1r = o1.ix + o1.collisionWidth;
	int o1b = o1.iy + o1.collisionHeight;
	int o2r = o2.ix + o2.collisionWidth;
	int o2b = o2.iy + o2.collisionHeight;

	if(o1r < 320 && o2.ix > 320)
	{
		if (o1.ix + 640 > o2r || o1r + 640 < o2.ix || o1.iy > o2b || o1b < o2.iy) 
			return false;
		else 
			return true;
	}
	else if(o2r < 320 && o1.ix > 320)
	{
		if (o1.ix > o2r + 640 || o1r < o2.ix + 640 || o1.iy > o2b || o1b < o2.iy)
			return false;
		else 
			return true;
	}
	else
	{
		if (o1.ix > o2r || o2.ix > o1r || o1.iy > o2b || o2.iy > o1b) 
			return false;
		else 
			return true;
	}

	return false;
}

void loadInteractionMapObjects()
{
	interactionobjectblocks.clean();
	
	for(int x = 0; x < MAPWIDTH; x++)
	{
		for(int y = 0; y < MAPHEIGHT; y++)
		{
			if(map.interactionobjectdata[x][y] == 0)
			{
				map.blockdata[x][y] = new B_BreakableBlock(&spr_breakableblock, x * TILESIZE, y * TILESIZE, 4, 10);
				interactionobjectblocks.add(map.blockdata[x][y]);
			}
			else if(map.interactionobjectdata[x][y] == 1)
			{
				map.blockdata[x][y] = new B_PowerupBlock(&spr_powerupblock, x * TILESIZE, y * TILESIZE, 4, 10);
				interactionobjectblocks.add(map.blockdata[x][y]);
			}
			else if(map.interactionobjectdata[x][y] == 2)
			{
				map.blockdata[x][y] = new B_DonutBlock(&spr_donutblock, x * TILESIZE, y * TILESIZE);
				interactionobjectblocks.add(map.blockdata[x][y]);
			}
			else if(map.interactionobjectdata[x][y] == 3)
			{
				map.blockdata[x][y] = new B_FlipBlock(&spr_flipblock, x * TILESIZE, y * TILESIZE);
				interactionobjectblocks.add(map.blockdata[x][y]);
			}
			else if(map.interactionobjectdata[x][y] == 4)
			{
				map.blockdata[x][y] = new B_BounceBlock(&spr_bounceblock, x * TILESIZE, y * TILESIZE);
				interactionobjectblocks.add(map.blockdata[x][y]);
			}
			else if(map.interactionobjectdata[x][y] == 5)
			{
				map.blockdata[x][y] = new B_NoteBlock(&spr_noteblock, x * TILESIZE, y * TILESIZE, 4, 10);
				interactionobjectblocks.add(map.blockdata[x][y]);
			}
			else
			{
				map.blockdata[x][y] = NULL;
			}
		}
	}
}
