
#include "global.h"
#include <math.h>

#ifdef _XBOX
	#include <xtl.h>
#endif

#ifdef _WIN32
	#ifndef _XBOX
		#include "windows.h"
	#endif
#endif

extern void _load_waitforkey();
extern bool __load_gfxck(gfxSprite &g, const char *f);
extern bool __load_gfx(gfxSprite &g, const char *f);

#define _load_gfx(g,f)		if(!__load_gfx(g,f)){_load_waitforkey();return false;};

enum MenuMode {menu_mode_normal = 0, menu_mode_player_select = 1, menu_mode_screen_resize = 2};

//-----------------------------------------------------------------------------
// THE NOW LESS STATIC BUT STILL WEIRD MENU
//-----------------------------------------------------------------------------

//i rewrote the whole menu code, but it's still a mess..,
//but it's now easier to add new menu items

#define BOOL2ONOFF(x) ( (x) == true ? "On" : "Off" )

bool backgroundonly = false;
bool fastmap = false;

/*
#ifdef _XBOX
extern void reconnectjoysticks();
extern int joystickcount;
#endif
*/

extern void loadInteractionMapObjects();
extern char *convertPath(char *source);
bool loadfullskin(gfxSprite ** sprites, int skinID, int colorID);
bool loadmenuskin(int playerID, int skinID, int colorID);
void findnewteam(int id, int scandirection);
int lookupteamid(int playerID);
void writegameoptions();


//---------------------------------------------------------------
// MAIN MENU
//---------------------------------------------------------------

class MenuItem
{
	public:
		MenuItem() {strcpy(description, "");};
		virtual ~MenuItem() {};
		virtual bool left(){return false;};
		virtual bool right(){return false;};
		virtual bool enter(MenuID menuID){return false;};
		virtual bool random(){return false;};
		virtual int draw(const int x1, const int x2, const int y){return y;};

		MenuItem* next(){return mnext;};
		MenuItem* prev(){return mprev;};

		void setnext(MenuItem *m){ m->mprev = this; mnext = m;};

		char * getDescription() {return description;}

	protected:
		char description[128];

	private:
		MenuItem* mprev;
		MenuItem* mnext;
};

//---------------------------------------------------------------
// SUPER CRAZY OPTIONS/MAIN MENU SYSTEM
//---------------------------------------------------------------

MenuItem	*currentmenuhead;
MenuItem	*currentitem;

MenuItem	*head_optionsmenu;
MenuItem	*head_mainmenu;

MenuMode	menumode = menu_mode_normal;

int			options_menu_selected_index = 0;
int			options_menu_total_items = 0;
float		goalmenuy = 50.0f;
float		menuy = 0.0f;
extern bool	autotest;

void menu_setmenu(MenuItem *newhead)
{
	currentmenuhead = newhead;
	currentitem = newhead;
}


bool menu_startgame()
{
	game_values.gamestate = GS_GAME;
	backgroundonly = false;
	fastmap = false;

	writegameoptions();

	//Load skins for players
	for(int k = 0; k < 4; k++)
	{
		if(game_values.playercontrol[k] > 0)
		{
			loadfullskin(spr_player[k], game_values.skinids[k], game_values.colorids[k]);
		}
	}

	//Load announcer sounds if changed
	if(game_values.loadedannouncer != announcerlist.GetCurrentIndex())
	{
		game_values.loadedannouncer = announcerlist.GetCurrentIndex();

		//Delete the old sounds
		for(int k = 0; k < PANNOUNCER_SOUND_LAST; k++)
			announcer[k].reset();

		FILE * announcerfile = fopen(announcerlist.current_name(), "r");
		
		char szBuffer[256];

		int announcerIndex = 0;

		while(fgets(szBuffer, 256, announcerfile) && announcerIndex < PANNOUNCER_SOUND_LAST)
		{
			//Ignore comment lines
			if(szBuffer[0] == '#' || szBuffer[0] == ' ' || szBuffer[0] == '\t' || szBuffer[0] == '\n' || szBuffer[0] == '\r')
				continue;

			//Clean off carriage returns
			for(int k = 0; k < (int)strlen(szBuffer); k++)
			{
				if(szBuffer[k] == '\r' || szBuffer[k] == '\n')
				{
					szBuffer[k] = '\0';
					break;
				}
			}

			if(!strcmp(szBuffer, "[none]"))
				announcerIndex++;
			else
				announcer[announcerIndex++].init(convertPath(szBuffer));

		}

		fclose(announcerfile);
	}
	
	//Load announcer sounds if changed
	if(game_values.loadedmusic != musiclist.GetCurrentIndex())
	{
		game_values.loadedmusic = musiclist.GetCurrentIndex();
		backgroundmusic[1].load(musiclist.GetMusic(0));
		backgroundmusic[3].load(musiclist.GetMusic(2));
		backgroundmusic[4].load(musiclist.GetMusic(3));
	}

	if(game_values.music)
	{
		//musicplaylist.random();
		//backgroundmusic[0].load(musicplaylist.current_name());
		musiclist.SetRandomMusic(map.backgroundID);
		backgroundmusic[0].load(musiclist.GetCurrentMusic());
		backgroundmusic[0].play(false, false);
	}
	
	ifsoundonandreadyplay(announcer[11]);
	return true;
}

bool menu_startnewgame()
{
	menumode = menu_mode_normal;

	game_values.tournamentwinner = -1;
	game_values.powerupselectdone = false;

	if(game_values.tournamentgames == 1)
	{
		game_values.tournament = false;
	}
	else
	{
		for(int k = 0; k < 4; k++)
			tournament_scores[k].wins = 0;

		game_values.tournament = true;
	}

	return menu_startgame();
}

bool menu_startplayerselect()
{
	for(int k = 0; k < 4; k++)
	{
		game_values.teamids[k][0] = k;

		if(game_values.playercontrol[k] > 0)
			game_values.teamcounts[k] = 1;
		else
			game_values.teamcounts[k] = 0;
	}
	
	menumode = menu_mode_player_select;
	return false;
}

bool menu_exit()
{
	game_values.gamestate = GS_QUIT;
	writegameoptions();
	return true;
}

void writegameoptions()
{
	FILE *fp;
#ifdef _XBOX
	fp = fopen("D:\\options.bin", "wb");
#else
	fp = fopen("options.bin", "wb");
#endif

	if(fp != NULL)
	{

#ifdef _XBOX
		fwrite(&game_values.screenResizeX, sizeof(int), 1, fp);
		fwrite(&game_values.screenResizeY, sizeof(int), 1, fp);
		fwrite(&game_values.screenResizeW, sizeof(int), 1, fp);
		fwrite(&game_values.screenResizeH, sizeof(int), 1, fp);
#endif
		unsigned char abyte[15];
		abyte[0] = (unsigned char) game_values.spawnstyle;
		abyte[1] = (unsigned char) game_values.awardstyle;
		abyte[2] = (unsigned char) announcerlist.GetCurrentIndex();
		abyte[3] = (unsigned char) game_values.friendlyfire;
		abyte[4] = (unsigned char) game_values.screencrunch;
		abyte[5] = (unsigned char) game_values.toplayer;
		abyte[6] = (unsigned char) game_values.scoreboardstyle;
		abyte[7] = (unsigned char) game_values.teamcolors;
		abyte[8] = (unsigned char) game_values.sound;
		abyte[9] = (unsigned char) game_values.music;
		abyte[10] = (unsigned char) game_values.spawninvincibility;
		abyte[11] = (unsigned char) game_values.musicvolume;
		abyte[12] = (unsigned char) game_values.soundvolume;
		abyte[13] = (unsigned char) game_values.respawn;
		abyte[14] = (unsigned char) musiclist.GetCurrentIndex();
		fwrite(abyte, 15, 1, fp); 

#ifndef _XBOX
		fwrite(&game_values.fullscreen, sizeof(bool), 1, fp);
#endif
		for(int k = 0; k < GAMEMODE_LAST; k++)
			fwrite(&(gamemodes[k]->goal), sizeof(int), 1, fp);

		fclose(fp);
	}
}

bool tournament_exit()
{
	game_values.exitinggame = false;
	game_values.gamestate = GS_MENU;
	game_values.tournamentwinner = -1;
	game_values.powerupselectdone = false;
	eyecandyfront.clean();

	for(int k = 0; k < 4; k++)
	{
		game_values.colorids[k] = k;
		loadmenuskin(k, game_values.skinids[k], game_values.colorids[k]);
	}

	return true;
}

void setuppowerupselector()
{
	//1up, flower, star, clock, bobomb, pow, bullet, hammer
	int powerupweights[8] = {25, 25, 20, 10, 10, 5, 5, 10};

	int randpowerup = rand() % 110;
	int powerupindex = 0;
	int powerupweightcount = powerupweights[0];

	while(powerupweightcount < randpowerup)
		powerupweightcount += powerupweights[++powerupindex];

	game_values.powerupselector.selectoranimation = 0;
	game_values.powerupselector.selectoranimationcounter = 0;
	game_values.powerupselector.selectionspeed = 0.0f;
	game_values.powerupselector.selectedpowerup = powerupindex;
	game_values.powerupselector.selectionangle = (float)(game_values.powerupselector.selectedpowerup) * TWO_PI / 8.0f;

	//wind back the selectionangle
	int windback = rand() % 50 + 250;
	for(int i = 0; i < windback; i++)
	{
		game_values.powerupselector.selectionangle -= game_values.powerupselector.selectionspeed;
		game_values.powerupselector.selectionspeed += 0.0005f;
	}
}

class MI_Start : public MenuItem
{
	public:
        virtual ~MI_Start() {};
		bool enter(MenuID menuID)
		{
			if(menuID == menu_id_tournament)
				return menu_startgame();

			return menu_startplayerselect();
		};

		int draw(const int x1, const int x2, const int y)
		{
			font[2].draw(x1, y, "Start");
			return y + MENUSPACING + (game_values.gamestate == GS_SCOREBOARD ? 0 : MENUSPACING / 6);
		};
};

class MI_Players : public MenuItem
{
	public:
        virtual ~MI_Players() {};
		int selectedPlayer;
		MI_Players()
		{
			selectedPlayer = 0;
		};

		bool left()
		{
			if(selectedPlayer > 0)
				selectedPlayer--;

			return false;
		};

		bool right()
		{
			if(selectedPlayer < 3)
				selectedPlayer++;

			return false;
		};
		
		bool enter(MenuID menuID)
		{
			if(game_values.playercontrol[selectedPlayer] == 2)
			{
				int count = 0;
				for(int k = 0; k < 4; k++)
				{
					if(game_values.playercontrol[k] > 0)
						count++;
				}

				if(count <= 2)
				{
					game_values.playercontrol[selectedPlayer] = 1;
					return false;
				}
			}

			if(++game_values.playercontrol[selectedPlayer] > 2)
				game_values.playercontrol[selectedPlayer] = 0;

			return false;
		};
	
		int draw(const int x1, const int x2, const int y)
		{
			font[2].draw(x1, y, "Players");

			int i;
			for(i = 0; i < 4; i++)
			{
				if(game_values.playercontrol[i] == 0)
				{
					menu_mario.draw(x2 + i*40, y-6, (selectedPlayer == i && currentitem == this ? 32 : 0), 0, 32, 32);
				}
				else
				{
					spr_player[i][PGFX_STANDING_R]->draw(x2 + i*40, y-6, (selectedPlayer == i  && currentitem == this ? 128 : 0), 0, 32, 32);
					
					if(game_values.playercontrol[i] == 2)
						menu_cpu.draw(x2 + i*40, y-6);
				}
			}

			return y + MENUSPACING;
		};

};

bool loadmap()
{
	map.loadMap(maplist.current_name());
	SDL_Delay(5);  //Sleeps to help the music from skipping
	
	char filename[128];
	sprintf(filename, "gfx/backgrounds/bg%d.bmp", map.backgroundID);
	_load_gfx(spr_background, convertPath(filename));
	SDL_Delay(5);
	
	map.predrawbackground(spr_background, spr_backmap);
	SDL_Delay(5);
	map.predrawforeground(spr_frontmap);
	SDL_Delay(5);

	loadInteractionMapObjects();
	SDL_Delay(5);

	blitdest = menu_backdrop.getSurface();
	spr_backmap.draw(0, 0);
	SDL_Delay(5);
	interactionobjectblocks.draw();
	SDL_Delay(5);

#ifdef _XBOX
	map.drawfrontlayer();
	SDL_Delay(5);
#else
	if(game_values.toplayer)
	{
		map.drawfrontlayer();
		SDL_Delay(5);
	}
#endif
	menu_shade.draw(0, 0);
	SDL_Delay(5);
	blitdest = screen;

	return false;
}

class MI_Map : public MenuItem
{
	public:
        virtual ~MI_Map() {};
		bool left()
		{
			int numadvance = 1;
			if(fastmap)
				numadvance = 10;

			for(int k = 0; k < numadvance; k++)
				maplist.prev();

			return loadmap();
		};

		bool right()
		{
			int numadvance = 1;
			if(fastmap)
				numadvance = 10;

			for(int k = 0; k < numadvance; k++)
				maplist.next();

			return loadmap();
		};

		bool enter(MenuID menuID)
		{
			backgroundonly = false;
			fastmap = false;

			if(menuID == menu_id_tournament)
				return menu_startgame();
			
			return menu_startplayerselect();
        };

		bool random()
		{
		    //random map
            maplist.random();
            return loadmap();
        };

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "Map");
			font[2].drawChopRight(x2, y, 261, maplist.current_key());

			return y + MENUSPACING;
		};
};

class MI_Mode : public MenuItem
{
	public:
        virtual ~MI_Mode() {};
		bool left()
		{
			currentgamemode--;
			if(currentgamemode < 0)
			{
				if(game_values.tournament)
					currentgamemode = GAMEMODE_LAST-2;
				else
					currentgamemode = GAMEMODE_LAST-1;
			}
			game_values.gamemode = gamemodes[currentgamemode];
			return false;
		};

		bool right()
		{
			currentgamemode++;
			
			if(game_values.tournament)
            {
				if(currentgamemode >= GAMEMODE_LAST - 1)
					currentgamemode = 0;
            }
			else
            {
				if(currentgamemode >= GAMEMODE_LAST)
					currentgamemode = 0;
            }

			game_values.gamemode = gamemodes[currentgamemode];
			return false;
		};

		bool enter(MenuID menuID)
		{
			game_values.gamemode->toggleoptions();
			return false;
		};

		bool random()
		{
			int randommode = currentgamemode;
			
			if(game_values.tournament)
				while(randommode == currentgamemode)
					randommode = rand() % (GAMEMODE_LAST - 1);
			else
				while(randommode == currentgamemode)
					randommode = rand() % GAMEMODE_LAST;

			currentgamemode = randommode;
			game_values.gamemode = gamemodes[currentgamemode];
			return false;
		}

		int draw(const int x1, const int x2, const int y)
		{
			char buffer64[64];

			font[2].drawf(x1, y, "Mode");
			menu_mode.draw(x2, y + 3, currentgamemode * 16, 0, 16, 16);
			font[2].drawf(x2 + 18, y, "%s", game_values.gamemode->getMenuString(buffer64));
			

			return y + MENUSPACING;
		};
};

class MI_Tournament : public MenuItem
{
	public:
        virtual ~MI_Tournament() {};
		bool left()
		{
			if(--game_values.tournamentgames < 1)
				game_values.tournamentgames = 10;
            game_values.tournament = (game_values.tournamentgames != 1);

			if(game_values.tournament && currentgamemode == GAMEMODE_LAST - 1)
			{
				currentgamemode = 0;
				game_values.gamemode = gamemodes[currentgamemode];
			}

			return false;
		};
		bool right()
		{
			if(++game_values.tournamentgames > 10)
				game_values.tournamentgames = 1;
            game_values.tournament = (game_values.tournamentgames != 1);

			if(game_values.tournament && currentgamemode == GAMEMODE_LAST - 1)
			{
				currentgamemode = 0;
				game_values.gamemode = gamemodes[currentgamemode];
			}


			return false;
		};

		bool random()
		{
			int randomtournament = game_values.tournamentgames;
			while(randomtournament == game_values.tournamentgames)
				randomtournament = rand() % 10 + 1;

			game_values.tournamentgames = randomtournament;
            game_values.tournament = (game_values.tournamentgames != 1);

			if(game_values.tournament && currentgamemode == GAMEMODE_LAST - 1)
			{
				currentgamemode = 0;
				game_values.gamemode = gamemodes[currentgamemode];
			}


			return false;
		}
		
		bool enter(MenuID menuID)
		{
			return menu_startplayerselect();
		};

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "Match");

			char tournamentString[32];
			if(game_values.tournamentgames == 1)
				sprintf(tournamentString, "Single Game");
			else
				sprintf(tournamentString, "Tournament %d", game_values.tournamentgames);

			font[2].drawf(x2, y, "%s", tournamentString);

			return y + MENUSPACING;
		};
};

class MI_Options : public MenuItem
{
	public:
        virtual ~MI_Options() {};

		bool enter(MenuID menuID)
		{	
			menu_setmenu(head_optionsmenu);
			options_menu_selected_index = 0;
			goalmenuy = 50.0f;
			menuy = 50.0f;

			return false;
		};

		int draw(const int x1, const int x2, const int y)
		{
			font[2].draw(x1, y, "Options");
			return y + MENUSPACING + MENUSPACING / 6;
		};
};

class MI_Exit : public MenuItem
{
	public:
		
        virtual ~MI_Exit() {};

		bool enter(MenuID menuID)
		{
#ifndef _XBOX
			return menu_exit();
#else
			return true;
#endif
		};
		
		int draw(const int x1, const int x2, const int y)
		{
			font[2].draw(x1, y, "Exit");
			return y;
		};
};


//---------------------------------------------------------------
// OPTIONS MENU
//---------------------------------------------------------------

class MI_ToggleBool : public MenuItem
{
	public:
        virtual ~MI_ToggleBool() {};
		MI_ToggleBool(char *nname, char *ndescription, bool *nb)
		{
			name = nname;
			strcpy(description, ndescription);
			b = nb;
		};

		bool left(){	*b = !(*b);		return false;	};
		bool right(){	*b = !(*b);		return false;	};
		bool enter(MenuID menuID){	*b = !(*b);		return false;	};

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "%s", name);
			font[2].drawf(x2, y, "%s", BOOL2ONOFF(*b));
			return y + MENUSPACING;
		};
	
	protected:
		char *name;
		bool *b;
};

class MI_ToggleMusic : public MenuItem
{
	public:
        virtual ~MI_ToggleMusic() {};
		MI_ToggleMusic()
		{
			strcpy(description, "Set music volume or turn on and off.");
		};

		bool left()
		{	
			if(game_values.musicvolume > 16)
			{
				game_values.musicvolume -= 16;
				sfx_setmusicvolume(game_values.musicvolume);
			}
			else if(game_values.musicvolume > 0)
			{
				game_values.musicvolume -= 16;
				game_values.music = false;
				backgroundmusic[2].stop();
			}
			
			return false;	
		};

		bool right()
		{	
			if(!game_values.music)
			{
				game_values.music = true;
				backgroundmusic[2].play(false, false);
			}

			if(game_values.music && game_values.musicvolume < 128)
			{
				game_values.musicvolume += 16;
				sfx_setmusicvolume(game_values.musicvolume);
			}

			return false;	
		};

		bool enter(MenuID menuID)
		{
			return right();
		};

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "Music");
			
			if(game_values.music)
			{
				menu_slider_bar.draw(x2 + 10, y + 2);
				spr_awardkillsinrow[0].draw(x2 - 22 + (game_values.musicvolume >> 4) * 24, y + 1, ((game_values.musicvolume >> 4) - 1) * 16, 0, 16, 16);
			}
			else
			{
				font[2].draw(x2, y, "Off");
			}

			return y + MENUSPACING;
		};
};


class MI_ToggleSound : public MenuItem
{
	public:
        virtual ~MI_ToggleSound() {};
		MI_ToggleSound()
		{
			strcpy(description, "Set sound volume or turn on and off.");
		};

		bool left()
		{	
			if(game_values.soundvolume > 16)
			{
				game_values.soundvolume -= 16;
				sfx_setsoundvolume(game_values.soundvolume);
				ifsoundonplay(coin);
			}
			else if(game_values.soundvolume > 0)
			{
				game_values.soundvolume -= 16;
				game_values.sound = false;
			}

			return false;	
		};

		bool right()
		{	
			game_values.sound = true;

			if(game_values.soundvolume < 128)
			{
				game_values.soundvolume += 16;
				sfx_setsoundvolume(game_values.soundvolume);
				ifsoundonplay(coin);
			}

			return false;	
		};

		bool enter(MenuID menuID)
		{
			return right();
		};

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "Sound");
			
			if(game_values.sound)
			{
				menu_slider_bar.draw(x2 + 10, y + 2);
				spr_awardkillsinrow[0].draw(x2 - 22 + (game_values.soundvolume >> 4) * 24, y + 1, ((game_values.soundvolume >> 4) - 1) * 16, 0, 16, 16);
			}
			else
			{
				font[2].draw(x2, y, "Off");
			}

			return y + MENUSPACING;
		};
};

#ifndef _XBOX

class MI_Fullscreen : public MenuItem
{
	public:
        virtual ~MI_Fullscreen() {};
		MI_Fullscreen()
		{
			strcpy(description, "Switch between windowed and full screen.");
		};

		bool enter(MenuID menuID)
		{
			game_values.fullscreen = !game_values.fullscreen;
			gfx_setresolution(640, 480, game_values.fullscreen);
			blitdest = screen;
			return false;
		};

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "Fullscreen");
			font[2].drawf(x2, y, "%s", BOOL2ONOFF(game_values.fullscreen));

			return y + MENUSPACING;
		};
};
#endif

#ifdef _XBOX

class MI_ScreenResize : public MenuItem
{
	public:
        virtual ~MI_ScreenResize() {};
		MI_ScreenResize()
		{
			strcpy(description, "Select to resize the screen to your television.");
		};

		bool enter(MenuID menuID)
		{
			menumode = menu_mode_screen_resize;
			return false;
		};

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "Resize");
			font[2].drawf(x2, y, "%d,%d %d,%d", (int)game_values.screenResizeX, (int)game_values.screenResizeY, (int)game_values.screenResizeW, (int)game_values.screenResizeH);
			return y + MENUSPACING;
		};
};
#endif

class MI_SpawnStyle : public MenuItem
{
	public:
        virtual ~MI_SpawnStyle() {};
		MI_SpawnStyle()
		{
			strcpy(description, "Style of how players spawn.");
		};

		bool left()
		{
			if(--game_values.spawnstyle < 0)
				game_values.spawnstyle = 2;

			return false;
		};
		bool right()
		{
			if(++game_values.spawnstyle > 2)
				game_values.spawnstyle = 0;

			return false;
		};
		
		bool enter(MenuID menuID)
		{
			return right();
		};

		bool random()
		{
			int randomspawn = game_values.spawnstyle;
			while(randomspawn == game_values.spawnstyle)
				randomspawn = rand() % 3;

			game_values.spawnstyle = randomspawn;
			return false;
		}

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "Spawn");
			
			char *stylenames[3] = {"Instant", "Door", "Swirl"};
			font[2].drawf(x2, y, "%s", stylenames[game_values.spawnstyle]);

			return y + MENUSPACING;
		};
};

class MI_AwardStyle : public MenuItem
{
	public:
        virtual ~MI_AwardStyle() {};
		MI_AwardStyle()
		{
			strcpy(description, "Style of the kills in a row awards.");
		};

		bool left()
		{
			if(--game_values.awardstyle < 0)
				game_values.awardstyle = 5;

			return false;
		};
		bool right()
		{
			if(++game_values.awardstyle > 5)
				game_values.awardstyle = 0;

			return false;
		};
		
		bool enter(MenuID menuID)
		{
			return right();
		};

		bool random()
		{
			int randomaward = game_values.awardstyle;
			while(randomaward == game_values.awardstyle)
				randomaward = rand() % 6;

			game_values.awardstyle = randomaward;
			return false;
		}

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "Awards");
			
			char *stylenames[6] = {"None", "Fireworks", "Spiral", "Ring", "Souls", "Text"};
			font[2].drawf(x2, y, "%s", stylenames[game_values.awardstyle]);

			return y + MENUSPACING;
		};
};

class MI_ScoreStyle : public MenuItem
{
	public:
        virtual ~MI_ScoreStyle() {};
		MI_ScoreStyle()
		{
			strcpy(description, "Placement of the game scores.");
		};

		bool left()
		{
			if(--game_values.scoreboardstyle < 0)
				game_values.scoreboardstyle = 2;

			return false;
		};
		bool right()
		{
			if(++game_values.scoreboardstyle > 2)
				game_values.scoreboardstyle = 0;

			return false;
		};
		
		bool enter(MenuID menuID)
		{
			return right();
		};

		bool random()
		{
			int randomscore = game_values.scoreboardstyle;
			while(randomscore == game_values.scoreboardstyle)
				randomscore = rand() % 3;

			game_values.scoreboardstyle = randomscore;
			return false;
		}

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "Scores");
			
			char *stylenames[3] = {"Top", "Bottom", "Corners"};
			font[2].drawf(x2, y, "%s", stylenames[game_values.scoreboardstyle]);

			return y + MENUSPACING;
		};
};

class MI_Announcer : public MenuItem
{
	public:
        virtual ~MI_Announcer() {};
		MI_Announcer()
		{
			strcpy(description, "Style of the voice that plays for awards.");
		};

		bool left()
		{
			announcerlist.prev();
			return false;
		};

		bool right()
		{
			announcerlist.next();
			return false;
		};

		bool enter(MenuID menuID)
		{
			announcerlist.next();
			return false;
        };

		bool random()
		{
		    //random map
            announcerlist.random();
            return false;
        };

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "Announcer");

			char announcername[64];
#ifdef _XBOX
			sprintf(announcername, announcerlist.current_name()+17);
#else
			sprintf(announcername, announcerlist.current_name()+14);
#endif

			for(int i = (int)strlen(announcername); i >= 0; i--)
			{
				if(announcername[i] == '.')
				{
					announcername[i] = '\0';
					break;
				}
			}

			font[2].drawChopRight(x2, y, 241, announcername);

			return y + MENUSPACING;
		};
};

class MI_Playlist : public MenuItem
{
	public:
        virtual ~MI_Playlist() {};
		MI_Playlist()
		{
			strcpy(description, "Music playlist choices.");
		};

		bool left()
		{
			musiclist.prev();
			backgroundmusic[2].stop();
			backgroundmusic[2].load(musiclist.GetMusic(1));
			
			if(game_values.music)
				backgroundmusic[2].play(false, false);
			
			return false;
		};

		bool right()
		{
			musiclist.next();
			backgroundmusic[2].stop();
			backgroundmusic[2].load(musiclist.GetMusic(1));
			
			if(game_values.music)
				backgroundmusic[2].play(false, false);

			return false;
		};

		bool enter(MenuID menuID)
		{
			musiclist.next();
			backgroundmusic[2].stop();
			backgroundmusic[2].load(musiclist.GetMusic(1));
			
			if(game_values.music)
				backgroundmusic[2].play(false, false);

			return false;
        };

		bool random()
		{
            musiclist.random();
			backgroundmusic[2].stop();
			backgroundmusic[2].load(musiclist.GetMusic(1));
			
			if(game_values.music)
				backgroundmusic[2].play(false, false);

            return false;
        };

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "Playlist");
			font[2].drawChopRight(x2, y, 241, musiclist.current_name());

			return y + MENUSPACING;
		};
};

class MI_Respawn : public MenuItem
{
	public:
        virtual ~MI_Respawn() {};
		MI_Respawn()
		{
			strcpy(description, "Number of seconds player must wait to respawn.");
		};

		bool left()
		{
			if(--game_values.respawn < 0)
				game_values.respawn = 10;

			return false;
		};
		bool right()
		{
			if(++game_values.respawn > 10)
				game_values.respawn = 0;

			return false;
		};

		bool random()
		{
			int randomrespawn = game_values.respawn;
			while(randomrespawn == game_values.respawn)
				randomrespawn = rand() % 11;

			game_values.respawn = randomrespawn;
			return false;
		}
		
		bool enter(MenuID menuID)
		{
			return right();
		};

		int draw(const int x1, const int x2, const int y)
		{
			font[2].drawf(x1, y, "Respawn");

			char respawnString[32];
			if(game_values.respawn == 0)
				sprintf(respawnString, "Instant");
			else if(game_values.respawn == 1)
				sprintf(respawnString, "%d Second", game_values.respawn);
			else
				sprintf(respawnString, "%d Seconds", game_values.respawn);

			font[2].drawf(x2, y, "%s", respawnString);

			return y + MENUSPACING;
		};
};

class MI_Back : public MenuItem
{
	public:

        virtual ~MI_Back() {};
		bool enter(MenuID menuID)
		{
			menu_setmenu(head_mainmenu);
			return false;
		};

		int draw(const int x1, const int x2, const int y)
		{
			font[2].draw(x1, y, "Back");
			return y + MENUSPACING + MENUSPACING / 6;
		};
};


//---------------------------------------------------------------
// RUN THE MENU
//---------------------------------------------------------------

void runmenu(MenuID menuID)
{
	unsigned int	framestart;
	int delay;
	SDL_Event		event;


	//for drawing the menu
	const int	menux1 = 125;
	const int	mainmenux2 = 280;
	const int	optionsmenux2 = 300;
	MenuItem	*temp;

	//main menu
	MI_Start		m_start;
	MI_Players		m_players;
	MI_Map			m_map;
	MI_Mode			m_mode;
	MI_Tournament	m_tournament;
	MI_Options		m_options;

#ifndef _XBOX
	MI_Exit			m_exit;
#endif

	if(menuID == menu_id_main)
	{
		m_start		.setnext(	&m_players);
		m_players	.setnext(	&m_map);
		m_map		.setnext(	&m_mode);
		m_mode		.setnext(	&m_tournament);
		m_tournament.setnext(	&m_options);

#ifndef _XBOX
		m_options	.setnext(	&m_exit);
		m_exit		.setnext(	&m_start);
#else
		m_options	.setnext(	&m_start);
#endif
	}
	else if(menuID == menu_id_tournament)
	{
		m_start		.setnext(	&m_map);
		m_map		.setnext(	&m_mode);
		m_mode		.setnext(	&m_start);
	}

	//options menu
	MI_Back			m_back;
	MI_ToggleSound	m_sound;
	MI_ToggleMusic	m_music;
	MI_ToggleBool	m_fps	("Show FPS", "Show frames per second at the bottom of the screen.", 	&(game_values.showfps));
	MI_ToggleBool	m_spawnshield	("Shield", "Protection for one second after spawning.", &(game_values.spawninvincibility));
	MI_Respawn		m_respawn;
	MI_SpawnStyle	m_spawnstyle;
	MI_AwardStyle   m_awardstyle;
	MI_ScoreStyle	m_scorestyle;
	MI_ToggleBool	m_friendlyfire	("Team Kill", "Players on your own team will be able to kill you.",	&(game_values.friendlyfire));
	MI_ToggleBool	m_teamcolors	("Team Color", "Player color will change when switching teams.", &(game_values.teamcolors));
	MI_ToggleBool	m_screencrunch	("Crunch", "Screen will move when players are killed.", &(game_values.screencrunch));
	MI_Announcer	m_announcer;
	MI_Playlist		m_playlist;

#ifdef _XBOX
	MI_ScreenResize m_resize;
	options_menu_total_items = 15;
#else
	MI_ToggleBool	m_mergelayers ("Top Layer", "Overlay map foreground layer if exists.", &(game_values.toplayer));
	MI_Fullscreen	m_fullscreen;
	options_menu_total_items = 16;
#endif		

	m_back			.setnext( &m_spawnstyle);
	m_spawnstyle	.setnext( &m_awardstyle);
	m_awardstyle	.setnext( &m_scorestyle);
	m_scorestyle	.setnext( &m_announcer);
	m_announcer		.setnext( &m_friendlyfire);
	m_friendlyfire	.setnext( &m_teamcolors);
	m_teamcolors	.setnext( &m_respawn);
	m_respawn		.setnext( &m_spawnshield);
	m_spawnshield	.setnext( &m_screencrunch);
	
#ifdef _XBOX
	m_screencrunch  .setnext( &m_resize);
	m_resize		.setnext( &m_sound);
#else
	m_screencrunch  .setnext( &m_mergelayers);
	m_mergelayers	.setnext( &m_fullscreen);
	m_fullscreen	.setnext( &m_sound);
#endif

	m_sound			.setnext( &m_music);
	m_music			.setnext( &m_playlist);
	m_playlist		.setnext( &m_fps);
	m_fps			.setnext( &m_back);

	
	//game type menu (single vs. tournament)

	//menu heads
	head_mainmenu		= &m_start;
	head_optionsmenu	= &m_back;
	
	menu_setmenu(head_mainmenu);
	
#ifdef _XBOX
    int lastJoy1X = 0;
	int lastJoy1Y = 0;
	int lastJoy2X = 0;
	int lastJoy2Y = 0;
#endif

	if(game_values.music)
	{
		if(game_values.tournamentwinner < 0)
		{
			if(menuID == menu_id_tournament)
				backgroundmusic[3].play(false, false);
			else
				backgroundmusic[2].play(false, false);
		}
	}

	while (true)
	{
		framestart = SDL_GetTicks();

/*
#ifdef _XBOX
		if(joystickcount != SDL_NumJoysticks())
			reconnectjoysticks();
#endif
*/

#ifdef _DEBUG

		static int startgametimer = rand() % 200;

		if(autotest)
		{
			if(--startgametimer < 0)
			{
				if(menumode == menu_mode_player_select)
				{
					static int playerselecttimer = rand() % 50;

					if(--playerselecttimer < 0)
					{
						startgametimer = rand() % 200;
						playerselecttimer = rand() % 50;

						if(menu_startnewgame())
							return;
					}
					else
					{
						for(int k = 0; k < 4; k++)
						{
							if(game_values.playercontrol[k] > 0)
							{
								int randaction = rand() % 4;

								if(randaction == 0)
								{
									findnewteam(k, -1);
								}
								else if(randaction == 1)
								{
									findnewteam(k, 1);
								}
								else if(randaction == 2)
								{
									if(--game_values.skinids[k] < 0)
										game_values.skinids[k] = skinlist.GetCount() - 1;
									
									loadmenuskin(k, game_values.skinids[k], game_values.colorids[k]);
								}
								else
								{
									if(++game_values.skinids[k] >= skinlist.GetCount())
										game_values.skinids[k] = 0;
									
									loadmenuskin(k, game_values.skinids[k], game_values.colorids[k]);
								}
							}
						}
					}
				}
				else
				{
					startgametimer = rand() % 200;

					if(game_values.tournamentwinner > -1)
					{
						if(game_values.powerupselectdone)
						{
							if(tournament_exit())
								return;
						}
						else if(game_values.gamestate == GS_SCOREBOARD)
						{
							game_values.gamestate = GS_BONUS;
							setuppowerupselector();
							return;
						}
					}
					else
					{
						for(int k = 0; k < GAMEMODE_LAST; k++)
						{
							gamemodes[k]->setdebuggoal();
						}

						m_map.random();
						m_mode.random();

						while(game_values.gamemode->getgamemode() == game_mode_freeplay)
							m_mode.random();

						if(menuID == menu_id_main && currentmenuhead == head_mainmenu)
						{
							m_tournament.random();
							if(rand() % 2) m_sound.enter(menuID);
							if(rand() % 2) m_music.enter(menuID);
							if(rand() % 2) m_fps.right();
							if(rand() % 2) m_spawnshield.right();
							m_spawnstyle.random();
							m_awardstyle.random();
							m_scorestyle.random();
							if(rand() % 2) m_friendlyfire.right();
							if(rand() % 2) m_teamcolors.right();
							if(rand() % 2) m_screencrunch.right();
							m_announcer.random();
							m_respawn.random();
							m_playlist.random();
						}
						
						if(m_start.enter(menuID))
							return;
					}
				}
			}
		}

#endif

		//handle messages
		while(SDL_PollEvent(&event))
		{
			bool upPressed = false;
			bool downPressed = false;
			bool rightPressed = false;
			bool leftPressed = false;
			bool cancelPressed = false;
			bool okPressed = false;
			bool randomPressed = false;
			bool mapViewPressed = false;
			bool fastMapPressed = false;
		
			switch(event.type)
			{
				
#ifndef _XBOX
				case SDL_QUIT:
					menu_exit();
					return;
				break;
#endif

				case SDL_KEYDOWN:
				{
					if(event.key.keysym.sym >= SDLK_a && event.key.keysym.sym <= SDLK_z && menumode != menu_mode_player_select && !game_values.exitinggame)
					{
						maplist.startswith((char)event.key.keysym.sym);
						loadmap();
					}

					switch(event.key.keysym.sym)
					{
#ifndef _XBOX
						case SDLK_F4:
							if(keystates[SDLK_LALT] || keystates[SDLK_RALT])
								menu_exit();
								return;
							break;
#endif
						case SDLK_ESCAPE:
							cancelPressed = true;
							break;

						case SDLK_DOWN:
							downPressed = true;
							break;

						case SDLK_UP:
							upPressed = true;
							break;

						case SDLK_RETURN:
							if(keystates[SDLK_LALT] || keystates[SDLK_RALT])
							{
#ifndef _XBOX
								game_values.fullscreen = !game_values.fullscreen;
								gfx_setresolution(640, 480, game_values.fullscreen);
								blitdest = screen;
#endif
							}
							else
							{
								okPressed = true;
							}
							break;

						case SDLK_SPACE:
							randomPressed = true;
							break;

						case SDLK_LEFT:	
							leftPressed = true;
							break;

						case SDLK_RIGHT:
							rightPressed = true;
							break;

						case SDLK_RCTRL:
						case SDLK_LCTRL:
							mapViewPressed = true;
							break;

						case SDLK_RSHIFT:
						case SDLK_LSHIFT:
							fastMapPressed = true;
							break;

#ifdef _DEBUG
						case SDLK_INSERT:
							autotest = !autotest;
#endif

						default:
							break;
					}

					if(menumode == menu_mode_player_select)
					{
						for(int k = 0; k < 4; k++)
						{
							if(game_values.playercontrol[k] > 0)
							{
								if(event.key.keysym.sym == controlkeys[k][0])
								{
									findnewteam(k, -1);
								}
								
								if(event.key.keysym.sym == controlkeys[k][1])
								{
									findnewteam(k, 1);
								}

								if(event.key.keysym.sym == controlkeys[k][2])
								{
									if(--game_values.skinids[k] < 0)
										game_values.skinids[k] = skinlist.GetCount() - 1;
									
									loadmenuskin(k, game_values.skinids[k], game_values.colorids[k]);
								}

								if(event.key.keysym.sym == controlkeys[k][3])
								{
									if(++game_values.skinids[k] >= skinlist.GetCount())
										game_values.skinids[k] = 0;
									
									loadmenuskin(k, game_values.skinids[k], game_values.colorids[k]);
								}
							}
						}
					}

					break;
				}

				case SDL_KEYUP:
				{
					if(event.key.keysym.sym == SDLK_RCTRL || event.key.keysym.sym == SDLK_LCTRL)
					{
						backgroundonly = false;
					}

					if(event.key.keysym.sym == SDLK_RSHIFT || event.key.keysym.sym == SDLK_LSHIFT)
					{
						fastmap = false;
					}

					break;
				}

#ifdef _XBOX
				case SDL_JOYHATMOTION:
				{
					static bool oldLeft = false;
					static bool oldRight = false;
					static bool oldUp = false;
					static bool oldDown = false;

					if (event.jhat.value & SDL_HAT_LEFT)
					{
						if(oldLeft == false)
							leftPressed = true;
						oldLeft = true;
					}
					else
						oldLeft = false;

					if (event.jhat.value & SDL_HAT_RIGHT)
					{
						if(oldRight == false)
							rightPressed = true;
						oldRight = true;
					}
					else
						oldRight = false;

					if (event.jhat.value & SDL_HAT_UP)
					{
						if(oldUp == false)
							upPressed = true;
						oldUp = true;
					}
					else
						oldUp = false;

					if (event.jhat.value & SDL_HAT_DOWN)
					{
						if(oldDown == false)
							downPressed = true;
						oldDown = true;
					}
					else
						oldDown = false;
					
					if(menumode == menu_mode_player_select && event.jhat.which >= 0 && event.jhat.which <= 3 && game_values.playercontrol[event.jhat.which] > 0)
					{
						if(event.jhat.value & SDL_HAT_LEFT)
						{
							findnewteam(event.jhat.which, -1);
						}
						
						if(event.jhat.value & SDL_HAT_RIGHT)
						{
							findnewteam(event.jhat.which, 1);
						}

						if(event.jhat.value & SDL_HAT_UP)
						{
							if(--game_values.skinids[event.jhat.which] < 0)
								game_values.skinids[event.jhat.which] = skinlist.GetCount() - 1;
							
							loadmenuskin(event.jhat.which, game_values.skinids[event.jhat.which], game_values.colorids[event.jhat.which]);
						}

						if(event.jhat.value & SDL_HAT_DOWN)
						{
							if(++game_values.skinids[event.jhat.which] >= skinlist.GetCount())
								game_values.skinids[event.jhat.which] = 0;
							
							loadmenuskin(event.jhat.which, game_values.skinids[event.jhat.which], game_values.colorids[event.jhat.which]);
						}
					}

					break;
				}
				case SDL_JOYBUTTONDOWN:
				{
					if(event.jbutton.button == 2)
						randomPressed = true;

					if(event.jbutton.button == 9)
						cancelPressed = true;

#ifdef _DEBUG
					if(event.jbutton.button == 4)
						autotest = !autotest;
#endif

					if(event.jbutton.button == 0)
						okPressed = true;

					if(event.jbutton.button == 3)
						mapViewPressed = true;

					if(event.jbutton.button == 1)
						fastMapPressed = true;
						
					if(event.jbutton.button == 8)
					{
						if(menumode == menu_mode_screen_resize)
						{
							menumode = menu_mode_normal;
							backgroundonly = false;
							fastmap = false;
						}
						else if(menumode == menu_mode_normal)
						{
							if( m_map.enter(menuID) )
								return;
						}
						else if(menumode == menu_mode_player_select)
						{
							okPressed = true;
						}
					}

					break;
				}
				case SDL_JOYBUTTONUP:
				{
					if(event.jbutton.button == 3)
						backgroundonly = false;

					if(event.jbutton.button == 1)
						fastmap = false;

					break;
				}
				case SDL_JOYAXISMOTION:
				{
					if(event.jaxis.axis == 0)
					{
						lastJoy1X = event.jaxis.value;
					}
					else if(event.jaxis.axis == 1)
					{
						lastJoy1Y = event.jaxis.value;
					}
					else if(event.jaxis.axis == 2)
					{
						lastJoy2X = event.jaxis.value;
					}
					else if(event.jaxis.axis == 3)
					{
						lastJoy2Y = event.jaxis.value;
					}

					break;
				}
				
#endif

			default:
				break;
			}

			if(menumode == menu_mode_normal)
			{
				if(game_values.exitinggame)
				{
					if(rightPressed) 
						game_values.exityes = false;
					else if(leftPressed)
						game_values.exityes = true;

					if(okPressed)
					{
						if(game_values.exityes)
						{
							if(tournament_exit())
								return;
						}
						else
						{
							game_values.exitinggame = false;
						}
					}
				}
				else if(game_values.tournamentwinner > -1)
				{
					if(okPressed || cancelPressed)
					{
						if(game_values.powerupselectdone)
						{
							if(tournament_exit())
								return;
						}
						else if(game_values.gamestate == GS_SCOREBOARD)
						{
							game_values.gamestate = GS_BONUS;
							setuppowerupselector();
							return;
						}
					}
				}
				else
				{
					if(rightPressed) 
					{
						rightPressed = false;

						if(backgroundonly)
						{
							if( m_map.right() )
								return;
						}
						else
						{
							if( currentitem->right() )
								return;
						}
					}

					if(leftPressed)
					{
						leftPressed = false;

						if(backgroundonly)
						{
							if( m_map.left() )
								return;
						}
						else
						{
							if( currentitem->left() )
								return;
						}
					}

					if(downPressed)
					{
						downPressed = false;
						if(!backgroundonly)
							currentitem = currentitem->next();

						if(currentmenuhead == head_optionsmenu)
						{
							if(++options_menu_selected_index >= options_menu_total_items)
								options_menu_selected_index = 0;

							if(options_menu_selected_index < 5)
								goalmenuy = 50.0f;
							else if(options_menu_selected_index > options_menu_total_items - 5)
								goalmenuy = 410.0f - (float)(options_menu_total_items * MENUSPACING);
							else
								goalmenuy = 50.0f - (float)((options_menu_selected_index - 5) * MENUSPACING);
						}
					}

					if(upPressed)
					{
						upPressed = false;
						if(!backgroundonly)
							currentitem = currentitem->prev();

						if(currentmenuhead == head_optionsmenu)
						{
							if(--options_menu_selected_index < 0)
								options_menu_selected_index = options_menu_total_items - 1;

							if(options_menu_selected_index < 5)
								goalmenuy = 50.0f;
							else if(options_menu_selected_index > options_menu_total_items - 5)
								goalmenuy = 410.0f - (float)(options_menu_total_items * MENUSPACING);
							else
								goalmenuy = 50.0f - (float)((options_menu_selected_index - 5) * MENUSPACING);

						}
					}

					if(cancelPressed)
					{
						cancelPressed = false;

						if(!backgroundonly)
						{
							if(currentmenuhead == head_optionsmenu)
							{	//if we are in the options menu go back
								menu_setmenu(head_mainmenu);
							}
							else
							{	//quit

								if(menuID == menu_id_tournament)
								{
									menu_shade.draw(0, 0);
									game_values.exitinggame = true;
								}
								else
								{
#ifndef _XBOX
									menu_exit();
									return;
#endif
								}
							}
						}
					}
					
					if(okPressed)
					{
						okPressed = false;
						if(backgroundonly)
						{
							if( m_map.enter(menuID) )
								return;
						}
						else
						{
							if( currentitem->enter(menuID) )
								return;
						}
					}

					if(randomPressed)
					{
						randomPressed = false;
						if(backgroundonly)
						{
							if( m_map.random() )
								return;
						}
						else
						{
							if( currentitem->random() )
								return;
						}
					}

					if(mapViewPressed)
					{
						if(menumode == menu_mode_normal &&
							(currentmenuhead == head_optionsmenu || currentmenuhead == head_mainmenu))
							backgroundonly = true;
					}

					if(fastMapPressed)
					{
						if(menumode == menu_mode_normal &&
							(currentmenuhead == head_optionsmenu || currentmenuhead == head_mainmenu))
							fastmap = true;
					}
				}
			}
			else if(menumode == menu_mode_player_select)
			{
				if(okPressed)
				{
					if(menu_startnewgame())
						return;
				}
				else if(cancelPressed)
				{
					menumode = menu_mode_normal;

					for(int k = 0; k < 4; k++)
					{
						game_values.colorids[k] = k;
						loadmenuskin(k, game_values.skinids[k], game_values.colorids[k]);
					}
				}
			}
#ifdef _XBOX
			else if(menumode == menu_mode_screen_resize)
			{
				if(okPressed)
				{
					okPressed = false;
					menumode = menu_mode_normal;
					writegameoptions();
				}
			}
#endif
		}

#ifdef _XBOX
		if(menumode == menu_mode_screen_resize)
		{
			bool resized = false;
			if(lastJoy1X > 0 || lastJoy1X < 0)
			{
				game_values.screenResizeX += (float)lastJoy1X / 50000.0f;
				resized = true;
			}

			if(lastJoy1Y > 0 || lastJoy1Y < 0)
			{
				game_values.screenResizeY += (float)lastJoy1Y / 50000.0f;
				resized = true;
			}

			if(lastJoy2X > 0 || lastJoy2X < 0)
			{
				game_values.screenResizeW += (float)lastJoy2X / 50000.0f;
				resized = true;
			}

			if(lastJoy2Y > 0 || lastJoy2Y < 0)
			{
				game_values.screenResizeH += (float)lastJoy2Y / 50000.0f;
				resized = true;
			}
			
			if(resized)
			{
				SDL_XBOX_SetScreenPosition(game_values.screenResizeX, game_values.screenResizeY);
				SDL_XBOX_SetScreenStretch(game_values.screenResizeW, game_values.screenResizeH);
			}
		}
#endif

		//--------------- draw everything ----------------------
		
		if(!backgroundonly)
		{
			menu_backdrop.draw(0,0);

			int menuOffsetY = 0;

			//Draw logo for single game or draw match scores for tournament game
			if(menuID == menu_id_tournament)
			{
				spr_scoreboard.draw(124, 12);
				
				for(int i = 0; i < score_cnt; i++)
				{
					int scoreY = i * 69 + 80 + (4 - score_cnt) * 35;
					
					if(game_values.tournamentwinner == i)
					{
						static int blinkcounter = 0;
						static bool blink = false;

						if(++blinkcounter > 20)
						{
							blinkcounter = 0;
							blink = !blink;
						}

						spr_tournament_background.draw(70, scoreY, 0, (blink ? 64 : 0), 512, 64);

						static int fireworkscounter = 0;

						if(--fireworkscounter < 0)
						{
							fireworkscounter = rand() % 100 + 25;

							ifsoundonplay(cannon);

							float angle = 0.0f; 
							int randX = rand() % 440 + 100;
							int randY = rand() % 280 + 100;

							for(int k = 0; k < 28; k++)
							{
								float vel = 7.0f + ((k % 2) * 5.0f);
								float velx = vel * cos(angle);
								float vely = vel * sin(angle);
								
								int randcolor = rand() % game_values.teamcounts[i];
								eyecandyfront.add(new EC_BrokenBlock(&spr_bonus[game_values.colorids[game_values.teamids[i][randcolor]]], randX, randY, velx, vely));
								angle -= (float)PI / 14;
							}
						}

						static int winnertextcounter = 0;

						if(--winnertextcounter < 0)
						{
							winnertextcounter = rand() % 35 + 15;

							char winnertext[64];
							if(game_values.teamcounts[i] == 1)
								sprintf(winnertext, "Player %d Wins!", game_values.teamids[i][0] + 1);
							else if(game_values.teamcounts[i] > 1)
								sprintf(winnertext, "Team %d Wins!", i + 1);


							int stringwidth = font[2].getWidth(winnertext);
							int randX = rand() % (640 - stringwidth) + (stringwidth >> 1);
							int randY = rand() % 380 + 100;

							eyecandyfront.add(new EC_GravText(&font[2], randX, randY, winnertext, -VELJUMP));
						}
					}
					else
					{
						spr_tournament_background.draw(70, scoreY, 0, 0, 512, 64);
					}
					
					int offsets[3][3] = {{110, 0, 0},
										{89, 129, 0},
										{76, 110, 144}};

					for(int k = 0; k < game_values.teamcounts[i]; k++)
					{
                        spr_player[game_values.teamids[i][k]][PGFX_STANDING_R]->draw(offsets[game_values.teamcounts[i] - 1][k], scoreY + 16, 0, 0, 32, 32);
					}

					int spacing = (372 - game_values.tournamentgames * 32) / (game_values.tournamentgames + 1);

					for(int k = 0; k < tournament_scores[i].wins; k++)
					{
						game_mode.draw(202 + spacing + k * (32 + spacing), scoreY + 16, tournament_scores[i].type[k] * 32, 0, 32, 32);
					}
				}

				menuOffsetY = 180;
			}
			else if(menuID == menu_id_bonus)
			{
				spr_tournament_powerup_splash.draw(144,64);

				if(++game_values.powerupselector.selectoranimationcounter > 8)
				{
					game_values.powerupselector.selectoranimationcounter = 0;
					if(++game_values.powerupselector.selectoranimation > 1)
						game_values.powerupselector.selectoranimation = 0;
				}

				game_values.powerupselector.selectionspeed -= 0.0005f;

				if(game_values.powerupselector.selectionspeed <= 0.0f)
				{
					game_values.powerupselector.selectionspeed = 0.0f;
					
					if(!game_values.powerupselectdone)
					{
						for(int i = 0; i < score_cnt; i++)
						{
							for(int k = 0; k < game_values.teamcounts[i]; k++)
							{
								if(i == game_values.tournamentwinner)
									game_values.storedpowerups[game_values.teamids[i][k]] = game_values.powerupselector.selectedpowerup;
								else
									game_values.storedpowerups[game_values.teamids[i][k]] = -1;
							}
						}

						ifsoundonplay(collectpowerup);
						game_values.powerupselectdone = true;
					}
				}

				game_values.powerupselector.selectionangle += game_values.powerupselector.selectionspeed;

				int selectorx = 288 + (int)(90.0f * cos(game_values.powerupselector.selectionangle));
				int selectory = 246 + (int)(90.0f * sin(game_values.powerupselector.selectionangle));

				spr_powerupselector.draw(selectorx, selectory, game_values.powerupselector.selectoranimation * 64, 0, 64, 64);

				int xoffset = 304 + (game_values.teamcounts[game_values.tournamentwinner] - 1) * 17;
				for(int k = game_values.teamcounts[game_values.tournamentwinner] - 1; k >= 0; k--)
				{
                    spr_player[game_values.teamids[game_values.tournamentwinner][k]][PGFX_JUMPING_R]->draw(xoffset, 264, 0, 0, 32, 32);
					xoffset -= 34;
				}

				for(int k = 0; k < 8; k++)
				{
					float angle = (float)k * TWO_PI / 8.0f;
					int powerupx = 304 + (int)(90.0f * cos(angle));
					int powerupy = 264 + (int)(90.0f * sin(angle));
					
					spr_storedpoweruplarge.draw(powerupx, powerupy, k * 32, 0, 32, 32);
				}
			}
			else if(menuID == menu_id_main && currentmenuhead == head_mainmenu)
			{
				menu_smw.draw(320 - ((menu_smw.getWidth())>>1), 30);	//smw logo
				menu_version.draw(567, 10);	//smw logo
				//font[2].drawRightJustified(625, 45, "RC1");
			}
			
			//draw the menu
			if(menumode == menu_mode_normal && game_values.tournamentwinner < 0 && menuID != menu_id_bonus)
			{
				if(currentmenuhead == head_optionsmenu)
				{
					if(menuy < goalmenuy)
					{
						menuy += (goalmenuy - menuy) / 8.0f;

						if(menuy > goalmenuy)
							menuy = goalmenuy;
					}

					if(menuy > goalmenuy)
					{
						menuy += (goalmenuy - menuy) / 8.0f;

						if(menuy < goalmenuy)
							menuy = goalmenuy;
					}
				}
				else
					menuy = 186.0f + menuOffsetY;

				int displayy = (int)menuy;
				temp = currentmenuhead;
				do
				{
					menu_itembackground.draw(110, displayy - 8, 0, 34 * (temp == currentitem ? 1 : 0), 420, 34);

					if(currentmenuhead == head_optionsmenu)
						displayy = temp->draw(menux1, optionsmenux2, displayy);
					else
						displayy = temp->draw(menux1, mainmenux2, displayy);

					temp = temp->next();
				}
				while(temp != currentmenuhead);

				if(currentmenuhead == head_optionsmenu)
				{
					menu_stoneborder.draw(96, -64);
					menu_stoneborder.draw(96, 416);

					font[0].drawCentered(5, currentitem->getDescription());
				}
			}
			else if(menumode == menu_mode_player_select)
			{
				spr_player_select_background.draw(112, 200);
				font[2].drawCentered(220, "Team Select");

				for(int k = 0; k < 4; k++)
				{
					for(int j = 0; j < game_values.teamcounts[k]; j++)
					{
						spr_player[game_values.teamids[k][j]][PGFX_STANDING_R]->draw(k * 96 + 160, j * 36 + 276, 0, 0, 32, 32);
						spr_awardkillsinrow[game_values.colorids[game_values.teamids[k][j]]].draw(k * 96 + 156, j * 36 + 296, game_values.teamids[k][j] * 16, 0, 16, 16);
					}
				}
			}

			//Draw the help keys at bottom of screen
			if(menumode == menu_mode_normal && menuID == menu_id_main &&
				(currentmenuhead == head_optionsmenu || currentmenuhead == head_mainmenu))
			{
#ifdef _XBOX
				int spacing[6] = {70,110,240,280,420,460};
#else
				int spacing[6] = {70,130,240,300,420,476};
#endif
			
				spr_keys[0].draw(spacing[0], 445);
				font[2].draw(spacing[1], 480 - font[2].getHeight() - 3, "Select");

				spr_keys[1].draw(spacing[2], 445);
				font[2].draw(spacing[3], 480 - font[2].getHeight() - 3, "Random");

				spr_keys[2].draw(spacing[4], 445);
				font[2].draw(spacing[5], 480 - font[2].getHeight() - 3, "View Map");
			}
			else if(menumode == menu_mode_player_select)
			{
#ifdef _XBOX
				int spacing[6] = {120,160,275,315,415,450};
#else
				int spacing[6] = {90,160,260,330,420,480};
#endif
			
				spr_keys[3].draw(spacing[0], 445);
				font[2].draw(spacing[1], 480 - font[2].getHeight() - 3, "Team");

				spr_keys[4].draw(spacing[2], 445);
				font[2].draw(spacing[3], 480 - font[2].getHeight() - 3, "Skin");

				spr_keys[0].draw(spacing[4], 445);
				font[2].draw(spacing[5], 480 - font[2].getHeight() - 3, "Start");
			}
		}
		else //draw map view mode help keys
		{
			spr_backmap.draw(0,0);
			interactionobjectblocks.draw();

#ifdef _XBOX
			map.drawfrontlayer();
			int spacing[6] = {55,95,285,325,465,505};
#else
			if(game_values.toplayer)
				map.drawfrontlayer();
			
			int spacing[6] = {30,98,270,330,450,510};
#endif

			spr_keys[3].draw(spacing[0], 445);
			font[2].draw(spacing[1], 480 - font[2].getHeight() - 3, "Change Map");

			spr_keys[1].draw(spacing[2], 445);
			font[2].draw(spacing[3], 480 - font[2].getHeight() - 3, "Random");

			spr_keys[0].draw(spacing[4], 445);
			font[2].draw(spacing[5], 480 - font[2].getHeight() - 3, "Start");
		}

		//Special screen resize code for xbox
		if(menumode == menu_mode_screen_resize)
		{
			font[2].drawCentered(200, "Use left joystick to set");
			font[2].drawCentered(225, "upper left corner.");
			font[2].drawCentered(280, "Use right joystick to set");
			font[2].drawCentered(305, "lower right corner.");

			font[2].drawCentered(360, "Press     to exit.");

			spr_keys[0].draw(291, 355);
		}

		if(game_values.exitinggame)
		{
			spr_dialog.draw(224, 176);
			font[2].drawCentered(205 - (font[2].getHeight() >> 1), "Exit");
			font[2].drawCentered(230 - (font[2].getHeight() >> 1), "Tournament");

			spr_dialogbutton.draw(235, 250, 0, (game_values.exityes ? 34 : 0), 80, 34);
			spr_dialogbutton.draw(325, 250, 0, (game_values.exityes ? 0 : 34), 80, 34);
		
			font[2].draw(275 - (font[2].getWidth("Yes") >> 1),  269 - (font[2].getHeight() >> 1), "Yes");
			font[2].draw(365 - (font[2].getWidth("No") >> 1),  269 - (font[2].getHeight() >> 1), "No");
		}
		
		eyecandyfront.cleandeadobjects();
		eyecandyfront.update();
		eyecandyfront.draw();

		SDL_Flip(screen);


		//we don't need much accuracy here, so we can stick to SDL_Delay
		delay = WAITTIME - (SDL_GetTicks() - framestart);
		if(delay < 0)
			delay = 0;
		else if(delay > WAITTIME)
			delay = WAITTIME;
		
		SDL_Delay(delay);
	}

	//we won't ever get here
	return;
}

void findnewteam(int id, int scandirection)
{
	for(int i = 0; i < 4; i++)
	{
		for(int j = 0; j < game_values.teamcounts[i]; j++)
		{
			if(game_values.teamids[i][j] == id)
			{
				game_values.teamcounts[i]--;

				for(int m = j; m < game_values.teamcounts[i]; m++)
                    game_values.teamids[i][m] = game_values.teamids[i][m + 1];
				
				
				int newteam = i;
				bool onlyteam = true;
				do
				{
					newteam += scandirection;
					if(newteam < 0)
						newteam = 3;
					else if(newteam > 3)
						newteam = 0;

					onlyteam = true;
					for(int m = 0; m < 4; m++)
					{
						if(m == newteam)
							continue;

						if(game_values.teamcounts[m] > 0)
						{
							onlyteam = false;
							break;
						}
					}
				}
				while(onlyteam);

				game_values.teamids[newteam][game_values.teamcounts[newteam]] = id;
				game_values.teamcounts[newteam]++;

				if(game_values.teamcolors)
				{
					game_values.colorids[id] = newteam;
					loadmenuskin(id, game_values.skinids[id], newteam);
				}

				return;
			}
		}
	}
}

