#include "SDL_mixer.h"
#include "SDL.h"

bool sfx_init();
void sfx_close();
void sfx_stopallsounds();
void sfx_setmusicvolume(int volume);
void sfx_setsoundvolume(int volume);

class sfxSound
{
	public:
		sfxSound();
		~sfxSound();

		bool init(const char *filename);

		int play();
		int playloop(int iLoop);
		void stop();
		void pause();

		void resetpause() {paused = false;}

		void reset();
		bool isready() {return ready;}
		
	private:
		Mix_Chunk *sfx;
		int channel;
		bool paused;
		bool ready;
		int starttime;
};

class sfxMusic
{
	public:
		sfxMusic();
		~sfxMusic();

		bool load(const char *filename);

		void play(bool fPlayonce, bool fResume);
		void stop();
		void pause();

		void resetpause() {paused = false;}

		void reset();
		bool isready() {return ready;}

	private:
		Mix_Music *music;
		bool paused;
		bool ready;
};
