#ifdef _XBOX
	#include <xtl.h>
#endif

#ifdef _WIN32
	#ifndef _XBOX
		#define WIN32_LEAN_AND_MEAN
		#include "windows.h"
	#endif
#endif

#include "global.h"
#include "time.h"

extern void loadInteractionMapObjects();
extern char *convertPath(char *source);
extern bool loadmessages;

extern bool gfx_createmenuskin(gfxSprite * gSprite, const char *filename, Uint8 r, Uint8 g, Uint8 b, int colorScheme);
extern bool gfx_createfullskin(gfxSprite ** gSprites, const char *filename, Uint8 r, Uint8 g, Uint8 b, int colorScheme);


bool loadmenuskin(int playerID, int skinID, int colorID);
bool loadfullskin(gfxSprite ** sprites, char * filename, int colorID);

extern CEyecandyContainer eyecandyfront;

//-----------------------------------------------------------------------------
// THE LOAD UP SEQUENCE + SPLASH SCREEN
//-----------------------------------------------------------------------------
//that's a bunch of ugly code, maybe i'll throw it out again

void _load_drawmsg(const char *f)
{
	if(loadmessages)
	{
		static SDL_Rect r;
		r.x = 0;
		r.y = 0;
		r.w = 500;
		r.h = font[0].getHeight();
		Uint32 col = SDL_MapRGB(screen->format, 189, 251, 255);

		SDL_FillRect(screen, &r, col);		//fill empty area
		font[0].draw(0,0, f);
	}
}
void _load_waitforkey()
{
	SDL_Event event;
	while (true)
	{
		while(SDL_PollEvent(&event))
		{
			if(event.type == SDL_KEYDOWN)
				return;
			if(event.type == SDL_JOYBUTTONDOWN)
				return;
		}

		SDL_Delay(10);
	}
}
bool __load_gfxck(gfxSprite &g, const char *f)
{
	if(! g.init(f, 255, 0, 255) )
	{
		char msg[512];
		sprintf(msg, "error loading color keyed sprite %s", f);
		
		_load_drawmsg(msg);

		return false;
	}

	return true;
}

bool __load_gfxa(gfxSprite &g, const char *f, Uint8 alpha)
{
	if(! g.init(f, 255, 0, 255, alpha) )
	{
		char msg[512];
		sprintf(msg, "error loading alpha color keyed sprite %s", f);
		
		_load_drawmsg(msg);

		return false;
	}

	return true;
}

bool __load_gfxmenuskin(gfxSprite * g, const char *f, int colorscheme)
{
	if(! gfx_createmenuskin(g, f, 255, 0, 255, colorscheme) )
	{
		char msg[512];
		sprintf(msg, "error loading color keyed sprite %s", f);
		_load_drawmsg(msg);
		return false;
	}

	return true;
}
bool __load_gfxfullskin(gfxSprite ** g, const char *f, int colorscheme)
{
	if(! gfx_createfullskin(g, f, 255, 0, 255, colorscheme) )
	{
		char msg[512];
		sprintf(msg, "error loading color keyed sprite %s", f);
		_load_drawmsg(msg);
		return false;
	}

	return true;
}
bool __load_gfx(gfxSprite &g, const char *f)
{
	if(! g.init(f))
	{
		char msg[512];
		sprintf(msg, "error loading sprite %s", f);
		_load_drawmsg(msg);
		return false;
	}

	return true;
}
bool __load_sfx(sfxSound &s, const char *f)
{
	if(! s.init(f) )
	{
		char msg[512];
		sprintf(msg, "error loading sound %s", f);
		_load_drawmsg(msg);
		return false;
	}

	return true;
}

#define _load_gfxck(g,f)			if(!__load_gfxck(g,f)){_load_waitforkey();return false;};
#define _load_gfxa(g,f,a)			if(!__load_gfxa(g,f,a)){_load_waitforkey();return false;};
#define _load_gfxmenuskin(g,f,c)	if(!__load_gfxmenuskin(g,f,c)){_load_waitforkey();return false;};
#define _load_gfxfullskin(g,f,c)	if(!__load_gfxfullskin(g,f,c)){_load_waitforkey();return false;};
#define _load_gfx(g,f)				if(!__load_gfx(g,f)){_load_waitforkey();return false;};
#define _load_sfx(s,f)				if(!__load_sfx(s,f)){_load_waitforkey();return false;};

bool load_and_splashscreen()
{
	bool loadok = true;

	loadok &= font[0].init(convertPath("gfx/fonts/font0.bmp"));
	loadok &= font[1].init(convertPath("gfx/fonts/font1.bmp"));
	loadok &= font[2].init(convertPath("gfx/fonts/font2.bmp"));

	if(!loadok)
	{
		_load_drawmsg("ERROR: error loading the fonts!\n");
		_load_waitforkey();
		return false;
	}

	//load basic stuff
	_load_gfx(menu_backdrop, convertPath("gfx/backgrounds/bg16.bmp"));
	_load_gfxck(menu_smw, convertPath("gfx/menu/menu_smw.bmp"));
	_load_gfxck(menu_version, convertPath("gfx/menu/menu_version.bmp"));

	gfxSprite menu_dpi_logo;
	_load_gfx(menu_dpi_logo, convertPath("gfx/menu/splash_72dpi.bmp"));

	gfxSprite menu_credits;
	_load_gfxck(menu_credits, convertPath("gfx/menu/splash_credits.bmp"));
	
	int alpha = 0;
	int state = 0;
	int timer = 120;

#define NUM_CONTRIBUTORS 51

	char * contributors[NUM_CONTRIBUTORS] = {"no_shorty", "Samuele Poletto", "redfalcon", "no_human", "dschingis", "matsche", 
		"aeroflare", "Tymoe", "David Olofson", "scoti", "affeOHNEwaffe", "mademan", "mario piuk", "yvoo", "DNightmare",
		"funvill", "Armen", "vvill", "zio tiok", "emedia", "gpmania", "Donny Viszneki", "Stephan Peijnik",
		"ventuz", "Stefan Schury", "DrJonez", "riahc3", "jinkies.uk", "devguy", "Alexis Morrissette", "Bidbood",
		"Quinn Storm", "Flexserve", "Xijar", "j rok", "nitsuja", "4matsy", "leftyfb", "Brian Porter", "Brandon Stansbury",
	    "Brian Smith", "Caesar Cypher", "Chris Schager", "Alex Arnot", "Jason Lumbert", "Kevin King", "Fernando Marquez", 
		"DrJones", "SleepyP", "Jared", "UltimateNinja9"};

	bool contributorUsed[NUM_CONTRIBUTORS];
	int contributorOrder[NUM_CONTRIBUTORS];

	for(int k = 0; k < NUM_CONTRIBUTORS; k++)
	{
		contributorUsed[k] = false;
	}

	for(int k = 0; k < NUM_CONTRIBUTORS; k++)
	{
		int index = rand() % NUM_CONTRIBUTORS;
		
		while(contributorUsed[index])
		{
			if(++index >= NUM_CONTRIBUTORS)
				index = 0;
		}

		contributorUsed[index] = true;
		contributorOrder[k] = index;		
	}


	SDL_Event event;

	while (true)
	{
		int framestart = SDL_GetTicks();

		while(SDL_PollEvent(&event))
		{
			bool okPressed = false;
		
			switch(event.type)
			{

#ifndef _XBOX
				case SDL_QUIT:
				{
					return false;
				}
				break;
#endif
				case SDL_KEYDOWN:
				{
					switch(event.key.keysym.sym)
					{
						case SDLK_ESCAPE:
							okPressed = true;
							break;

						case SDLK_RETURN:
							if(keystates[SDLK_LALT] || keystates[SDLK_RALT])
							{
#ifndef _XBOX
								game_values.fullscreen = !game_values.fullscreen;
								gfx_setresolution(640, 480, game_values.fullscreen);
								blitdest = screen;
#endif
							}
							else
							{
								okPressed = true;
							}
							break;

						case SDLK_SPACE:
							okPressed = true;
							break;

#ifndef _XBOX
						case SDLK_F4:
							if(keystates[SDLK_LALT] || keystates[SDLK_RALT])
								return false;
							break;
#endif

						default:
							break;
					}
					break;
				}

#ifdef _XBOX

				case SDL_JOYBUTTONDOWN:
				{
					if(event.jbutton.button == 0)
						okPressed = true;
						
					if(event.jbutton.button == 8)
						okPressed = true;
						
					break;
				}
#endif

			default:
				break;
			}

			if(okPressed)
			{
				if(state <= 3)
				{
					state = 3;
					alpha = 255;
				}
				else
				{
					blitdest = menu_backdrop.getSurface();
					spr_backmap.draw(0, 0);
					interactionobjectblocks.draw();

#ifdef _XBOX
					map.drawfrontlayer();
#else
					if(game_values.toplayer)
						map.drawfrontlayer();
#endif
					menu_shade.draw(0, 0);
					blitdest = screen;

					loadmessages = false;
					eyecandyfront.clean();

					return loadok;
				}
			}
		}

		if(state == 0)
		{
			alpha += 4;
			if(alpha >= 255)
			{
				alpha = 255;
				state++;
			}
		}
		else if(state == 1)
		{
			if(--timer <= 0)
			{
				state++;
			}
		}
		else if(state == 2)
		{
			alpha -= 4;
			if(alpha <= 0)
			{
				alpha = 0;
				state++;
			}
		}
		else if(state == 3)
		{
			alpha += 5;
			if(alpha >= 255)
			{
				alpha = 255;
				state++;
			}
		}

		SDL_FillRect(screen, NULL, 0x0);

		if(state == 0 || state == 1 || state == 2)
		{
			menu_dpi_logo.setalpha(alpha);
			menu_dpi_logo.draw(195, 186);
		}
		else if(state == 3 || state == 4 || state == 5)
		{
			menu_backdrop.setalpha(alpha);
			menu_backdrop.draw(0, 0);
			
			menu_smw.setalpha(alpha);
			menu_smw.draw(320 - (menu_smw.getWidth() >> 1), 30);	//smw logo

			menu_version.setalpha(alpha);
			menu_version.draw(567, 10);	//smw logo
			
			font[2].setalpha(alpha);
			//font[2].drawRightJustified(625, 45, "RC1");

			menu_credits.setalpha(alpha);
			menu_credits.draw(227, 200);

			/*
			dy+=font[f].getHeight();
			font[f].draw(dx,dy+=font[f].getHeight(), "gfx: Nintendo, Alexis Morrissette, Bidbood, Two52");
			font[f].draw(dx,dy+=font[f].getHeight(), "sfx: Nintendo, Florian Hufsky, Two52");
			font[f].draw(dx,dy+=font[f].getHeight(), "original idea: Samuele Poletti");
			dy+=font[f].getHeight();
			font[f].draw(dx,dy+=font[f].getHeight(), "code:");
			font[f].draw(dx,dy+=font[f].getHeight(), "  Florian Hufsky aka no_skill (main smw code)");
			font[f].draw(dx,dy+=font[f].getHeight(), "  Mario Piuk aka MPXL (game modes)");
			font[f].draw(dx,dy+=font[f].getHeight(), "  Armen (editor load/save map)");
			font[f].draw(dx,dy+=font[f].getHeight(), "  Two52 (v1.5)");
			dy+=font[f].getHeight();
			font[f].draw(dx,dy+=font[f].getHeight(), "Thanks to all who supported me and to you for playing.");
			dy+=font[f].getHeight() >> 1;
			font[f].draw(dx,dy+=font[f].getHeight(), "Have a lot of fun!");
			*/
		}

		if(state == 4)
		{
			_load_drawmsg("Loading...");
		}
		else if(state == 5)
		{
			_load_drawmsg("Press Any Key To Continue");

			eyecandyfront.cleandeadobjects();
			eyecandyfront.update();
			eyecandyfront.draw();

			static int timer = 60;
			static int index = 0;
			if(++timer >= 60)
			{
				eyecandyfront.add(new EC_GravText(&font[2], 320, 480, contributors[contributorOrder[index]], -8.2f));
				timer = 0;

				if(++index >= NUM_CONTRIBUTORS)
					index = 0;
			}
		}

		SDL_Flip(screen);

		if(state == 4)
		{
#ifdef _XBOX
			_load_gfxa(menu_shade, convertPath("gfx/menu/menu_shade.bmp"), 96); //TV's seem to need extra shade
#else
			_load_gfxa(menu_shade, convertPath("gfx/menu/menu_shade.bmp"), 72);
#endif
			_load_gfxck(spr_scoreboard, convertPath("gfx/menu/scoreboard.bmp"));
			_load_gfxck(menu_itembackground, convertPath("gfx/menu/menu_itembackground.bmp"));
			_load_gfxck(menu_stoneborder, convertPath("gfx/menu/menu_stoneborder.bmp"));
			_load_gfxck(menu_slider_bar, convertPath("gfx/menu/menu_slider_bar.bmp"));

			_load_gfxck(menu_mario, convertPath("gfx/menu/menu_mario.bmp"));
			_load_gfxck(menu_cpu, convertPath("gfx/menu/menu_cpu.bmp"));
			_load_gfxck(menu_mode, convertPath("gfx/awards/small.bmp"));
			_load_gfxck(game_mode, convertPath("gfx/awards/large.bmp"));
			
			_load_gfxck(spr_dialog, convertPath("gfx/menu/dialog.bmp"));
			_load_gfxck(spr_dialogbutton, convertPath("gfx/menu/dialog_button.bmp"));
			_load_gfxck(spr_tournament_background, convertPath("gfx/menu/tournament_background.bmp"));
			_load_gfxck(spr_tournament_powerup_splash, convertPath("gfx/menu/tournament_powerup_splash.bmp"));
			_load_gfxck(spr_player_select_background, convertPath("gfx/menu/player_select_background.bmp"));
			
			backgroundmusic[2].load(musiclist.GetMusic(1));

			int k, j;
			for(k = 0; k < 4; k++)
			{
				spr_player[k] = new gfxSprite * [PGFX_LAST];
				spr_chocobo[k] = new gfxSprite * [PGFX_LAST];
				spr_bobomb[k] = new gfxSprite * [PGFX_LAST];

				for(j = 0; j < PGFX_LAST; j++)
				{
					spr_player[k][j] = new gfxSprite();
					spr_chocobo[k][j] = new gfxSprite();
					spr_bobomb[k][j] = new gfxSprite();
				}
			}

			//Just load menu skins for now (just standing right sprite)
			for(k = 0; k < 4; k++)
			{
				loadmenuskin(k, game_values.skinids[k], game_values.colorids[k]);
				loadfullskin(spr_chocobo[k], convertPath("gfx/skins/special/chocobo.bmp"), k);
				loadfullskin(spr_bobomb[k], convertPath("gfx/skins/special/bobomb.bmp"), k);
			}

			_load_gfxck(spr_clouds[0], convertPath("gfx/eyecandy/cloud1.bmp"));
			_load_gfxck(spr_clouds[1], convertPath("gfx/eyecandy/cloud2.bmp"));
			_load_gfxa(spr_ghosts[0], convertPath("gfx/eyecandy/ghost1.bmp"), 128);
			_load_gfxa(spr_ghosts[1], convertPath("gfx/eyecandy/ghost2.bmp"), 128);
			_load_gfxa(spr_ghosts[2], convertPath("gfx/eyecandy/ghost3.bmp"), 128);
			
			_load_gfxck(spr_noteblock, convertPath("gfx/blocks/noteblock.bmp"));
			_load_gfxck(spr_breakableblock, convertPath("gfx/blocks/breakableblock.bmp"));
			_load_gfxck(spr_powerupblock, convertPath("gfx/blocks/powerupblock.bmp"));
			_load_gfxck(spr_donutblock, convertPath("gfx/blocks/donutblock.bmp"));
			_load_gfxck(spr_flipblock, convertPath("gfx/blocks/flipblock.bmp"));
			_load_gfxck(spr_bounceblock, convertPath("gfx/blocks/bounceblock.bmp"));

			_load_gfxck(spr_starpowerup, convertPath("gfx/powerups/starpowerup.bmp"));
			_load_gfxck(spr_1uppowerup, convertPath("gfx/powerups/1uppowerup.bmp"));
			_load_gfxck(spr_firepowerup, convertPath("gfx/powerups/fireflower.bmp"));
			_load_gfxck(spr_hammerpowerup, convertPath("gfx/powerups/hammerpowerup.bmp"));
			_load_gfxck(spr_poisonpowerup, convertPath("gfx/powerups/poisonpowerup.bmp"));
			_load_gfxck(spr_clockpowerup, convertPath("gfx/powerups/clockpowerup.bmp"));
			_load_gfxck(spr_bobombpowerup, convertPath("gfx/powerups/bobombpowerup.bmp"));
			_load_gfxck(spr_powpowerup, convertPath("gfx/powerups/powpowerup.bmp"));
			_load_gfxck(spr_bulletbillpowerup, convertPath("gfx/powerups/bulletbillpowerup.bmp"));
			
			_load_gfxa(spr_shade[0], convertPath("gfx/eyecandy/shade1.bmp"), 64);
			_load_gfxa(spr_shade[1], convertPath("gfx/eyecandy/shade2.bmp"), 64);
			_load_gfxa(spr_shade[2], convertPath("gfx/eyecandy/shade3.bmp"), 64);
			_load_gfxck(spr_spawneggs, convertPath("gfx/eyecandy/spawneggs.bmp"));

			_load_gfxck(spr_crown, convertPath("gfx/eyecandy/crown.bmp"));
			_load_gfxck(spr_warplock, convertPath("gfx/eyecandy/warplock.bmp"));
			
			_load_gfxck(spr_egg, convertPath("gfx/modeobjects/egg.bmp"));
			_load_gfxck(spr_yoshi, convertPath("gfx/modeobjects/yoshi.bmp"));
			_load_gfxck(spr_coin, convertPath("gfx/modeobjects/coin.bmp"));
			_load_gfxck(spr_thwomp, convertPath("gfx/modeobjects/thwomp.bmp"));
			_load_gfxck(spr_areas, convertPath("gfx/modeobjects/areas.bmp"));
			_load_gfxa(spr_jail, convertPath("gfx/modeobjects/jail.bmp"), 160);
			_load_gfxck(spr_goomba, convertPath("gfx/modeobjects/goomba.bmp"));
			_load_gfxck(spr_goombadead, convertPath("gfx/eyecandy/goombadead.bmp"));
			_load_gfxck(spr_goombadeadflying, convertPath("gfx/eyecandy/goombadeadflying.bmp"));
			_load_gfxck(spr_bulletbill, convertPath("gfx/projectiles/bulletbill.bmp"));
			_load_gfxck(spr_bulletbilldeadflyingleft, convertPath("gfx/eyecandy/bulletbilldeadflyingleft.bmp"));
			_load_gfxck(spr_bulletbilldeadflyingright, convertPath("gfx/eyecandy/bulletbilldeadflyingright.bmp"));
			_load_gfxa(spr_chicken, convertPath("gfx/modeobjects/chicken.bmp"), 160);
			_load_gfxck(spr_racegoal, convertPath("gfx/modeobjects/racegoal.bmp"));
			_load_gfxck(spr_racegoalnumbers, convertPath("gfx/modeobjects/racegoalnumbers.bmp"));
			
			_load_gfxck(spr_bobombcard, convertPath("gfx/modeobjects/bobombcard.bmp"));
			_load_gfxck(spr_fireflowercard, convertPath("gfx/modeobjects/fireflowercard.bmp"));
			_load_gfxck(spr_hammercard, convertPath("gfx/modeobjects/hammercard.bmp"));

			_load_gfxck(spr_fireball, convertPath("gfx/projectiles/fireball.bmp"));
			_load_gfxck(spr_hammer, convertPath("gfx/projectiles/hammer.bmp"));
			
			_load_gfxa(spr_fireballexplosion, convertPath("gfx/eyecandy/fireballexplosion.bmp"), 160);
			_load_gfxa(spr_frictionsmoke, convertPath("gfx/eyecandy/frictionsmoke.bmp"), 160);
			_load_gfxck(spr_explosion, convertPath("gfx/eyecandy/explosion.bmp"));
			_load_gfxa(spr_burnup, convertPath("gfx/eyecandy/burnup.bmp"), 192);
			
			_load_gfxa(spr_spawnsmoke[0], convertPath("gfx/eyecandy/spawnsmoke1.bmp"), 128);
			_load_gfxa(spr_spawnsmoke[1], convertPath("gfx/eyecandy/spawnsmoke2.bmp"), 128);
			_load_gfxa(spr_spawnsmoke[2], convertPath("gfx/eyecandy/spawnsmoke3.bmp"), 128);
			_load_gfxa(spr_spawnsmoke[3], convertPath("gfx/eyecandy/spawnsmoke4.bmp"), 128);

			_load_gfxck(spr_spawndoor[0], convertPath("gfx/eyecandy/spawndoor1.bmp"));
			_load_gfxck(spr_spawndoor[1], convertPath("gfx/eyecandy/spawndoor2.bmp"));
			_load_gfxck(spr_spawndoor[2], convertPath("gfx/eyecandy/spawndoor3.bmp"));
			_load_gfxck(spr_spawndoor[3], convertPath("gfx/eyecandy/spawndoor4.bmp"));

			_load_gfxck(spr_bonus[0], convertPath("gfx/eyecandy/bonus1.bmp"));
			_load_gfxck(spr_bonus[1], convertPath("gfx/eyecandy/bonus2.bmp"));
			_load_gfxck(spr_bonus[2], convertPath("gfx/eyecandy/bonus3.bmp"));
			_load_gfxck(spr_bonus[3], convertPath("gfx/eyecandy/bonus4.bmp"));

			_load_gfxck(spr_brokenBlock[0], convertPath("gfx/eyecandy/brokenblock1.bmp"));
			_load_gfxck(spr_brokenBlock[1], convertPath("gfx/eyecandy/brokenblock2.bmp"));
			_load_gfxck(spr_brokenBlock[2], convertPath("gfx/eyecandy/brokenblock3.bmp"));
			_load_gfxck(spr_brokenBlock[3], convertPath("gfx/eyecandy/brokenblock4.bmp"));

			_load_gfxa(spr_award, convertPath("gfx/awards/killsinrow.bmp"), 128);
			_load_gfxck(spr_awardsolid, convertPath("gfx/awards/killsinrow.bmp"));
			_load_gfxck(spr_awardsouls, convertPath("gfx/awards/souls.bmp"));
			_load_gfxck(spr_awardsoulspawn, convertPath("gfx/awards/soulspawn.bmp"));

			_load_gfxck(spr_awardkillsinrow[0], convertPath("gfx/awards/killsinrownumbers1.bmp"));
			_load_gfxck(spr_awardkillsinrow[1], convertPath("gfx/awards/killsinrownumbers2.bmp"));
			_load_gfxck(spr_awardkillsinrow[2], convertPath("gfx/awards/killsinrownumbers3.bmp"));
			_load_gfxck(spr_awardkillsinrow[3], convertPath("gfx/awards/killsinrownumbers4.bmp"));

			_load_gfxa(spr_owned[0], convertPath("gfx/modeobjects/owned1.bmp"), 160);
			_load_gfxa(spr_owned[1], convertPath("gfx/modeobjects/owned2.bmp"), 160);
			_load_gfxa(spr_owned[2], convertPath("gfx/modeobjects/owned3.bmp"), 160);
			_load_gfxa(spr_owned[3], convertPath("gfx/modeobjects/owned4.bmp"), 160);

			_load_gfxck(spr_storedpowerupsmall, convertPath("gfx/powerups/small.bmp"));
			_load_gfxck(spr_storedpoweruplarge, convertPath("gfx/powerups/large.bmp"));
			_load_gfxck(spr_powerupselector, convertPath("gfx/awards/award.bmp"));
			
			_load_gfxck(spr_abovearrows, convertPath("gfx/eyecandy/abovearrows.bmp"));

		#ifdef _XBOX
			_load_gfxck(spr_keys[0], convertPath("gfx/buttons/xbox_abutton.bmp"));
			_load_gfxck(spr_keys[1], convertPath("gfx/buttons/xbox_xbutton.bmp"));
			_load_gfxck(spr_keys[2], convertPath("gfx/buttons/xbox_ybutton.bmp"));
			_load_gfxck(spr_keys[3], convertPath("gfx/buttons/xbox_dpadleftright.bmp"));
			_load_gfxck(spr_keys[4], convertPath("gfx/buttons/xbox_dpadupdown.bmp"));
		#else
			_load_gfxck(spr_keys[0], convertPath("gfx/buttons/keyboard_enter.bmp"));
			_load_gfxck(spr_keys[1], convertPath("gfx/buttons/keyboard_space.bmp"));
			_load_gfxck(spr_keys[2], convertPath("gfx/buttons/keyboard_ctrl.bmp"));
			_load_gfxck(spr_keys[3], convertPath("gfx/buttons/keyboard_leftright.bmp"));
			_load_gfxck(spr_keys[4], convertPath("gfx/buttons/keyboard_updown.bmp"));
		#endif
			
			_load_sfx(mip, convertPath("sfx/mip.wav"));
			_load_sfx(deathsound, convertPath("sfx/death.wav"));
			_load_sfx(jump, convertPath("sfx/jump.wav"));
			
			_load_sfx(invinciblemusic, convertPath("sfx/invincible.wav"));
			_load_sfx(extraguysound, convertPath("sfx/1up.wav"));
			_load_sfx(sprout, convertPath("sfx/sprout.wav"));
			_load_sfx(collectpowerup, convertPath("sfx/collectpowerup.wav"));
			_load_sfx(storepowerup, convertPath("sfx/storeitem.wav"));
			_load_sfx(breakblock, convertPath("sfx/breakblock.wav"));
			_load_sfx(bump, convertPath("sfx/bump.wav"));
			_load_sfx(coin, convertPath("sfx/coin.wav"));
			_load_sfx(fireball, convertPath("sfx/fireball.wav"));
			_load_sfx(springjump, convertPath("sfx/springjump.wav"));
			_load_sfx(timewarning, convertPath("sfx/timewarning.wav"));
			_load_sfx(hit, convertPath("sfx/hit.wav"));
			_load_sfx(chicken, convertPath("sfx/chicken.wav"));
			_load_sfx(transform, convertPath("sfx/transform.wav"));
			_load_sfx(yoshi, convertPath("sfx/yoshi.wav"));
			_load_sfx(pause, convertPath("sfx/pause.wav"));
			_load_sfx(bobombsound, convertPath("sfx/bob-omb.wav"));
			_load_sfx(areatag, convertPath("sfx/area_tag.wav"));
			_load_sfx(cannon, convertPath("sfx/cannon.wav"));
			_load_sfx(burnup, convertPath("sfx/burnup.wav"));
			_load_sfx(sfx_pipe, convertPath("sfx/warp.wav"));
			_load_sfx(thunder, convertPath("sfx/thunder.wav"));
			_load_sfx(slowdownmusic, convertPath("sfx/clock.wav"));
			_load_sfx(storedpowerupsound, convertPath("sfx/storedpowerup.wav"));
			_load_sfx(kicksound, convertPath("sfx/kick.wav"));
			_load_sfx(racesound, convertPath("sfx/race.wav"));
			_load_sfx(bulletbillsound, convertPath("sfx/bulletbill.wav"));

			_load_gfx(spr_backmap, convertPath("gfx/backgrounds/bg0.bmp"));
			_load_gfx(spr_frontmap, convertPath("gfx/backgrounds/bg0.bmp"));
			

			char tileSetTLS[128];
			strcpy(tileSetTLS, convertPath("maps/tileset.tls"));
			char tileSetBMP[128];
			strcpy(tileSetBMP, convertPath("gfx/tileset.bmp"));
			map.loadTileSet(tileSetTLS, tileSetBMP);

			map.loadMap(maplist.current_name());			//this must be called before initializing any players, because the player constructor needs a loaded map to see where the player can spawn

			char filename[128];
			sprintf(filename, "gfx/backgrounds/bg%d.bmp", map.backgroundID);
			_load_gfx(spr_background, convertPath(filename));

			map.predrawbackground(spr_background, spr_backmap);
			map.predrawforeground(spr_frontmap);
			loadInteractionMapObjects();

			ifsoundonplay(coin);
			state++;
		}


		//Sleep for time just under what we need
		int delay = WAITTIME - SDL_GetTicks() + framestart - 2;

		if(delay > 0)
		{
			if(delay > WAITTIME)
				delay = WAITTIME;
			
			SDL_Delay(delay);
		}

		//Fine tune wait here
		while(SDL_GetTicks() - framestart < WAITTIME)
			SDL_Delay(0);   //keep framerate constant at 1000/WAITTIME fps

	}
	
	return loadok;
}

bool loadmenuskin(int playerID, int skinID, int colorID)
{
	_load_gfxmenuskin(spr_player[playerID][PGFX_STANDING_R], skinlist.GetIndex(skinID)->name, colorID);
	return true;
}

bool loadfullskin(gfxSprite ** sprites, char * filename, int colorID)
{
	_load_gfxfullskin(sprites, filename, colorID);
	return true;
}

bool loadfullskin(gfxSprite ** sprites, int skinID, int colorID)
{
	return loadfullskin(sprites, skinlist.GetIndex(skinID)->name, colorID);
}

